#ifndef communicator_h
#define communicator_h

//Used to construct a message for sending
//or for getting information from a message
#include <string>
using namespace std;
#include <dtk.h>
#include "Messenger.h"
#include "MessageParser.h"
using namespace std;
class Message
{
	public:  
	Message();

	//Setting methods
	void SetTo(const string& To);
	void SetFrom(const string& From);
	void SetToClass(const string& Class);
	void SetMessage(const string& AMessage);
	void SetParamaters(const string& Params);
	void SetTime(const double& Time);

	//Getting methods
	string GetTo() ;
	string GetFrom() ;
	string GetToClass();
	string GetMessage();
	double GetTime();

	//Adding paramaters 
	void AddString(const string& Data);
	void AddInt(const int& Data);
	void AddDouble(const double& Data);
	void AddFloat(const float& Data);

	//Getting paramaters
	string GetString() ;
	int    GetInt() ;
	double GetDouble() ;
	float  GetFloat() ;

	//Used to clear the message and get the entire message
	void Clear();
	string GetEntireMessage() const ;

	private:
	void FixParamaters() ;
	void AddParamaters(string& A, const string& B);
	double	 Time;
	string   To;
	string   From;
	string   Class;
	string   TheMessage;
	string   Paramaters;
	istream* StringStream;
};

//Used to provide send / receive messages
class Communicator
{

	public:
	//Normal constructor / destructor with Name being which segment
	//to connect to.
	Communicator(const string& Name);
	//Is this a remote or local object?
	bool IsRemote() { return Remote;};
	//Set the remote computer this object is connected to 
	bool SetRemote(const string& RemoteName);
	bool DisconnectRemote();

	~Communicator();
	//Send a message to the world
	int SendMessage(Message& AMessage);
	//Get a message out of the system
	Message* GetMessage();

	private:
	//Used to send a message
	Messenger* Sender;
	//Used to get a message
	MessageParser* Getter;
	string RemoteName;
	string SegmentName;
	bool Remote;
};
#endif
