#include "Communicator.h"

Communicator::Communicator(const string& Name)
{
	Sender = new Messenger(Name);
	Getter = new MessageParser(Name);
	SegmentName = Name;
}

Communicator::~Communicator()
{
	if (Sender != NULL)
		delete Sender;

	if (Getter != NULL)
		delete Getter;
}

int Communicator::SendMessage(Message& AMessage)
{
	Sender->setTo(AMessage.GetTo());
	Sender->setFrom(AMessage.GetFrom());
	Sender->addString(AMessage.GetEntireMessage());
	Sender->addString("\n");
	Sender->SendMessage();
	return 0;
}

Message* Communicator::GetMessage()
{
	if (Getter->NextMessage() == -1)
		return NULL;
	Message* Temp = new Message;
	Temp->SetFrom(Getter->getFrom());
	Temp->SetTo(Getter->getTo());
	Temp->SetTime(atoi(Getter->getTime().c_str()));
	Temp->SetMessage(Getter->getMessage());
	//Temp->SetToClass(Getter->getString());
	string Test = Getter->getLine('\n');
	Temp->SetParamaters(Test);
	bool Debug = false;
	if (Debug)
	{
		printf("Params are %s\n", Test.c_str());
		printf("From : %s\n", Temp->GetFrom().c_str());
		printf("To   : %s\n", Temp->GetTo().c_str());
		printf("Time : %lf\n", Temp->GetTime());
	}
	return Temp;
}

bool Communicator::SetRemote(const string& RemoteName)
{
	return !(Sender->connectRemoteSharedMem(SegmentName , string(RemoteName)));
}
