#include <dtk.h>
#include <string>
using namespace std;
#include "Communicator.h"

Message::Message()
{
	Time = -1;
	To = "";
	From = "";
	Class = "";
	TheMessage = "";
	Paramaters = "";
	StringStream = NULL;
}
void Message::SetTime(const double& Time)
{
	this->Time = Time;
}

double Message::GetTime() 
{
	return Time;
}
void Message::SetTo(const string& To)
{
	this->To = To;
}


void Message::SetFrom(const string& From)
{
	this->From = From;
}

void Message::SetToClass(const string& Class)
{
	this->Class = Class;
}

void Message::SetMessage(const string& AMessage)
{
	this->TheMessage = AMessage;
}

string Message::GetTo() 
{
	FixParamaters();
	return To;
}

string Message::GetFrom() 
{
	FixParamaters();
	return From;
}

string Message::GetToClass() 
{
	FixParamaters();
	return Class;
}

string Message::GetMessage() 
{
	FixParamaters();
	return TheMessage;
}

void Message::AddString(const string& Data)
{
	AddParamaters(Paramaters, Data);
}

void Message::AddInt(const int& Data)
{
	char* Temp = new char[100];
	sprintf(Temp, "%d", Data);
	AddParamaters(Paramaters, Temp);
	delete Temp;
}

void Message::AddDouble(const double& Data)
{
	char* Temp = new char[100];
	sprintf(Temp, "%lf", Data);
	AddParamaters(Paramaters, Temp);
	delete Temp;
}

void Message::AddFloat(const float& Data)
{
	char* Temp = new char[100];
	sprintf(Temp, "%f", Data);
	AddParamaters(Paramaters, Temp);
	delete Temp;
}

string Message::GetString()
{
	if (StringStream == NULL)
	{
		printf("Null I am \n");
		StringStream = new istringstream(Paramaters);
	}
	string temp1 , temp2;
	(*StringStream) >> temp1;	
	getline((*StringStream), temp2, '\t');
	return temp1+temp2;	
}
int Message::GetInt()
{
	int Temp = -1;
	if (StringStream == NULL)
	{
		StringStream = new istringstream(Paramaters);
	}
	(*StringStream) >> Temp;
	return Temp;
}
double Message::GetDouble()
{
	double Temp = -1.0;
	if (StringStream != NULL)
	{
		StringStream = new istringstream(Paramaters);
	}
	(*StringStream) >> Temp;
	return Temp;
}
float Message::GetFloat()
{
	float Temp = -1.0;
	if (StringStream == NULL)
	{
		StringStream = new istringstream(Paramaters);
	}
	(*StringStream) >> Temp;
	return Temp;
}

void Message::FixParamaters() 
{
	if (To == "" || To == " " || To == "\t")
		To = "None";
	if (From == "" || From  == " " || From == "\t")
		From = "None";
	if (Class == "" || Class == " " || Class == "\t")
		Class  = "None";
	if (TheMessage == "" || TheMessage == " " || TheMessage == "\t")
		TheMessage = "None";
}

void Message::Clear()
{
	To = "";
	From = "";
	Class = "";
	TheMessage = "";
	Paramaters = "";
	if (StringStream != NULL)
		delete StringStream;
	StringStream = NULL;
}

string Message::GetEntireMessage() const
{
	//printf("Packing message with %s %s and %s \n", Class.c_str(), TheMessage.c_str(), Paramaters.c_str());
	return string(Class + "\t" + TheMessage + "\t" + Paramaters) ;
}

void Message::SetParamaters(const string& Line)
{
	//printf("Constructing a message with %s\n", Line.c_str());
	StringStream = new istringstream(Line);
	(*StringStream) >> TheMessage;
	(*StringStream) >> Class;
}

void Message::AddParamaters(string& A, const string& B)
{
	if (A != "")
		A = A + "\t" + B;
	else
		A = B;
}
