#include <dtk.h>
#include "Messenger.h"
Messenger::Messenger(string ShmName)
{
  ClientManager = NULL;
  
  //If user passed a string to the constructor it has presedence.
  if(ShmName.length() == 0){
    char* charShmName = getenv("DTK_COMMAND_SHM_NAME");
    if(charShmName == NULL) ShmName = "CommandMessage";
    else ShmName = charShmName;
    //If the length is still 0 then it's default
    if(ShmName.length() == 0) ShmName = "CommandMessage";
  }
    
  
  Send = new dtkSharedMem (SHM_SIZE, ShmName.c_str());
  if(!Send || Send->isInvalid() || Send->getSize() < SHM_SIZE){
    cout<<"could not get shared mem for Messenger"<<endl;
  }

  Timer.delta();
  Time = "";
 
  // End Message Stuff 
}

Messenger::~Messenger()
{
  delete Send;
  if(ClientManager) delete ClientManager;
}

int Messenger::connectRemoteSharedMem(const string& Name, const string& host)
{
  if(ClientManager == NULL) ClientManager = new dtkClient;

  if(ClientManager->connectRemoteSharedMem(Name.c_str() , host.c_str()) == -1)
    return -1;
  else
    return 0;
}

int Messenger::addInt(int add)
{
  char temp[100];
  sprintf(temp,"%d",add);
  parameters += "\t";
  parameters += temp;  
  return 0;
}
int Messenger::addDouble(double add)
{
  char temp[100];
  sprintf(temp,"%lf",add);
  parameters += "\t";
  parameters += temp;
  return 0;
}

int Messenger::addString(string add)
{
  parameters += "\t" + add;
  return 0;
}

int Messenger::addChar(char add)
{
  parameters += '\t' + add;
  return 0;
}

string Messenger::getTime()
{
  //The tm struct;
/*
   typedef struct {
   int tm_hour;    hour (0 - 23) 
   int tm_isdst;   daylight saving time enabled/disabled 
   int tm_mday;    day of month (1 - 31) 
   int tm_min;     minutes (0 - 59) 
   int tm_mon;     month (0 - 11 : 0 = January) 
   int tm_sec;     seconds (0 - 59) 
   int tm_wday;    Day of week (0 - 6 : 0 = Sunday) 
   int tm_yday;    Day of year (0 - 365) 
   int tm_year;    Year less 1900 
   }
*/
  /*
  time_t rawtime;
  time(&rawtime);
  tm* currtime = localtime(&rawtime);
  char teatime[10];
  sprintf(teatime,"%d:%d:%d",currtime->tm_hour,currtime->tm_min,currtime->tm_sec);
  
  */

  long double currTime = Timer.get();
  char teatime[100];
  sprintf(teatime,"%LG10",currTime);
  return teatime;
}

int Messenger::SendMessage()
{
  string pass = from + "\t";
  pass += to + "\t";
  if(Time == "") Time = getTime();
  pass += Time + "\t";
  pass += message;
  if(parameters != ""){
    pass += parameters;
  }
  else
    pass += '\t';

  cout<<"trying to send message: \""<<pass.c_str()<<"\""<<endl;
//  cout<<"trying to send message: "<<"'"<<from.c_str()
//    <<"'\t'"<<to.c_str()<<"'\t'"<<Time.c_str()<<"'\t'"<<message.c_str()
//    <<"'\t'"<<parameters.c_str()<<"'"<<endl;

  parameters = ""; //reset the parameters to nothing.

  pass += "\0"; //To terminate the string.

  Time = ""; //reset the time to blank string.

  return Send->write(pass.c_str(),(pass.length()+1)*sizeof(char));
}

