// This is the client to connect to the dedicated server

#ifndef DCLIENT_H
#define DCLIENT_H

#include <dpf.h>
#include <string>
#include <vector>
#include "Messenger.h"
#include "MessageParser.h"
#include "duser.h"

using namespace std;

class dclient : public dtkAugment
{
  public:
    dclient(dpf *app);
    ~dclient(void);

    int preConfig(void);
    int postConfig(void);
    int postFrame(void);

    vector<duser*> getUsers();

    int setMapGroup(pfGroup* pmap) {mapSCS = pmap; return 0;}

  private:

    dpf* app;
    dtkSharedMem* positionShm;
    dtkClient* ClientManager;
    char* host;
    dtkTime Timer;
//    long double lastFrameTime;
//    long double lastPingTime;
    MessageParser* parser;
    Messenger* messenger;

    vector<duser*> users;
    string compName;

    int CheckMessages();
    int SearchUsers(string user);
    int addNewUser(string newguy,string avatar);
    int disconnect(string user);
    
    pfCoord coord;
    //The coordinate where the user was before shared view became active
    pfCoord oldLocation;
    pfGroup* mapSCS;
    bool Tethered;
    bool SharedView;
    bool Highlight;
    dtkTime* Time;
    double ElapsedTime;
    string PersonToHighlight;
    string TetheredTo;
    string SharedPerson;


};

#endif
