// generated by Fast Light User Interface Designer (fluid) version 1.0011
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "chatDso.h"
#include "chatDso-Menu.h"

#include <FL/Fl_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Browser.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Multi_Browser.H>
#include <FL/Fl_Scrollbar.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Group.H>
#include <FL/fl_ask.H>

Fl_Input *Send=(Fl_Input *)0;			    // widget where user types message
Fl_Tabs *curConvWin=(Fl_Tabs *)0;		    // the tabs of current open conversations
Fl_Browser *Conversation=(Fl_Browser *)0;	    // might not be needed
Fl_Multi_Browser *curUserList=(Fl_Multi_Browser*)0; // lists the current logged in computers
Fl_Multi_Browser *curConvList=(Fl_Multi_Browser*)0; // lists the current conversations and who
						    // is in which group
static char user[SIZE];

/*********************************
 *	  Class Methods
 ********************************/
chatDso::chatDso(dpf* app_in):
  dtkAugment("chatDso"){
  app = app_in;
  client = NULL;
  messenger = NULL;
  parser = NULL;
  guiWin = NULL;
  validate();
}

chatDso::~chatDso() {
  if(guiWin) {
    delete guiWin;
    guiWin = NULL;
  }

  if(client) {
    delete client;
    client = NULL;
  }

  if(messenger) {
    delete messenger;
    messenger = NULL;
  }

  if(parser) {
    delete parser;
    parser = NULL;
  }
}

int chatDso::postConfig() {
  
  // connects to the server 
  if(!connectToClient()){
    printf("E:ERROR: Unable to connect to client\n");
    return DTK_CALLBACK_ERROR;
  }
 
  // creates object that sends messages to sharedMem segment
  // called genMessage
  messenger = new Messenger("genMessage");
  if(!messenger) {
    printf("E:ERROR: Unable to create Messenger object.\n");
    return DTK_CALLBACK_ERROR;
  }
  
  // creates object that parses the messages from the sharedMem
  // segment called genMessage
  parser = new MessageParser("genMessage");
  if(!parser) {
    printf("E:ERROR: Unable to create MessageParser object.\n");
    return DTK_CALLBACK_ERROR;
  }

  // creates the gui
  make_window(this);
  if(!guiWin){
    printf("E:ERROR: Unable to create gui\n");
    return DTK_CALLBACK_ERROR;
  }

  // makes the list of Users
  makeList();

  return DTK_REMOVE_CALLBACK; 
}

// checks each frame for new information
int chatDso::postFrame() {
  check();
  Fl::check();
  return DTK_CONTINUE;
}

// check to see of there is something to display
bool chatDso::check() {
	
  unsigned int c = 0;
  char buf[SIZE];
  char added[SIZE];

  // refresh the list of users
  makeList();
 
  // get messages from the server 
  string message;
  
  // if last message was from me then skip rest of function
  if(parser->getMessage(message,user)){// && (message == "BOGUS")) {
    printf("E:The message was from me or it was not important.\n");
    return false;
  }

  printf("E:check Message = %s\n", message.c_str());
  
  string forMe = parser->getString();

  // check to see if message is for me
  if(strcmp(forMe.c_str(), "everyone") == 0) {	      /*** should make loop to check through group list ***/
   
    printf("E: to everyone and not from me :)\n"); 
    parser->getDouble();
    string tmp = parser->getString();

    // for someone to chat
    if(strcmp(tmp.c_str(), "toChat") == 0){
    
      sprintf(buf, "%s",parser->getLine().c_str());
      printf("E:chat = %s\n", buf);
      for(;c < strlen(buf);c++)
	if(buf[c] == ':') break; 
    
      sprintf(added,"@C4@b%s\n", buf);
      Conversation->add(added);
/*////      
      Fl_Group* tmp = (Fl_Group*) curConvWin->value();
      if(tmp){
	((Fl_Browser*) tmp->child(0))->add(buf);
	//printf("label = %s\n", tmp->label());
      }
*/      
    
    // if someone disconnects
    } else if(strcmp(tmp.c_str(), "disconnect") == 0) {
      printf("E:disconnects\n");
      
      string droppedUser = parser->getString();
      int index = userIndex(droppedUser);
      sprintf(buf,"@C1@i%s has left us, let us have a " \
		   "moment of silence.\n",droppedUser.c_str());
      allUsers[index].active = false;    
      
    } else printf("E:Unrecognized message = %s\n", message.c_str());
  } else printf("E:Unrecognized message = %s\n", message.c_str());
    
  return true;
}

int chatDso::userIndex(string name) {
  unsigned int i;
  for (i = 0; i < allUsers.size(); i++) {
    if(allUsers[i].userName == name){
      return i;
    }
  }

  return -1;
}

// connects to shared mem
bool chatDso::connectToClient() {
  
  char buf[SIZE];
  gethostname(buf, SIZE);
  myName = buf;
  sprintf(user,"%s",buf);
  printf("E:user = %s\n", user);
  
  client = (dclient*) app->check("dclient");
  if(!client) {
    printf("E:Could not get client\n");
    return false;    
  }

  printf("E:apparently connected\n");

  return true;    
}

// loads the list of logged in users into the gui
void chatDso::makeList() {

  if(!(dclient*) app->check("dclient")) return;

  vector<duser*> newUsers;
  static unsigned int lastCount = 0;
  client = (dclient*) app->check("dclient");
  
  newUsers = client->getUsers();
/////
  if(newUsers.size() != lastCount) {
    printf("E:different size\n");
  

  // checks to see if there are new users to add to the list
  unsigned int i;
  int index;
  
  // clear current list
  curUserList->clear();
  
  /*// set all the users to be inactive  
  for (i = 0; i < allUsers.size(); i++)
    allUsers[i].active = false;
  */

  // look throught a refreshed list of users and check
  // to see who has been added or dropped
  for (i = 0; i < newUsers.size(); i++) {
    userData data;
    data.userName = newUsers[i]->getName();
    data.active = true;
      
    index = userIndex(data.userName); 
    if(index >= 0) allUsers[i].active = true;
    else {
      allUsers.push_back(data);
      char buf[SIZE];
      sprintf(buf,"@C1@i%s just joined our little party.\n", data.userName.c_str());
      Conversation->add(buf);
/*///      
      Fl_Group* tmp = (Fl_Group*) curConvWin->value();
      if(tmp){
	((Fl_Browser*) tmp->child(0))->add(buf);
	//printf("label = %s\n", tmp->label());
      }
*////
    }
  }

  // change to text to show who is connected or not 
  for (i = 0; i < allUsers.size(); i++) {
    char buf[SIZE];      
    if(allUsers[i].active) {
      sprintf(buf,"@C4@b@.%s\n", allUsers[i].userName.c_str());
    }else {
      sprintf(buf,"@C2@b%s\n", allUsers[i].userName.c_str());
    }
    curUserList->add(buf);
    curUserList->data(i,(void*)allUsers[i].userName.c_str());
  }
/////  
  }
  
  lastCount = newUsers.size();
}

/*********************************
 *	    Callbacks
 ********************************/

// sends the message out to the server to be sent to the appropriate group
static void sendMessage_callback(Fl_Widget*, Messenger* messenger) {
  char message[SIZE];
  // <myName>: <myMessage>
  sprintf(message,"%s: %s\n", user,Send->value());

 // if(message && strcmp(message,"") != 0) {
  if(Send->value() && strcmp(Send->value(),"") != 0) {
    
    if(strlen(message) < SIZE){
    char buff[SIZE];
      
      // <fromMe>\t<toUser>\t<timeStamp>\t<toChat>\t<myMessage>
      sprintf(buff, "%s\t%s\t0.0\ttoChat\t%s\n", user,curConvWin->value()->label(),message);
     
      Fl_Group* tmp = (Fl_Group*) curConvWin->value();
      if(tmp){
	((Fl_Browser*) tmp->child(0))->add(message);
	printf("label = %s\n", tmp->label());
      }
      
      messenger->SendMessage(buff);
      printf("E:send message = %s\n", buff);
      
    } else {
      //Conversation->add("@C1@b@iError: Message too big, try again\n");
////
      Fl_Group* tmp = (Fl_Group*) curConvWin->value();
      if(tmp){
	((Fl_Browser*) tmp->child(0))->add("@C1@b@iError: Message too big, try again.\n");
	//printf("label = %s\n", tmp->label());
      }
////      
    }

    Send->value("");
  }
}

static void rightClick_callback(Fl_Menu_Button* mb, void*) {
  int userIndex = curUserList->value();
  int convIndex = curConvList->value();

  printf("E:curConvIndex = %i, data = %s\n", convIndex, (char*) curConvList->data(convIndex));
  printf("E:curUserIndex = %i, data = %s\n", userIndex, (char*) curUserList->data(userIndex));

  curConvList->deselect();
  curUserList->deselect();
}

/***********************************
 *	    Menu Callbacks
 **********************************/

// add selected user to a new group chat
void addUserToNewGroup_callback(Fl_Widget*, void*) {
  int userIndex = curUserList->value();

  if(userIndex > 0) {
    char * convName = (char*) fl_input("Add %s to group:\n",NULL,curUserList->text(userIndex));
    if(convName) {
      curConvList->add(convName);
      curConvList->data(curConvList->size(),(void*)strdup(convName));
      char userName[SIZE];
      sprintf(userName, "@C4@b@i@.%s",convName);
      printf("E:userName =%s\n", userName);
      
    } else printf("E:Canceled\n");

    convName = NULL;      
  } 
}

void addUserToGroup_callback(Fl_Widget*, void*) {

  int userIndex = curUserList->value(),
      convIndex = curConvList->value(),
      i;
  char name[SIZE],
       *tmp = NULL;
  

  if(userIndex > 0 && convIndex > 0) {
    
//    tmp = strdup(curUserList->text(userIndex));
    tmp = (char*) curUserList->data(userIndex);

    printf("E:addUserToGroup_cb tmp = %s\n", tmp);

    sprintf(name,"@C4@b@i@.\ti%s",tmp);
//    for(i = 0;tmp[i] != '.';i++);
//    sprintf(name, "%s%s",name,&tmp[i+1]);
    printf("E:addUserToGroup name = %s\n", name);
    curConvList->insert(convIndex+1,name);
    
/*// adds user to a group and changes the font to show that it is a group
    /////delete tmp;
    tmp = NULL;
    tmp = strdup(curConvList->text(convIndex));
    for(i = 0; tmp[i] != '.';i++);
    sprintf(name, "@C1@b@.%s",&tmp[i+1]);
    printf("name = %s\n", name); 
    curConvList->text(convIndex,name);
*///
  } else if(userIndex > 0){
    tmp = (char*) fl_input("Add %s to group:\n",NULL,curUserList->text(userIndex));
    if(tmp) {
      printf("tmp = %s\n", tmp);
      /*for (i = curConvList->children(); i > 0; i--) {
	if(strcmp(tmp, curConvList->text(i)) == 0){
	  sprintf(name,"@b@i.\t%s",tmp);
	  break;
	}
      }*/
    }
  }
  
  tmp = NULL;
}

// adds a new conversation to the curConversation list
void addConv_callback(Fl_Widget*, void*) {
  static bool colorFlag = false;
  char *convName = NULL;
/*//
  int userIndex = curUserList->value();
  if(userIndex > 0){
    char* tmp = strdup(curUserList->text(userIndex));
    printf("E:addConv_cb tmp = %s\n", tmp);
    convName = new char[SIZE];
    sprintf(convName, "@C4@b@i@.%s",tmp);
    curConvList->add(convName);
    return;
  }
*///  
  char *tmp = (char*) fl_input("Enter the name of the new chat session:  ");

  if(tmp) {

    convName = new char[SIZE];
    sprintf(convName, "@C4@b@i@.%s", tmp);
    printf("E:addConv_cb tmp = %s\n", tmp);
    curConvList->add(convName);
    int index = curConvList->size();
    curConvList->data(index,(void*)strdup(tmp));

    printf("E:addConv_cb data at index %i = %s\n", index, (char*) curConvList->data(index));
    { Fl_Group *o = new Fl_Group(10, 25, 350, 190, strdup(tmp));
      o->box(FL_FLAT_BOX);
      o->labeltype(FL_ENGRAVED_LABEL);
      o->labelcolor(4);	  // blue font
      o->labelfont(2);	  // italic font
      if(colorFlag) o->color(44);
      colorFlag = !colorFlag;
      o->hide();
      { Fl_Browser* o = new Fl_Browser(15, 30, 340, 180);
        o->type(FL_MULTI_BROWSER);
        o->align(FL_ALIGN_TOP_LEFT);
      }
      o->end();
      curConvWin->add(o);
      curConvWin->redraw();
    }
  } else printf("E:Cancled\n");

  convName = NULL;
}

// remove all current conversations
void removeAllConv_callback(Fl_Widget*, void*) { 
	
  if(curConvList->children() > 1){ 
    curConvList->clear();
    for (int i = curConvWin->children(); i > 0; i--){	    
      curConvWin->remove(curConvWin->child(i));
    }
  
    curConvList->add("@beveryone");
    //printf("before data\n");
    curConvList->data(1,(void*)"Everyone");
    //printf("after data\n");
    curConvList->deselect();
    curConvWin->redraw();
  }
}

// removes a selected conversation
void removeSelectedConv_callback(Fl_Widget*, void*) {
	
  for (int i = curConvList->size(); i > 1; i--)
    if(i > 0 && !curConvList->select(i)) {
      curConvList->remove(i);
      curConvWin->remove(curConvWin->child(i-1));
    }

  curConvWin->redraw();
}

// when selecting a conversations from list it brings up that
// main chat window
static void selectCurConv_callback (Fl_Multi_Browser* multiBrowser,void *) {
  int index = multiBrowser->value();
  if(index > 0)
    curConvWin->value(curConvWin->child(index-1));
}

// hides the window
static void hide_callback(Fl_Button *, Fl_Window* guiWin) { guiWin->iconize(); }

// creates the chat gui
void make_window(chatDso* data) {

  { Fl_Window* o = new Fl_Window(520, 355, data->myName.c_str());
    data->guiWin = o;
    { Fl_Tabs * o = curConvWin = new Fl_Tabs(10, 5, 350, 190);
      { Fl_Group *o = new Fl_Group(10, 25, 350, 190,"everyone");
	o->box(FL_FLAT_BOX);
	o->labeltype(FL_ENGRAVED_LABEL);
	o->color(44);
	o->hide();
	{ Fl_Browser* o = Conversation = 
    	    new Fl_Browser(15, 30, 340, 180);
	  o->type(FL_MULTI_BROWSER);
	  o->align(FL_ALIGN_TOP_LEFT);
	}
	o->end();
      }
      o->end();
    }
    { Fl_Input* o = Send = new Fl_Input(10, 235, 350, 85, "Send Message:");
      o->type(4);
      o->labeltype(FL_ENGRAVED_LABEL);
      o->align(FL_ALIGN_TOP_LEFT);
      o->maximum_size(SIZE);
      o->callback((Fl_Callback*)sendMessage_callback,(void*)data->messenger);
      o->when(FL_WHEN_ENTER_KEY);
    }
    { Fl_Multi_Browser *o = curUserList = new Fl_Multi_Browser(365, 25, 145, 90,"Who is Logged In:");	// 365, 25, 145, 190
      o->labeltype(FL_ENGRAVED_LABEL);
      o->align(FL_ALIGN_TOP_LEFT);
    } 
    { Fl_Multi_Browser *o = curConvList = 
	    new Fl_Multi_Browser(365, 135, 145, 185, "Talking To:"); // 365,235, 145, 85
      o->labeltype(FL_ENGRAVED_LABEL);
      o->align(FL_ALIGN_TOP_LEFT);
      o->add("@beveryone");
      o->data(1,(void*)"everyone");
      o->callback((Fl_Callback*)selectCurConv_callback);
    }
    { Fl_Button* o = new Fl_Button(320, 325, 90, 25, "Send"); 
      o->labeltype(FL_ENGRAVED_LABEL);
      o->callback((Fl_Callback*)sendMessage_callback, (void*)data->messenger);
    }
    { Fl_Button* o = new Fl_Button(420, 325, 90, 25, "Hide");
      o->labeltype(FL_ENGRAVED_LABEL);
      o->callback((Fl_Callback *)hide_callback,(void*)data->guiWin);
    }
    
    /* right click menus */
    
    // for the users logged in
    { Fl_Menu_Button *o = new Fl_Menu_Button(365, 135, 145, 185);    // 365, 235, 145, 85
      o->type(Fl_Menu_Button::POPUP3);
      o->menu(curConvRightClick);
      o->callback((Fl_Callback*)rightClick_callback);
    }
    // for the current conversations
    { Fl_Menu_Button *o = new Fl_Menu_Button(365, 25, 145, 90);    // 365, 25, 145, 190
      o->type(Fl_Menu_Button::POPUP3);
      o->menu(curUserRightClick);
      o->callback((Fl_Callback*)rightClick_callback);
    }
    o->end();
  }
  data->guiWin->show();
}

/*************** DTK C++ DSO loader/unloader functions ***********/
/*
 * All DTK DSO files are required to declare these two functions.
 * These function are called by the loading program to get your
 * C++ objects loaded.
 *
 *****************************************************************/

static dtkAugment *dtkDSO_loader(dtkManager *manager, void *p)
{
  dpf *app = static_cast<dpf *>(manager);
  return new chatDso(app);
}

static int dtkDSO_unloader(dtkAugment *augment)
{
  delete augment;
  return DTKDSO_UNLOAD_CONTINUE;
}

