#include <vector>
#include <string>

using namespace std;

#include <dtk.h>
#include "Communicator.h"
#include "Rule.h"

ForwardRule::ForwardRule()
{
	Container = NULL;
	Sender = NULL;
}

ForwardRule::ForwardRule(ForwardContainer* Forward)
{
	if (Forward == NULL)
		printf("Null container problem when adding a forward rule, should break application\n");
	printf("%s %s %s\n", Forward->AMessage.c_str(), Forward->Segment.c_str(), Forward->Destination.c_str());
	Container = Forward;
	AddMessage(Forward->AMessage);
	Sender = new Communicator(Forward->Segment);
	Sender->SetRemote(Container->Destination);
}

ForwardRule::~ForwardRule()
{
	if (Container == NULL)
		return;
	delete Sender;

}

bool ForwardRule::AddForward(ForwardContainer* Forward)
{
	if (Forward == NULL)
		return false;
	Container = Forward;
	Sender = new Communicator(Forward->Segment);
	return Sender->SetRemote(Container->Destination);
}

bool ForwardRule::RemoveForward()
{
	if (Container == NULL)
		return false;
	delete Container;
	delete Sender;
	return true;
}

ForwardContainer* ForwardRule::GetForward()
{
	return Container;
}

bool ForwardRule::DoForward(Message& AMessage)
{
	if (Container == NULL)
		return false;
	AMessage.SetTo(Container->Destination);
	return !Sender->SendMessage(AMessage);
}
