#include <string>
#include <vector>

using namespace std;

#include "Communicator.h"
#include "MultiCast.h"
#include "Item.h"

ItemServer::ItemServer(const string& Name) 
{
	 CLine = new Communicator(Name);
	 /*
	 Item Temp;
	 Temp.Name = "glyph.sv.vt.edu";
	 Temp.URL = "http:://look.at.me";
	 Temp.Description = "My wonderful world actually works";
	 Temp.Control = false;
	 Objects.push_back(Temp);
	 */
	 char buff[64];
	 unsigned int size = 64;
	 gethostname(buff,size);
	 //HostName = string(buff);
	 BaseURL=string(buff) + "/ItemFiles/";
	 //For the remote connection fun
	 //RemoteConnector = new dtkClient;
}

ItemServer::~ItemServer()
{

}

void ItemServer::Register(const string& Computer, const string& Segment)
{
	printf("Registering computer %s with segment %s\n", Computer.c_str(), Segment.c_str());
	/*
	//Add in the user to the person list
	Person Temp;
	Temp.Computer = Computer;
	Temp.Segment  = Segment;
	People.push_back(Temp);
	//Create / Connect to the remote computers position segment
	string Name = Computer+"-ITEM_POSITION";
	dtkSharedMem* Test = new dtkSharedMem(sizeof(float)*6, Name.c_str());
	if(!Test || Test->isInvalid() || Test->getSize() < 6*sizeof(float))
	{
		printf("Could not get shared mem for%s\n ",  Name.c_str());
	}
	//If I am not running on the client machine connect to the client machine
	if (Computer != HostName)
		RemoteConnector->ConnectRemoteSharedMem(Name.c_str(), Computer.c_str());

	//Add the shared memory segment to our internal list
	Positions.push_back(Test);
	*/

	//Add the person to the multicast segment
	MCast.AddPerson(Computer, Segment);
	printf("Person added\n");
}

void ItemServer::UnRegister(const string& Computer, const string& Segment)
{
	printf("UnRegistering computer %s with segment %s\n", Computer.c_str(), Segment.c_str());
	MCast.RemovePerson(Computer, Segment);
	/*
	//Go through and find the person to remove
	for (unsigned int i=0; i< People.size(); i++)
	{
		if (People[i].Computer == Computer)
		{
			delete Positions[i];
			Positions.erase(Positions.begin()+i);
			People.erase(People.begin() + i);
		}
	}
	*/
}

void ItemServer::Serve()
{
	Message* Info;
	while (1)
	{
		Info = CLine->GetMessage();
		if (Info !=NULL && Info->GetTo() != "ITEM_SERVER")
			printf("Message not for the item server is for %s\n", Info->GetTo().c_str());
		if (Info !=NULL && Info->GetTo() == "ITEM_SERVER")
		{
			if (Info->GetMessage() == "ASSOCIATE_ITEM")
			{
				MCast.SendMessage(*Info);
			}
			if (Info->GetMessage() == "ADD_USER")
			{
				string Computer = Info->GetString();
				string Segment = Info->GetString();
				Register(Computer, Segment);
			}
			if (Info->GetMessage() == "REMOVE_USER")
			{
				string Computer = Info->GetString();
				string Segment = Info->GetString();
				MCast.RemovePerson(Computer,Segment);
			}
			if (Info->GetMessage() == "ADD_ITEM")
			{
				string App = Info->GetString();
				string URL = Info->GetString();
				AddItem(App, URL);
			}
			if (Info->GetMessage() == "REMOVE_ITEM")
			{
				RemoveItem(Info->GetString());
			}
			if (Info->GetMessage() == "GUI_LIST_ITEMS")
			{
				ListObjects(Info->GetFrom(), "GUI_LOAD_ITEMS");	
			}
			if (Info->GetMessage() == "DSO_LIST_ITEMS")
			{
				ListObjects(Info->GetFrom(), "DSO_LOAD_ITEMS");	
				SendPosition(Info->GetFrom());
			}
			if (Info->GetMessage() == "REQUEST_ITEM_CONTROL")
			{
				RequestControl(Info->GetFrom(), Info->GetString());
			}
			if (Info->GetMessage() == "RELEASE_ITEM_CONTROL")
			{
				ReleaseControl(Info->GetString());
			}
			if (Info->GetMessage() == "GET_URL")
			{
				GetURL(Info->GetFrom(), Info->GetString());

			}
			if (Info->GetMessage() == "ADD_INFO")
			{
				printf("Told to set information\n");
				string Object = Info->GetString();
				string TheInfo = Info->GetString();
				SetInfo(Object, TheInfo);
			}
			if (Info->GetMessage() == "GET_INFO")
			{
				printf("Got the request for information\n");
				GetInfo(Info->GetFrom(), Info->GetString());
			}

			if (Info->GetMessage() == "MOVE_ITEM")
			{
				Info->SetFrom("ITEM_SERVER");
				Message Hrm;
				Hrm.SetFrom("ITEM_SERVER");
				Hrm.SetTo("Everyone");
				Hrm.SetMessage("MOVE_ITEM");
				Hrm.AddString(Info->GetString());
				Hrm.AddFloat(Info->GetFloat());
				Hrm.AddFloat(Info->GetFloat());
				Hrm.AddFloat(Info->GetFloat());
				MCast.SendMessage(Hrm);
			}
			if (Info->GetMessage() == "ASSOCIATE")
			{
				//MCast.SendMessage(*Info);
				string A = Info->GetString();
				string B = Info->GetString();
				printf("Associate on server is %s %s \n", A.c_str(), B.c_str());
				Associate(A,B);
				Message WTF;
				WTF.SetMessage("ASSOCIATE");
				WTF.AddString(A);
				WTF.AddString(B);
				MCast.SendMessage(WTF);
			}
			if (Info->GetMessage() == "DISASSOCIATE")
			{
				string A = Info->GetString();
				DisAssociate(A);
				Message WTF;
				WTF.SetMessage("DISASSOCIATE");
				WTF.AddString(A);
				MCast.SendMessage(WTF);
			}
			if(Info->GetMessage() == "REPLICATE")
			{
				Replicate(Info->GetString());	
			}
			if (Info->GetMessage() == "NEEDFILE")
			{
				SendURL(Info->GetFrom(), Info->GetString());
			}
			if(Info->GetMessage() == "UPDATE_URL")
			{
				string Object = Info->GetString();
				string URL    = Info->GetString();
				UpdateURL(Object, URL);
			}
			if (Info->GetMessage() == "UPDATE_KNOWN_POSITION")
			{
				string Object = Info->GetString();
				float Temp[6];
				for (int i=0; i<5; i++)
					Temp[i] = Info->GetFloat();
				UpdatePosition(Object, Temp);
			}
			//Cleanup object
			delete Info;
		}
		usleep(100000);
	}
}

void ItemServer::UpdatePosition(const string& Object, float* Position)
{
	for (unsigned int i=0; i< Objects.size(); i++)
	{
		if (Objects[i].Name == Object)
		{
			for (int j=0; j< 6; j++)
			{
				Objects[i].LastKnownPosition[j] = Position[j];
			}
		}
		for (unsigned int j=0; j< Objects[i].Children.size(); j++)
		{
			if (Objects[i].Children[j].Name == Object)
			{
				for (int k=0; k< 6; j++)
				{
					Objects[i].Children[j].LastKnownPosition[k] = Position[k];
				}
			}
		}
	}
}
void ItemServer::Replicate(const string& Object)
{
	Item Temp;
	bool Done = false;
	for (unsigned int i=0; i<Objects.size(); i++)
	{
		if (Objects[i].Name == Object && !Done)
		{
			Temp.Name = Objects[i].Name;
			Temp.URL  = Objects[i].URL;
			Temp.Description = Objects[i].Description;
			Temp.Control = false;
			Done = true;

		}
		for (unsigned int j=0; j< Objects[i].Children.size(); j++)
		{
			if (Objects[i].Children[j].Name == Object && !Done)
			{
				Temp.Name = Objects[i].Children[j].Name;
				Temp.URL  = Objects[i].Children[j].URL;
				Temp.Description = Objects[i].Children[j].Description;
				Temp.Control = false;
				Done = true;
			}
		}
	}
	if (!Done)
		return;
	//Find the number objects that are in the system
	int Num = 0;
	for (unsigned int i=0; i < Objects.size(); i++)
	{
		if (Objects[i].Name == Object)
			Num++;
		for (unsigned int j=0; j < Objects[i].Children.size(); j++)
		{
			if (Objects[i].Children[j].Name == Object)
				Num++;
		}
	}
	//Turn int into string
	char* Name = new char[10];
	sprintf(Name , "%d", Num);
	//Add to main list
	Objects.push_back(Temp);

	//Send result to server
	Message Rep;
	Rep.SetTo("Everyone");
	Rep.SetFrom("ItemServer");
	Rep.SetMessage("REPLICATE");
	Rep.AddString(Temp.Name);
	Rep.AddString(Name);
	MCast.SendMessage(Rep);
}
void ItemServer::SetInfo(const string& Object, const string& Info)
{
	printf("Setting information %s %s \n", Object.c_str(), Info.c_str());
	for (unsigned int i=0; i<Objects.size(); i++)
	{
		if (Objects[i].Name  == Object)
		{
			Objects[i].Description = Info;
		}
		for (unsigned int j=0; j<Objects[i].Children.size(); j++)
		{
			if (Objects[i].Children[j].Name == Object)
			{
				Objects[i].Children[j].Description = Info;
			}
		}
	}
}
void ItemServer::GetInfo(const string& To, const string& Object)
{
	printf("Trying to find information for object %s sending to %s\n", Object.c_str(), To.c_str());
	Message Temp;
	Temp.SetFrom("ITEM_SERVER");
	Temp.SetTo(To);
	Temp.SetMessage("INFO_IS");
	for (unsigned int i=0; i< Objects.size(); i++)
	{
		for (unsigned int j=0; j< Objects[i].Children.size(); j++)
		{
			if (Objects[i].Children[j].Name == Object)
			{
				Temp.AddString(Objects[i].Children[j].Description);
				break;
			}
		}
		if (Objects[i].Name == Object)
		{
			Temp.AddString(Objects[i].Description);
		}
	}
	CLine->SendMessage(Temp);
}

void ItemServer::GetURL(const string& To, const string& Object)
{
	for (unsigned int i=0; i< Objects.size(); i++)
	{
		if (Objects[i].Name == Object)
		{
			Message Temp;
			Temp.SetTo(To);
			Temp.SetFrom("ITEM_SERVER");
			Temp.SetMessage("URL_IS");
			Temp.AddString(Objects[i].URL);
		}
	}
}
void ItemServer::ReleaseControl(const string& Name)
{
	Message Temp;
	Temp.SetTo("ALL");
	Temp.SetFrom("ITEM_SERVER");
	Temp.SetMessage("CONTROL_RELEASED");
	for (unsigned int i=0; i<Objects.size(); i++)
	{
		if (Objects[i].Name == Name)
		{
			if (Objects[i].Control == true)
			{
				Objects[i].Control = false;
				Temp.AddString(Objects[i].Name);
				Message Temp2; 
				Temp2.SetTo("Everyone");
				Temp2.SetFrom("ITEM_SERVER");
				Temp2.SetMessage("UNWATCH_ITEM");
				Temp2.AddString("ITEM_SERVER");
				Temp2.AddString(Name);
				MCast.SendMessage(Temp2);
				MCast.SendMessage(Temp);
				return;
			}
		}
		for (unsigned int j=0; j< Objects[i].Children.size(); j++)
		{
			if (Objects[i].Children[j].Name == Name)
			{
				if (Objects[i].Children[j].Control)
				{
					Temp.AddString(Objects[i].Children[j].Name);
					Objects[i].Children[j].Control = false;
					Message Temp2; 
					Temp2.SetTo("Everyone");
					Temp2.SetFrom("ITEM_SERVER");
					Temp2.SetMessage("UNWATCH_ITEM");
					Temp2.AddString("ITEM_SERVER");
					Temp2.AddString(Name);
					MCast.SendMessage(Temp2);
					MCast.SendMessage(Temp);
					return;
				}
			}
		}
	}
}

void ItemServer::RequestControl(const string& From, const string& Name)
{
	Message Temp;
	Temp.SetTo(From);
	Temp.SetFrom("ITEM_SERVER");
	Temp.SetMessage("ITEM_CONTROL");
	for (unsigned int i=0; i<Objects.size(); i++)
	{
		for (unsigned int j=0; j<Objects[i].Children.size(); j++)
		{
			if (Objects[i].Children[j].Name == Name)
			{
				if (Objects[i].Children[j].Control)
				{
					Temp.AddString("DENIED");
				}
				else
				{
					Objects[i].Children[j].Control = true;
					Temp.AddString("GRANTED");
					Message Temp2; 
					Temp2.SetTo("Everyone");
					Temp2.SetFrom("ITEM_SERVER");
					Temp2.SetMessage("WATCH_ITEM");
					Temp2.AddString(From);
					Temp2.AddString(Name);
					MCast.SendMessage(Temp2);
					Objects[i].Children[j].Controller = From;
				}
				Temp.AddString(Name);
				CLine->SendMessage(Temp);
				return;
			}
		}
		if (Objects[i].Name == Name)
		{
			if (Objects[i].Control == false)
			{
				Objects[i].Control = true;
				Temp.AddString("GRANTED");
				Message Temp2; 
				Temp2.SetTo("Everyone");
				Temp2.SetFrom("ITEM_SERVER");
				Temp2.SetMessage("WATCH_ITEM");
				Temp2.AddString(From);
				Temp2.AddString(Name);
				MCast.SendMessage(Temp2);
				Objects[i].Controller = From;
			}
			else
			{
				Temp.AddString("DENIED");
			}
			Temp.AddString(Name);
			CLine->SendMessage(Temp);
			return;
		}
	}
}

void ItemServer::ListObjects(const string& To, const string& TheMessage)
{
	printf("Listing objects!\n");
	Message Temp;
	Temp.SetFrom("ITEM_SERVER");
	Temp.SetMessage(TheMessage);
	Temp.SetTo(To);
	printf("I have %d objects\n", Objects.size());
	Temp.AddInt(Objects.size());
	for (unsigned int i=0; i< Objects.size(); i++)
	{
		printf("Object %d is %s with url %s\n", i, Objects[i].Name.c_str(), Objects[i].URL.c_str());
		//Add in the objects name and url
		Temp.AddString(Objects[i].Name);
		Temp.AddString(Objects[i].URL);

		//Add in if the dso needs to watch the object
		if (Objects[i].Control)
		{
			Temp.AddInt(1);
			Temp.AddString(Objects[i].Controller);
		}
		else
		{
			Temp.AddInt(0);
		}

		//Add in the parents children
		Temp.AddInt(Objects[i].Children.size());
		for (unsigned int j=0; j< Objects[i].Children.size(); j++)
		{
			Temp.AddString(Objects[i].Children[j].Name);
			Temp.AddString(Objects[i].Children[j].URL);
			//Add in if we need to watch the children
			if (Objects[i].Control)
			{
				Temp.AddInt(1);
				Temp.AddString(Objects[i].Children[j].Controller);
			}
			else
			{
				Temp.AddInt(0);
			}
		}
	}
	CLine->SendMessage(Temp);
}

void ItemServer::AddItem(const string& Name, const string& URL)
{
	printf("Name is %s URL is %s\n", Name.c_str(), URL.c_str());

	for (unsigned int i=0; i< Objects.size(); i++)
	{
		if (Objects[i].Name == Name)
			return;
	}
	//Add to internal data structure
	Item Temp1;
	Temp1.Name = Name;
	Temp1.URL = BaseURL + "/" + Name;
	Temp1.Control = false;
	Temp1.Description = "No description given yet.";
	Temp1.LastKnownPosition[0] = 0;
	Temp1.LastKnownPosition[1] = 0;
	Temp1.LastKnownPosition[2] = 0;
	Temp1.LastKnownPosition[3] = 0;
	Temp1.LastKnownPosition[4] = 0;
	Temp1.LastKnownPosition[5] = 0;
	Objects.push_back(Temp1);

	//Send message to everyone else
	Message Temp;
	Temp.SetTo("Everyone");
	Temp.SetFrom("ITEM_SERVER");
	Temp.SetMessage("ADD_ITEM");
	Temp.AddString(Name);
	Temp.AddString(URL);
	MCast.SendMessage(Temp);
}

void ItemServer::RemoveItem(const string& Name)
{
	printf("Removing item %s\n", Name.c_str());
	//Go through each item and check to see if it is the one we want to remove
	//If it is put all of its children back into the object list
	//Otherwise check to see if the parents children are the object we are 
	//looking for
	for (unsigned int i=0; i< Objects.size(); i++)
	{
		//Check parent
		if (Objects[i].Name == Name)
		{
			Message Temp;
			Temp.SetTo("Everyone");
			Temp.SetFrom("ITEM_SERVER");
			Temp.SetMessage("REMOVE_ITEM");
			Temp.AddString(Name);
			if (Objects[i].Children.size() > 0)
			{
				for (unsigned int j=0; j< Objects[i].Children.size(); j++)
					Objects.push_back(Objects[i].Children[j]);
			}
			Objects.erase(Objects.begin() + i);
			MCast.SendMessage(Temp);
			return;
		}
		//Check child
		for (unsigned int j=0; j<Objects[i].Children.size(); j++)
		{
			if (Objects[i].Children[j].Name == Name)
			{
				Message Temp;
				Temp.SetTo("Everyone");
				Temp.SetFrom("ITEM_SERVER");
				Temp.SetMessage("REMOVE_ITEM");
				Temp.AddString(Name);
				Objects[i].Children.erase(Objects[i].Children.begin()+ j);
				MCast.SendMessage(Temp);
			}
		}
	}
}

//Associate two items together
void ItemServer::Associate(const string& Parent, const string& Child)
{
	int ParentPos = -1;  //The parents position
	int ChildPos  = -1;  //The childs  position
	//Find the parent
	for (unsigned int i=0; i<Objects.size(); i++)
	{
		if (Objects[i].Name == Parent)
			ParentPos = i;
	}
	//Find the child
	for (unsigned int i=0; i < Objects.size(); i++)
	{
		if (Objects[i].Name == Child)
			ChildPos = i;
	}
	//If we didn't find both, die
	if (ParentPos == -1 || ChildPos == -1)
	{
		printf("Could not find the parent or the child\n");
		return;
	}
	//Add the child to the parent
	Objects[ParentPos].Children.push_back(Objects[ChildPos]);
	//Erase the child from the main list
	Objects.erase(Objects.begin() + ChildPos);
}

//DisAssociate two items
void ItemServer::DisAssociate(const string& Child)
{
	//Go through each parent and search through their list of children
	//When child is found add it to the main list and erase it from the 
	//child list of its previous parent

	//Go through each parent
	for (unsigned int i=0; i<Objects.size(); i++)
	{
		//Go through each child
		for (unsigned int j=0; j<Objects[i].Children.size(); j++)
		{
			//Found the child
			if (Objects[i].Children[j].Name == Child)
			{
				Objects.push_back(Objects[i].Children[j]);
				Objects[i].Children.erase(Objects[i].Children.begin() + j);
			}
		}
	}
}

void ItemServer::SendURL(const string& From, const string& Object)
{
	for (unsigned int i=0; i<Objects.size(); i++)
	{
		if (Objects[i].Name == Object)
		{
			Message Temp;
			Temp.SetMessage("DOWNLOAD_URL");
			Temp.SetTo(From);
			Temp.SetFrom("ITEM_SERVER");
			Temp.AddString(Objects[i].Name);
			Temp.AddString(Objects[i].URL);
			CLine->SendMessage(Temp);
			printf("Server sending download message to client\n");
		}
		for (unsigned int j=0; j<Objects[i].Children.size(); j++)
		{
			if (Objects[i].Children[j].Name == Object)
			{
				Message Temp;
				Temp.SetMessage("DOWNLOAD_URL");
				Temp.SetTo(From);
				Temp.SetFrom("ITEM_SERVER");
				Temp.AddString(Objects[i].Children[j].Name);
				Temp.AddString(Objects[i].Children[j].URL);
				CLine->SendMessage(Temp);
			printf("Server sending download message to client\n");
			}
		}

	}
}
void ItemServer::UpdateURL(const string& Object, const string& URL)
{
	for (unsigned int i=0; i< Objects.size(); i++)
	{
		if (Objects[i].Name == Object)
		{
			printf("PARENT URL SET OK\n");
			Objects[i].URL = URL;
		}
		for (unsigned int j=0; j< Objects.size(); j++)
		{
			if (Objects[i].Children[j].Name == Object)
			{
				printf("CHILD URL SET OK\n");
				Objects[i].Children[j].URL= URL;
			}
		}
	}
}

void ItemServer::SendPosition(const string& To)
{
	Message Temp; 
	for (unsigned int i=0; i< Objects.size(); i++)
	{
		//Send the parent info off
		Temp.SetTo(To);
		Temp.SetFrom("ITEM_SERVER");
		Temp.SetMessage("ITEM_POSITION");
		Temp.AddString(Objects[i].Name);
		for (int k=0; k<6; k++)
			Temp.AddFloat(Objects[i].LastKnownPosition[k]);
		CLine->SendMessage(Temp);
		Temp.Clear();
		for (unsigned int j=0; j< Objects[i].Children.size(); j++)
		{
			Temp.SetTo(To);
			Temp.SetFrom("ITEM_SERVER");
			Temp.SetMessage("ITEM_POSITION");
			Temp.AddString(Objects[i].Children[j].Name);
			for (int k=0; k<6; k++)
				Temp.AddFloat(Objects[i].Children[j].LastKnownPosition[k]);
			CLine->SendMessage(Temp);
			Temp.Clear();
		}
	}
}
