
#include <string>
#include <vector>
using namespace std;
#include "Communicator.h"
#include <dtk.h>
#include "MultiCast.h"

MultiCast::MultiCast()
{

}

MultiCast::~MultiCast()
{
	for (unsigned int i=0; i< Segments.size(); i++)
	{
		delete Segments[i];
	}
}

bool MultiCast::AddPerson(const string& Hostname, const string& Segment)
{
	printf("Adding %s %s\n", Hostname.c_str(), Segment.c_str());
	if (Hostname == "" || Segment == "")
		return false;
	Communicator* Temp = new Communicator(Segment);
	char buff[64];
	unsigned int size = 64;
	gethostname(buff,size);
	if (string(buff) != Hostname)
		Temp->SetRemote(Hostname);
	else
		Temp->SetHost(Hostname);
	Segments.push_back(Temp);
	return true;
}

bool MultiCast::RemovePerson(const string& Hostname, const string& Segment)
{
	for (unsigned int i=0; i< Segments.size(); i++)
	{
		if (Segments[i]->GetHost() == Hostname && Segments[i]->GetSegment() == Segment)
		{
			delete Segments[i];
			Segments.erase(Segments.begin()+ i);
			return true;
		}
	}
	return false;
}

vector<string> MultiCast::GetHosts()
{
	vector<string> Temp;
	for (unsigned int i=0; i < Segments.size(); i++)
	{
		Temp.push_back(Segments[i]->GetHost());
	}
	return Temp;
}

vector<string> MultiCast::GetSegments()
{
	vector<string> Temp;
	for (unsigned int i=0; i < Segments.size(); i++)
	{
		Temp.push_back(Segments[i]->GetSegment());
	}
	return Temp;
}

bool MultiCast::SendMessage(Message& AMessage)
{
	for (unsigned int i=0; i< Segments.size(); i++)
	{
		printf("Sending message to %s\n", Segments[i]->GetHost().c_str());
		AMessage.SetTo(Segments[i]->GetHost());
		Segments[i]->SendMessage(AMessage);

	}
	return true;
}
