#include <vector>
#include <string>

using namespace std;

#include <dtk.h>
#include "Communicator.h"
#include "Rule.h"

RuleManager::RuleManager()
{

}

RuleManager::~RuleManager()
{

}

bool RuleManager::Check(const string& MessageName) 
{
	for (unsigned int i=0; i< TList.size(); i++)
	{
		if (TList[i]->GetMessage() == MessageName)
			return true;
	}	
	for (unsigned int i=0; i <FList.size(); i++)
	{
		printf("%s and %s \n", MessageName.c_str(), FList[i]->GetMessage().c_str());
		if (FList[i]->GetMessage() == MessageName)
			return true;
	}
	return false;
}

bool RuleManager::Handle(Message& AMessage)
{
	for (unsigned int i=0; i< TList.size(); i++)
	{
		if (TList[i]->GetMessage() == AMessage.GetMessage())
			TList[i]->DoTransformation(AMessage);
	}	
	for (unsigned int i=0; i <FList.size(); i++)
	{
		if (FList[i]->GetMessage() == AMessage.GetMessage())
		{
			FList[i]->DoForward(AMessage);
		}
	}
	return true;
}
bool RuleManager::AddTransformation(TransformationContainer* Transform)
{
	TransformationRule* Temp = new TransformationRule(Transform);
	TList.push_back(Temp);
	return true;
}
bool RuleManager::RemoveTransformation(TransformationContainer* Transform)
{
	for (unsigned int i=0; i<TList.size(); i++)
	{
		if ((TList[i])->GetMessage() == Transform->AMessage)
		{
			delete TList[i];
			TList.erase(TList.begin() + i);
		}
	}
	return true;
}

bool RuleManager::RemoveAllTransformations(const string& AMessage)
{
	for (unsigned int i=0; i<TList.size(); i++)
	{
		if (TList[i]->GetMessage()  == AMessage)
		{
			delete TList[i];
			TList.erase(TList.begin() + i);
		}
	}
	return true;

}

bool RuleManager::ClearEverything()
{
	TList.clear();
	FList.clear();
	return true;
}

bool RuleManager::AddForward(ForwardContainer* Forward)
{
	ForwardRule* Temp = new ForwardRule(Forward);
	FList.push_back(Temp);
	return true;
}

bool RuleManager::RemoveForward(ForwardContainer* Forward)
{
	for (unsigned int i=0; i<FList.size(); i++)
	{
		if ((FList[i])->GetMessage() == Forward->AMessage)
		{
			FList.erase(FList.begin() + i);
			return true;
		}
	}
	return false;
}
bool RuleManager::RemoveAllForwards(const string& Message)
{
	for (unsigned int i=0; i<FList.size(); i++)
	{
		if (FList[i]->GetMessage()  == Message)
		{
			FList.erase(FList.begin()+ i);
			return true;
		}
	}
	return false;
}
bool RuleManager::ClearMessage(const string& AMessage)
{
	for (unsigned int i=0; i<TList.size(); i++)
	{
		if (TList[i]->GetMessage() == AMessage)
			TList.erase(TList.begin() + i);
	}
	for (unsigned int i=0; i<FList.size(); i++)
	{
		if (FList[i]->GetMessage()  == AMessage)
			FList.erase(FList.begin() + i);
	}
	return true;
}
vector<ForwardRule*> RuleManager::GetAllForwards()
{
	return FList;
}
vector<ForwardRule*> RuleManager::GetAllForwards(const string& AMessage)
{
	vector<ForwardRule*> Test;
	for (unsigned int i=0; i< FList.size(); i++)
	{
		if (FList[i]->GetMessage() == AMessage)
			Test.push_back(FList[i]);
	}
	return Test;
}
vector<TransformationRule*> RuleManager::GetAllTransformations()
{
	return TList;
}
vector<TransformationRule*> RuleManager::GetAllTransformations(const string& AMessage)
{
	vector<TransformationRule*> Test;
	for (unsigned int i=0; i< TList.size(); i++)
	{
		if (TList[i]->GetMessage() == AMessage)
			Test.push_back(TList[i]);
	}
	return Test;
}
