#include <string>
#include <vector>
using namespace std;
#include "Communicator.h"
#include <dtk.h>
#include "Rule.h"

void RuleManagerForwardTest()
{
	RuleManager RMan;
	
	ForwardContainer Container;
	Container.AMessage = "Hello";
	Container.Destination = "ok.sv.vt.edu";
	Container.Segment = "Test";

	ForwardContainer Container2;
	Container2.AMessage = "Hello";
	Container2.Destination = "glyph.sv.vt.edu";
	Container2.Segment = "Test";

	RMan.AddForward(&Container);
	printf("One added\n");
	RMan.AddForward(&Container2);
	printf("Two added\n");

	
	Message Temp;
	Temp.SetMessage("Hello");
	Temp.SetFrom("Me");
	Temp.SetTo("You");
	Temp.SetToClass("Polymorph");
	Temp.AddString("100Dalmatians");
	Temp.AddInt(100);

	if (RMan.Check("Hello"))
	{
		printf("I have a forwarding rule!\n");
		RMan.Handle(Temp);
	}
}

void ForwardTest()
{
	//Set up the forward
	ForwardRule FRule;
	FRule.AddMessage("Hello");
	ForwardContainer Container;
	Container.AMessage = "Hello";
	Container.Destination = "ok.sv.vt.edu";
	Container.Segment = "Test";
	FRule.AddForward(&Container);
	//Set up the message
	Message Temp;
	Temp.SetMessage("Testing wohoo");
	Temp.SetFrom("Me");
	Temp.SetTo("You");
	Temp.SetToClass("Polymorph");
	Temp.AddString("100Dalmatians");
	Temp.AddInt(100);
	printf("Made it here\n");
	FRule.DoForward(Temp);
	printf("Made it past the message sending!\n");
}

void TransformTest()
{
	//Set up the transformation 
	TransformationRule TRule;
	TRule.AddMessage("Hello");
	TransformationContainer Container;
	Container.AMessage = "Hello";
	Container.NewMessage = "ANewMessage";
	Container.Destination = "ok.sv.vt.edu";
	Container.Segment = "Test";
	Container.Data = "AllYourTransformAreBelongToMe";
	TRule.AddTransformation(&Container);
	//Set up the message
	Message Temp;
	Temp.SetMessage("Testing wohoo");
	Temp.SetFrom("Me");
	Temp.SetTo("You");
	Temp.SetToClass("Polymorph");
	Temp.AddString("100Dalmatians");
	Temp.AddInt(100);
	printf("Made it here\n");
	TRule.DoTransformation(Temp);

}

int main()
{
	//ForwardTest();
	//TransformTest();
	RuleManagerForwardTest();

	return 0;
}
