#include <vector>
#include <string>

using namespace std;

#include <dtk.h>
#include "Communicator.h"
#include "Rule.h"

TransformationRule::TransformationRule()
{
	Container = NULL;
}

TransformationRule::TransformationRule(TransformationContainer* Transform)
{
	if (Transform == NULL)
		printf("Warning null transform struct, this should break the system\n");
	Container = Transform;
	AddMessage(Transform->AMessage);
	Sender = new Communicator(Transform->Segment);
	Sender->SetRemote(Container->Destination);
}

TransformationRule::~TransformationRule()
{
	if (Sender !=NULL)
		delete Sender;
}

bool TransformationRule::AddTransformation(TransformationContainer* Transformation)
{
	if (Transformation == NULL)
		return false;
	Container = Transformation;
	Sender = new Communicator(Transformation->Segment);
	Sender->SetRemote(Container->Destination);
	return true;
}

bool TransformationRule::RemoveTransformation()
{
	if (Container == NULL)
		return false;
	delete Container;
	return true;
}

TransformationContainer* TransformationRule::GetTransformation()
{
	return Container;
}

bool TransformationRule::DoTransformation(Message& AMessage)
{
	if (Container == NULL)
		return false;
	AMessage.SetMessage(Container->NewMessage);
	if (Container->Data == "")
		Container->Data = "None";
	string TempTo, TempFrom;
	TempTo = AMessage.GetTo();
	TempFrom = AMessage.GetFrom();
	string TempClass = AMessage.GetToClass();
	string Temp = Container->Data + "\t" + AMessage.GetParamaters(); 
	printf("Message is %s\n", Temp.c_str());

	AMessage.Clear();
	AMessage.SetTo(TempTo);
	AMessage.SetFrom(TempFrom);
	AMessage.SetToClass(TempClass);
	AMessage.SetMessage(Container->NewMessage);
	AMessage.SetParamaters(Temp);
	Sender->SendMessage(AMessage);
	return true;
}
