#ifndef groupserver_h
#define groupserver_h

#include "base_server.h"


struct Group
{
	bool            BroadCast;
	bool            Listen;
	string          Name;
	vector<Segment> FileList;
	vector<string>  Members;
};


class GroupServer : public Base_Server
{
	public:
	void AddGroup(const string& Data);
	void RemoveGroup(const string& Data);
	string* ListGroups();
	int NumGroups();
	//User group functionality
	void AddUserToGroup(const string& User, const string& Group);
	void RemoveUserFromGroup(const string& User, const string& Group);
	//Group and segment stuff
	void AddGroupToSegment(const string& Group, const string& Segment);
	void RemoveGroupFromSegment(const string& Group, const string& Segment);
	void GroupListen(const string& Group, const string& Segment);
	void IsGroupListen(const string& Group, const string& Segment);
	void GroupBroadCast(const string& Group, const string& Segment);
	void IsGroupBroadCast(const string& Group, const string& Segment);
	private:

};
#endif
