#ifndef item_server_h
#define item_server_h

class ItemServer
{

	public:
	
	//Start serving
	void Serve();

	//Set the main listening segment
	void SetMainListenSegment(const string& Listen);

	//Turn on queued requests
	void QueueRequests(const bool& Requests);
	//Return whether or not requests are queued
	bool QRequests();

	private:

	//Add / remove other shared memory segments
	void AddItemSegment(const string& Segment);
	void RemoveItemSegment(const string& Segment);

	//Grant and deny requests for items
	void GrantRequest(const string& Segment);
	void DenyRequest (const string& Segment);

	//Say the request is done
	void RequestDone(const string& Segment);


	//Add an item to the world
	void AddItem(const string& ItemName);

	//Remove and item from the world
	void RemoveItem(const string& ItemName);

};

#endif 
