// Hopefully will be the dedicated server for a CCC or otherwise.
//

//#include <cstdio>
#include <dtk.h>
#include <vector>
//#include <queue>
#ifdef IRIX //for bzero()
# include<bstring.h>
#endif
#include "../Client/duser.h"
#include "../Client/Messenger.h"
#include "../Client/MessageParser.h"

using namespace std;

struct mess
{
  string from;
  string time;
};

class dServer
{
  public:
    dServer();
    ~dServer();
    int serve();

  private:
    vector<duser*> clients;
    Messenger* messenger;
    MessageParser* parser;
    char buff[256];
    //queue<mess> ignoreQ;
    vector<mess> ignoreQ;
    //dtkTime Timer;
    //long double lastTime; //The last time the timer was reset.

    int CheckMessages();
    int writeAllUsers(string whoRequested);
    int writeNewUser(string from,string avatar);
    int addUser(string from,string avatarName);
    int SearchClients(string user);
    int disconnect(string user);
    //int checkUsers();
    //int checkIn(string user);
};

dServer::dServer()
{
  messenger = new Messenger("genMessage");
  messenger->setFrom("server");
  parser = new MessageParser("genMessage");
  cout<<"DTK dedicated server running"<<endl;
//  lastTime = Timer.delta();
}

dServer::~dServer()
{
  for(unsigned int i=0;i<clients.size();i++)
    if(clients[i] != NULL) delete clients[i];
}

int dServer::serve()
{
/*
  long double currTime = Timer.get();
  if(currTime - lastTime > 10){ //Ping users every ten seconds.
    lastTime = currTime;
    checkUsers();
  }
*/

  //  Update all of the clients positions
  for(unsigned int i=0;i<clients.size();i++){
    clients[i]->updatePos();
  }

  //  While there are messages on the queue keep going
  while(CheckMessages() != -1){
  
    //  Update all of the clients positions
    for(unsigned int i=0;i<clients.size();i++){
      clients[i]->updatePos();
    }

  }

  return 0;
}
/*
int dServer::checkUsers()
{
  string username;
  for(unsigned int i=0;i<clients.size();i++){

    username = clients[i]->getName();
    long double check = clients[i]->getCheckIn();

    if(lastTime - check > 20){
      cout<<"user "<<username<<" timed out"<<endl;
      disconnect(username);
    }
  }

  return 0;
}
*/
int dServer::CheckMessages()
{
  if(parser->NextMessage() == -1) return -1;
  
  string from = parser->getFrom();
  string to = parser->getTo();
  string time = parser->getTime();
  string message = parser->getMessage();
  
  if(from == "server"){
   return -2;
  }

  if(to != "server"){
/*    if(!ignoreQ.empty()){
      if(from == ignoreQ.front().from && time == ignoreQ.front().time){
        ignoreQ.pop();
        return -2;
      }
    }
    */
    if(!ignoreQ.empty()){
      if(from == ignoreQ[0].from && time == ignoreQ[0].time){
        ignoreQ.erase(ignoreQ.begin());
        return -2;
      }
    }
    string Line = parser->getLine();
    mess newMess;
    newMess.from = from;
    newMess.time = time;
//    ignoreQ.push(newMess);
    ignoreQ.push_back(newMess);
    messenger->setFrom(from);
    messenger->setTo(to);
    messenger->setTime(time);
    messenger->setMessage(message);
    if(Line != ""){
      messenger->addString(Line);
    }
    messenger->SendMessage();
    messenger->setFrom("server");
    return -2;
  }

  string Line = parser->getLine();

  cout<<"Server recieved message : \""
    <<"'"<<from.c_str()<<"'"<<" "
    <<"'"<<to.c_str()<<"'"<<" "
    <<"'"<<time.c_str()<<"'"<<" "
    <<"'"<<message.c_str()<<"'";
    if(Line != "") cout<<" "<<Line.c_str();
    cout<<"\""<<endl;
  
  switch(message[0]){
    // for a new client joining the session.
    case'a': //addme
      if(message == "addme"){
        string avatarName = Line;
        addUser(from,avatarName);
        writeAllUsers(from);
        writeNewUser(from,avatarName);
      }
      break;
/*    case 'c': // checking in
      checkIn(from);
      break;
*/
    case 'd':
      if(message == "disconnect"){
        cout<<"attempting to disconnect "<<from.c_str()<<endl;
        disconnect(from);
      }
      break;
    default:
      cout<<"Server could not understand command."<<endl;
      break;
  }

  return 0;
}
/*
int dServer::checkIn(string user)
{
  int pos = SearchClients(user);

  if(pos == -1) return -1; //Didn't find user.

  clients[pos]->setCheckIn(Timer.get());

  return 0;
}
*/
//////////////////////////////////////////
//
//  disconnect.
//
//  disconnects a user and tries to free
//  up the shared mem.
//
//////////////////////////////////////////

int dServer::disconnect(string user)
{
  int pos = SearchClients(user);
  
  if(pos == -1) return -1; //Didn't find the user;

  cout<<"user found disconnecting"<<endl;
  messenger->setTo("everyone");
  messenger->setMessage("disconnect");
  messenger->addString(user);
  messenger->SendMessage();

  clients.erase(clients.begin() + pos);

  return 0;
}

//////////////////////////////////////////
//    Add user 
//
//    Inserts another user into the client
//    vector in assending order.
//    
//////////////////////////////////////////

int dServer::addUser(string from,string avatarName)
{
	printf("Add user %s\n", from.c_str());
  int size = clients.size();

  if(size == 0){
    duser* newGuy = new duser(from,avatarName);
    clients.push_back(newGuy);
    return 0;
  }

  int pos = SearchClients(from);

  if(pos != -1) return -1;

  duser* newGuy = new duser(from,avatarName);

  clients.push_back(newGuy);


  return 0;
}

///////////////////////////////////////////
//
//    SearchClients
//
//    Parameters:  a user name without user-
//
//    Returns where in the client vector
//    a client is or the closet location
///////////////////////////////////////////

int dServer::SearchClients(string user)
{
  for(unsigned int i=0;i<clients.size();i++)
    if(clients[i]->getName() == user) return i;
      
  return -1;
  
/*
  int size = clients.size();
  if(size == 0) return 0;
  int low = 0;
  int high = size-1;
  string temp;
  int mid = (high+low)/2;

  for(mid = (high+low)/2;low<=high;){
    temp = clients[mid].getName();
    if(temp == user)
      return mid;
    if(user > temp){
        low = mid+1;
    }
    else
      high = mid-1;
  }

  return mid;
*/  
}

///////////////////////////////////////////////
//    Writes all the user names in one big
//    long string and writes that string
//    to shared mem for everyone else to read.
///////////////////////////////////////////////

int dServer::writeAllUsers(string whoRequested)
{
  messenger->setTo(whoRequested);

  string NameList;
  string AvatarList;

  for(unsigned int i=0;i<clients.size();i++){
    NameList += "\t" + clients[i]->getName();
    AvatarList += "\t" + clients[i]->getAvatar();
  }

  NameList.erase(0,1);
  AvatarList.erase(0,1);

  messenger->setMessage("usernames");
  messenger->addString(NameList);
  messenger->SendMessage();
  messenger->setMessage("useravatars");
  messenger->addString(AvatarList);
  messenger->SendMessage();

  return 0;
}

///////////////////////////////////////////////
//    Writes one new user for everyone to read
//    they will then inturn connect to the shared
//    mem segment for that user.
///////////////////////////////////////////////

int dServer::writeNewUser(string Name, string avatar)
{
  messenger->setTo("everyone");
  messenger->setMessage("newuser");
  messenger->addString(Name);
  messenger->addString(avatar);
  messenger->SendMessage();
  return 0;
}

int main(int argc, char* argv)
{
  dServer Server;
  while(true){
    Server.serve();
    //Server.printNames();
    usleep(100000);  //sleep for a 10th of a second
  }
}
