// generated by Fast Light User Interface Designer (fluid) version 1.0011

#include <dtk.h>
#include "Messenger.h"
#include "MessageParser.h"
#include "CollabConsole.h"
#include <unistd.h>
#include <stdio.h>

int NumPeople;
Messenger* Message;
bool Tethered, ASharedView;
Fl_Window *MainWindow=(Fl_Window *)0;

Fl_Tile *userTile=(Fl_Tile *)0;

Fl_Hold_Browser *GroupList=(Fl_Hold_Browser*)0;

Fl_Box *label1=(Fl_Box *)0;

Fl_Button *JumpTo=(Fl_Button *)0;

Fl_Button *TetherTo=(Fl_Button *)0;

Fl_Button *Sharedview=(Fl_Button *)0;

Fl_Button *Highlight=(Fl_Button *)0;



static void HighlightCallback(Fl_Widget*, void*)
{

	for (int i=1; i<=NumPeople; i++)
	{
		if (GroupList->selected(i))
		{
			char* Temp = new char[200];
			Temp = (char*)GroupList->data(i);
			printf("I am going to %s's position\n", Temp);
			Message->setFrom("server");
			char* Hostname = strdup(getenv("HOSTNAME"));
			Message->setTo(string(Hostname));
			Message->setMessage("highlight");
			Message->addString(Temp);
			Message->SendMessage();

		}
	}
}
static void JumpCallback(Fl_Widget*, void*)
{
	if (ASharedView || Tethered)
		return;
	for (int i=1; i<=NumPeople; i++)
	{
		if (GroupList->selected(i))
		{
			char* Temp = new char[200];
			Temp = (char*)GroupList->data(i);
			printf("I am going to %s's position\n", Temp);
			Message->setFrom("server");
			char* Hostname = strdup(getenv("HOSTNAME"));
			Message->setTo(string(Hostname));
			Message->setMessage("jumpto");
			Message->addString(Temp);
			Message->SendMessage();
		}
	}
}
static void TetherCallback(Fl_Widget*, void*)
{
	if (ASharedView)
		return;
	//Undo the tethering view
	if (Tethered)
	{
		Message->setFrom("server");
		char* Temp = getenv("HOSTNAME");
		Message->setTo(Temp);
		Message->setMessage("free-tether");
		Message->SendMessage();
		TetherTo->label("Tether to user");
		Tethered = false;
	}
	//Share tether the user
	else
	{
		for (int i=1; i<=NumPeople; i++)
		{
			if(GroupList->selected(i))
			{
				Message->setFrom("server");
				char* Temp = getenv("HOSTNAME");
				Message->setTo(Temp);
				Message->setMessage("tether-to");
				Message->addString((char*)GroupList->data(i));
				Message->SendMessage();
				TetherTo->label("Un-tether from user");
				Tethered = true;
			}
		}
	}
}

static void SharedCallback(Fl_Widget*, void*)
{
	if (Tethered)
		return;
	//Undo the tethering view
	if (ASharedView)
	{
		Message->setFrom("server");
		char* Temp = getenv("HOSTNAME");
		Message->setTo(Temp);
		Message->setMessage("free-sharedview");
		Message->SendMessage();
		Sharedview->label("Shared View");
		ASharedView = false;
	}
	//Share tether the user
	else
	{
		for (int i=1; i<=NumPeople; i++)
		{
			if(GroupList->selected(i))
			{
				Message->setFrom("server");
				char* Temp = getenv("HOSTNAME");
				Message->setTo(Temp);
				Message->setMessage("sharedview");
				Message->addString((char*)GroupList->data(i));
				Message->SendMessage();
				Sharedview->label("Return to your own eyes");
				ASharedView= true;
			}
		}
	}
}

Fl_Window* make_window() {
  Fl_Window* w;
  { Fl_Window* o = MainWindow = new Fl_Window(237, 403, "Collaboration Console");
    w = o;
    { Fl_Tile* o = userTile = new Fl_Tile(0, 20, 230, 185, "UserList:");
      o->box(FL_EMBOSSED_BOX);
      GroupList = new Fl_Hold_Browser(5, 25, 220, 175);
      o->end();
    }
    /*
    GroupList->add("pitr.sv.vt.edu");
    GroupList->data(1, (void*)"pitr.sv.vt.edu");
    GroupList->show(1);
    GroupList->add("glyph.sv.vt.edu");
    GroupList->data(2, (void*)"glyph.sv.vt.edu");
    GroupList->show(2);
    GroupList->add("idesk.sv.vt.edu");
    GroupList->data(3, (void*)"idesk.sv.vt.edu");
    GroupList->show(3);
    */
    label1 = new Fl_Box(25, 215, 185, 25, "Functions:");
    JumpTo = new Fl_Button(0, 240, 235, 35, "Jump To User");
    JumpTo->callback(JumpCallback, NULL);
    TetherTo = new Fl_Button(0, 285, 235, 35, "Tether to user");
    TetherTo->callback(TetherCallback, NULL);
    Sharedview = new Fl_Button(0, 325, 235, 35, "Shared View");
    Sharedview->callback(SharedCallback, NULL);
    Highlight = new Fl_Button(0, 370, 235, 30, "Highlight User");
    Highlight->callback(HighlightCallback, NULL);
    o->end();
  }
  w->show();
  return w;
}

int main()
{
	Tethered = false;
	ASharedView = false;
	Message = new Messenger("genMessage");
	if (Message == NULL)
		return 1;
	char* Server = NULL; 
	Server = getenv("DPF_SHARED_SERVER");
	if (Server !=NULL)
	{
		Message->connectRemoteSharedMem(Server);
		printf("Connected to server %s\n", Server);
	}
	Fl_Window* Window = make_window();
	bool Running;
	Running = true;
	Window->visible_r();
	MessageParser Update("Collab-Commands");
	while (Running)
	{
		if (! Window->visible())
			return 0;
		Fl::wait(.100000000);
		//If we get an update user list command
		if (Update.NextMessage() != -1)
		{
			printf("Beginning update\n");
			//Get the number of people
			NumPeople= Update.getInt();
			printf("I have %d people to add\n", NumPeople);
			printf("Grouplist is of size%d\n", GroupList->size());
			//Build the new list of people
			if (GroupList->size() ==  NumPeople )
				continue;
			GroupList->clear();
			for (int i=1; i<=NumPeople; i++)
			{
				char* Holder = strdup(Update.getString().c_str());
				GroupList->add(Holder);
				GroupList->data(i, (void*)Holder);
				GroupList->show(i);
			}
		}
		usleep(10000);
	}
}
