// FLTK part
// generated by Fast Light User Interface Designer (fluid) version 1.0011
// All other work done by Andrew A. Ray

#include <dtk.h>
#include <FL/fl_file_chooser.H>
#include "Messenger.h"
#include "MessageParser.h"
#include "fileloader.h"

/*Begin FLTK Function */
Fl_Hold_Browser *A_Browser=(Fl_Hold_Browser *)0;

Fl_Button *RemoveButton=(Fl_Button *)0;

Fl_Box *label1=(Fl_Box *)0;

Fl_Button *LoadButton=(Fl_Button *)0;
/* End FLTK functions */


//Is the program running
bool Running;
//Send messages 
Messenger* Message;
//Recieve messages
MessageParser* Parser;

//This is the function that is called when you press load on the gui
//Basically takes the file you chose and splits it into path2file and file,
//bundles that up in a message and sends it off
static void LoadCallback(Fl_Widget*, void*)
{
	//Hopefully people don't use files over 1024 characters long
	char* Temp = new char[1024];
	Temp = fl_file_chooser("Pick a file to load", NULL, NULL);
	if (Temp == NULL)
		return;
	char* Dir = NULL;
	char* App = NULL;
	if (Temp[0] == '/')
	{
		int Location = 0;
		for (int i=0; i< strlen(Temp); i++)
		{
			if (Temp[i] == '/')
				Location = i;
		}
		App = new char[strlen(Temp) - Location +1];
		//Copy the app name 
		for (int i=1; i< strlen(Temp) - Location+ 1; i++)
		{
			App[i-1] = Temp[Location+i];
		}
		//Get the path to the app
		Dir = new char[200];
		for (int i=0; i<Location; i++)
		{
			Dir[i] = Temp[i];
		}
		Dir[Location] = '\0';
	}
	else
	{
		App = strdup(Temp);
		Dir = new char[200];
		strcpy(Dir , getenv("PWD"));
	}
	printf("My file to load is %s\n", App);
	printf("My directory to load is %s\n", Dir);
	Message->setFrom("someone");
	Message->setTo("everyone");
	Message->setMessage("add-file");
	Message->addString(App);
	Message->addString(Dir);
	Message->SendMessage();
}
static void RemoveCallback(Fl_Widget*, void*)
{
	for (int i=1; i<=A_Browser->size(); i++)
	{
		if (A_Browser->selected(i))
		{
			Message->setFrom("someone");
			Message->setTo("everyone");
			Message->setMessage("remove-file");
			Message->addString((char*)A_Browser->data(i));
			Message->SendMessage();
			return;
		}
	}
}

Fl_Window* make_window() {
  Fl_Window* w;
  { Fl_Window* o = new Fl_Window(301, 154, " Object Loader and Unloader");
    w = o;
    { Fl_Hold_Browser* o = A_Browser = new Fl_Hold_Browser(10, 45, 165, 105, "Objects Loaded:");
      o->align(FL_ALIGN_TOP);
    }
    RemoveButton = new Fl_Button(180, 115, 120, 35, "Remove object");
    { Fl_Box* o = label1 = new Fl_Box(20, -5, 265, 50, "Object Loader / Unloader");
      o->labelsize(18);
    }
    RemoveButton->callback(RemoveCallback, NULL);
    LoadButton = new Fl_Button(180, 45, 120, 35, "Load Object");
    LoadButton->callback(LoadCallback, NULL);
    o->end();
  }
  w->show();
  return w;
}


int main()
{
	Running = true;
	Fl_Window* Window;
	Message = new Messenger("genMessage");
	Message->setFrom("server");
	Message->setTo(getenv("HOSTNAME"));
	Parser = new MessageParser("CollabFile");
	MessageParser GlobalParser("genMessage");
	Message->setMessage("get-files-loaded");
	Message->SendMessage();

        Window = make_window();
	Window->visible_r();
	string AMessage;
	//While the gui is running
	while (Running)
	{
		Fl::wait(.100000000);
		//Check to see if the we need to update the gui !
		if (GlobalParser.NextMessage() != -1)
		{
			string Temp = GlobalParser.getMessage();
			if (Temp == "files-loaded-are")
			{
				int TempSize = GlobalParser.getInt();
				string A = "";
				if (TempSize > A_Browser->size())
				{
					A_Browser->clear();
					Message->setMessage("load-file");
					for (int i=0; i< TempSize; i++)
					{
						A = GlobalParser.getString();
						Message->addString(A);
					}
					Message->SendMessage();
					continue;
				}
			}
		}
		//Check to see if we add or remove items from the list
		if (Parser->NextMessage() != -1)
		{
			AMessage = Parser->getMessage();
			printf("Working on message %s\n", AMessage.c_str());
			//Add a message to the gui
			if (AMessage  == "UpdateFileGui") 
			{
				string A;
				A = Parser->getString();
				bool Dup = false;
				for (int i=1; i<=A_Browser->size(); i++)
				{
					if (string((char*)A_Browser->data(i)) == A)
						Dup = true;
				}
				if (!Dup)
				{
					 A_Browser->add(A.c_str());
					 A_Browser->data(A_Browser->size(), (void*)strdup(A.c_str()));
				}
				continue;
			}
			//Remove an id from the gui
			if (AMessage == "remove-gui" )
			{
				string ID = Parser->getString();
				printf("Beginning remove of %s\n", ID.c_str());
				for (int i=1; i<= A_Browser->size(); i++)
				{
					if ( string((char*)A_Browser->data(i)) == ID)
					{
						A_Browser->remove(i);
						break;
					}
				}
				continue;

			}
		}
	}
	return 0;
}

