#include <string>
#include <vector>
using namespace std;
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>
#include "Communicator.h"
#include "ItemServer.h"
#include "func_declarations.h"
float NewX;
float NewY;
float NewZ;
float NewH;
float NewP;
float NewR;

//Register the gui with the item server
void Register()
{
	Message Temp;
	Temp.SetTo("ITEM_SERVER");
	Temp.SetFrom(HostName);
	Temp.SetMessage("ADD_USER");
	Temp.AddString(HostName);
	Temp.AddString("ITEM_MESSAGE");
	MCenter->SendMessage(Temp);
	printf("Registered with gui\n");
	Message Loader;
	Loader.SetTo("ITEM_SERVER");
	Loader.SetFrom(HostName);
	Loader.SetMessage("GUI_LIST_ITEMS");
	MCenter->SendMessage(Loader);
}

//Unregister the gui with the item server
void UnRegister()
{
	if (ControlledItem != "")
	{
		Message Temp1;
		Temp1.SetTo("ITEM_SERVER");
		Temp1.SetFrom(HostName);
		Temp1.SetMessage("RELEASE_ITEM_CONTROL");
		Temp1.AddString(ControlledItem);
		MCenter->SendMessage(Temp1);
		ControlledItem = "";
	}
	Message Temp;
	Temp.SetTo("ITEM_SERVER");
	Temp.SetFrom("HostName");
	Temp.SetMessage("REMOVE_USER");
	Temp.AddString(HostName);
	Temp.AddString("ITEM_MESSAGE");
	MCenter->SendMessage(Temp);
}

void HandleMessages()
{
	if (Controlled)
		UpdateItemWindow();
	//Temporary Message
	Message* Temp;
	//Fill message
	Temp = MCenter->GetMessage();

	//No message, return
	if (Temp == NULL)
	{
		//printf("No message\n");
		return;
	}

	//Message not for me
	if (Temp->GetTo() != HostName || Temp->GetTo() == "Everyone")
	{
		printf("Message not for me message is for %s\n", Temp->GetTo().c_str());
		return;
	}

	//Get the message
	string Info = Temp->GetMessage();

	printf("Message is %s\n", Info.c_str());
	
	//If we got query information sent to us
	if (Info == "INFO_IS")
	{
		printf("I got a query info message!\n");
		ShowQueryInfo(Temp);
	}
	if (Info == "REMOVE_ITEM")
	{
		RemoveItem(Temp);	
	}

	if (Info =="ADD_ITEM")
	{
		printf("Adding an item to the gui");
		AddItem(Temp);
	}

	if (Info=="DOWNLOAD_URL")
	{
		string Item   = Temp->GetString();
		string URL2DL = Temp->GetString();
		Download(Item, URL2DL);
	}

	if(Info == "GUI_LOAD_ITEMS")
	{
		int Size = Temp->GetInt();
		printf("I am supposed to load %d items\n", Size);
		for (int i=0; i<Size; i++)
		{
			AddItem(Temp);
			int Test = Temp->GetInt();
			if (Test == 1)
				Temp->GetString();
			int NumChildren = Temp->GetInt();
			for (int j=0; j< NumChildren; j++)
			{
				string Parent = (char*)MainItemBrowser->data(MainItemBrowser->size());
				AddItem(Temp);
				string Child = (char*)MainItemBrowser->data(MainItemBrowser->size());
				int Test = Temp->GetInt();
				if (Test == 1)
					Temp->GetString();
				Message Faker;
				Faker.AddString(Parent);
				Faker.AddString(Child);
				Associate(&Faker);
			}
		}
	}
	if (Info == "ASSOCIATE")
	{
		Associate(Temp);
	}
	if (Info == "DISASSOCIATE")
	{
		DisAssociate(Temp);
	}
	if (Info == "CONTROL_RELEASED")
	{
		string Item = Temp->GetString();
		printf("Trying to release item %s, my controlled item is %s\n", Item.c_str(), ControlledItem.c_str());
		if (Item == ControlledItem)
		{
			ControlledItem = "";
			Controlled = false;
			RequestButton->show();
			ReleaseButton->hide();
			ItemManipulationWindow->hide();
		}
	}
	if (Info == "ITEM_CONTROL")
	{
		string Item = Temp->GetString();
		if (Item == "DENIED")
		{
			ControlledItem = "";
			ReleaseButton->hide();
			RequestButton->show();
		}
		if (Item == "GRANTED")
		{
			Controlled = true;
			ReleaseButton->show();
			RequestButton->hide();
			SetupItemManipulationWindow();
		}
	}
	if (Info == "REPLICATE")
	{
		Replicate(Temp);
	}
	delete Temp;
}

//Show the query information for an item
void ShowQueryInfo(Message* Temp)
{
	QueryWindowInfo->label(Temp->GetString().c_str());
	QueryWindow->show();
}

//Add an item to the browser
void AddItem(Message* Temp)
{
	string App = Temp->GetString();
	string URL = Temp->GetString();
	printf("Adding %s at url %s\n", App.c_str(), URL.c_str());
	MainItemBrowser->add(App.c_str());
	MainItemBrowser->data(MainItemBrowser->size(), (void*)strdup(App.c_str()));
}

//Remove an item from the gui
void RemoveItem(Message* Temp)
{
	string Object = Temp->GetString();
	printf("Gui side trying to remove %s\n", Object.c_str());
	char* Data = NULL;
	//Go through the associated browser and see if we find it
	//If we do , remove it from the parent list of some item and take it out of the gui
	for (int i=1; i <= AssociatedItemBrowser->size(); i++)
	{
		Data = (char*)AssociatedItemBrowser->data(i);
		if (string(Data) == Object)
		{
			AssociatedItemBrowser->remove(i);
			for (unsigned int j=0; j< Parents.size(); j++)
			{
				for (unsigned int k=0; k < Parents[j].Children.size(); k++)
				{
					if (Parents[j].Children[k] == Object)
					{
						Parents[j].Children.erase(Parents[j].Children.begin() + k);
						if (Parents[j].Children.size() == 0)
							Parents.erase(Parents.begin()+j);
					}
				}
			}
			break;
		}
	}
	//If it an item is in the main item browser then take it out
	//Check to see if it has children
	//If it does then add the children to the main item browser (Unassociated items)
	for (int i=1; i<= MainItemBrowser->size(); i++)
	{
		Data = (char*)MainItemBrowser->data(i);
		if (string(Data) == Object)
		{
			MainItemBrowser->remove(i);
			for (unsigned int j=0; j < Parents.size(); j++)
			{
				if (Parents[j].Parent == string(Data))
				{
					for (unsigned int k=0; k< Parents[j].Children.size(); k++)
					{
						MainItemBrowser->add(strdup(Parents[j].Children[k].c_str()));
						MainItemBrowser->data(MainItemBrowser->size(), strdup(Parents[j].Children[k].c_str()));
						for (int l=1; l<= AssociatedItemBrowser->size(); l++)
						{
							Data = (char*)AssociatedItemBrowser->data(l);
							if (string(Data) == Parents[j].Children[k])
								AssociatedItemBrowser->remove(l);
						}
					}
				}
			}
			break;
		}
	}
	if (ControlledItem == Object)
	{
		ItemManipulationWindow->hide();
		ReleaseButton->hide();
		RequestButton->show();
	}

}
void Associate(Message* Temp)
{
	string Parent = Temp->GetString();
	string Child = Temp->GetString();
	printf("Associating %s with %s\n", Parent.c_str(), Child.c_str());
	bool Exists = false;
	//Add the information into the parent structure
	for (unsigned int k=0; k< Parents.size(); k++)
	{
		//Parent already exists, add to list of existing children
		if ( Parent == Parents[k].Parent)
		{
	      		printf("Found a parent!!! Parent is %s\n", Parents[k].Parent.c_str());
			printf("Child is %s\n", Child.c_str());
	     		Parents[k].Children.push_back(Child);
			Exists = true;
		}
	}
	//If a parent does not exist, create one and the child
	if (!Exists)
	{
		Info Temp;
		Temp.Parent = Parent;
		Temp.Children.push_back(Child);
		Parents.push_back(Temp);
	}
	//Update the gui menus
	AssociatedItemBrowser->add(Child.c_str());
	AssociatedItemBrowser->data(AssociatedItemBrowser->size(), strdup(Child.c_str()));
	for (int j=1; j<=MainItemBrowser->size(); j++)
	{
		if (string((char*)MainItemBrowser->data(j)) == Child)
			MainItemBrowser->remove(j);
	}
}	
void DisAssociate(Message* Temp)
{
	string Item = Temp->GetString();
	printf("Disassociating %s\n", Item.c_str());
	//Check all the parents to see who is in charge of the child
	for (unsigned int j=0; j<Parents.size(); j++)
	{
	//Go through each parents child and see if it is the rightone
	//If it is the right child then remove it and then see if the parent has any children left
	//If the parent does not have any other children left erase it
		for (unsigned int k=0; k<Parents[j].Children.size(); k++)
		{
			//Is this the right child?
			if (!strcmp(Parents[j].Children[k].c_str(), Item.c_str()))
			{
				//Erase child
				Parents[j].Children.erase(Parents[j].Children.begin() + k);
				//Erase the parent if it has no children
				if (Parents[j].Children.size() ==0)
				Parents.erase(Parents.begin() + j);
			}
		}
	}
	//Finally update the gui
	//Add to main list
	MainItemBrowser->add(strdup(Item.c_str()));
	MainItemBrowser->data(MainItemBrowser->size(), strdup(Item.c_str()));
	//Remove from associated list
	char* Data;
	for (int i=1; i<=AssociatedItemBrowser->size(); i++)
	{
		Data = (char*)AssociatedItemBrowser->data(i);
		if (string(Data) == Item)
			AssociatedItemBrowser->remove(i);
	}
}

//Replicate an item in the gui (in case a user wants a couple of them)
void Replicate(Message* Temp)
{
	//Get the item to add to the world
	string Item = Temp->GetString();
	string Num =  Temp->GetString();
	string Final = Item + "-" + Num;
	//Add to item list
	MainItemBrowser->add(strdup(Final.c_str()));
	//Add the data in
	MainItemBrowser->data(MainItemBrowser->size(), strdup(Item.c_str()));
}

//Basically unregister the gui and send out a die message that can be used
//to shut of the item dso
void SendDeathMessage()
{
	Message Temp;
	Temp.SetTo(HostName);
	Temp.SetFrom(HostName);
	Temp.SetMessage("DIE");
	MCenter->SendMessage(Temp);
	UnRegister();
}

//Download a file!!!
void Download(const string& Object, const string& URL)
{
	int Pipe[2];
	pipe(Pipe);

	int Pid = fork();
	if (Pid ==0)
	{
		int ID = getpid();
		write(Pipe[1], &ID, sizeof(int));

		char* Test = getenv("DPF_DOWNLOAD_DIR");
		if (Test == NULL)
		{
			return ;
		}
		else
		{
			string DL = "-P/";
			if (Test != NULL)
				DL = 	"-P" + string(Test);
			string Final = URL ;//+ "/" + Object;
			char* Get[4];
			Get[0] = "wget";
			Get[1] = strdup(DL.c_str());
			Get[2] = strdup(Final.c_str());
			Get[3] = NULL;
			execvp(Get[0], Get);
			printf("%s %s %s\n", Get[0], Get[1], Get[2]);
		}
	}
	else
	{
		int ID = -1;
		read(Pipe[0], &ID, sizeof(int));
		wait(&ID);
		printf("File grab program finished\n");
		Message Test;
		Test.SetTo(HostName);
		Test.SetFrom(HostName);
		Test.SetMessage("FILE_DOWNLOADED");
		Test.AddString(Object);
		Test.AddString("DOWNLOADED");
		MCenter->SendMessage(Test);
	}
}

void SetupItemManipulationWindow()
{
	float Prime = 0;
	char* Temp = new char[50];
	sprintf(Temp, "%f", Prime);
	X_Input->value(Temp);
	Y_Input->value(Temp);
	Z_Input->value(Temp);
	H_Input->value(Temp);
	P_Input->value(Temp);
	R_Input->value(Temp);
	X=0.0;
	Y=0.0;
	Z=0.0;
	H=0.0;
	P=0.0;
	R=0.0;
	NewX=0.0;
	NewY=0.0;
	NewZ=0.0;
	NewH=0.0;
	NewP=0.0;
	NewR=0.0;
	//Give the dso some time to get things going ;)
	usleep(100000);

	//Memory management is good, I hope :o
	/*
	if (!strcmp(Control_Name->value(),"Temp_Name"))
		free(Control_Name->value());

	//Update the item name
	Control_Name->value(strdup(ControlledItem.c_str()));
	*/
	//Update the item window values
	UpdateItemWindow();
	AllButton->value(1);
	X_Button->value(0);
	Y_Button->value(0);
	Z_Button->value(0);
	Zoom_Button->value(0);
	Rotate_Button->value(0);
	Pan_Button->value(0);
	Navigate_Button->value(0);

	//Show the window to the user!
	Control_Name->label(ControlledItem.c_str());
	ItemManipulationWindow->show();
	sprintf(Temp, "%f", XYZIncrementValue);
	XYZIncrement->value(Temp);
	sprintf(Temp, "%f", HPRIncrementValue);
	HPRIncrement->value(Temp);
	delete [] Temp;
}

//Update the item window
void UpdateItemWindow()
{
	float TempFloat[6];
	ObjectPosition->read(TempFloat);
	char* Temp = new char[50];
	NewX = TempFloat[0];
	NewY = TempFloat[1];
	NewZ = TempFloat[2];
	NewH = TempFloat[3];
	NewP = TempFloat[4];
	NewR = TempFloat[5];
	if (NewX != X)
	{
		X = NewX;
		sprintf(Temp, "%f", TempFloat[0]);
		X_Input->value(Temp);
	}
	if (NewY != Y)
	{
		Y = NewY;
		sprintf(Temp, "%f", TempFloat[1]);
		Y_Input->value(Temp);
	}
	if (NewZ != Z)
	{
		Z = NewZ;
		sprintf(Temp, "%f", TempFloat[2]);
		Z_Input->value(Temp);
	}
	if (NewH != H)
	{
		H = NewH;
		sprintf(Temp, "%f", TempFloat[3]);
		H_Input->value(Temp);
	}
	if (NewP != P)
	{
		P = NewP;
		sprintf(Temp, "%f", TempFloat[4]);
		P_Input->value(Temp);
	}
	if (NewR != R)
	{
		R = NewR;
		sprintf(Temp, "%f", TempFloat[5]);
		R_Input->value(Temp);
	}
	delete [] Temp;
}
