#ifndef func_h
#define func_h

//Function declarations

void AddCallbacks();                     //Sets up the fltk callbacks
void FakePopulate();        		 //Puts some fake data in the gui for testing
void SendDeathMessage();    		 //Kills the local dso and file gui
void HandleMessages();      		 //Handle messages
void SetupWindows();        	  	 //Setup the windows for the program
void ShowQueryInfo(Message* Temp);       //Show the query information
void AddItem(Message* Temp);             //Add the item to the gui
void RemoveItem(Message* Temp);          //Remove an item from the gui
void Register();                         //Register with the item server
void UnRegister();                       //UnRegister with the item server
void SendDeathMessage();                 //Send the die message
void Associate(Message* Temp);           //Associate items
void DisAssociate(Message* Temp);        //DisAssociate an item
void Replicate(Message* Temp);           //Replicate two items
void Download(const string& Objects, const string& URL);        //Download a file !!!
void SendUpdateMessage(const string& Variable, const float& Value); //Send an update of an objects position to the DSO
void SetupItemManipulationWindow();      //Setup the item manipulation window
void UpdateItemWindow();                 //Update the item window
void SendManipulationMessage(const string& AName, const string& AStatus, const string& MessageMe); //Send a status update message

//Basic structure that represents one item in the gui
struct Info
{
	string Parent;
	vector<string> Children;
};

//Global variables (don't complain, they are necessary :)
extern string ControlledItem;      //The item this gui controls
extern string HostName;            //The hostname for this computer
extern vector<Info> Parents;
extern Communicator* MCenter;      //The message center

//Fl window variables
extern Fl_Window* MainWindow;            //Main fltk window
extern Fl_Window* AssociateWindow;       //The association  window
extern Fl_Window* QueryWindow;           //The query window
extern Fl_Window* InfoWindow;            //The add info window
extern Fl_Window* ItemManipulationWindow;//The item manipulation window
extern Fl_Window* URLWindow;             //The url window

//X Y Z and HPR variables and the values to increment them by
extern float X;
extern float Y;
extern float Z;
extern float H;
extern float P;
extern float R;
extern float XYZIncrementValue;
extern float HPRIncrementValue;
extern float NewX;
extern float NewY;
extern float NewZ;
extern float NewH;
extern float NewP;
extern float NewR;
//The position of the object in memory :)
extern dtkSharedMem* ObjectPosition;
extern bool Controlled;
#endif
