// generated by Fast Light User Interface Designer (fluid) version 1.0011

#include <FL/fl_file_chooser.H>          //For the browse button
#include "initial.h"
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdlib.h>
#include <unistd.h>

char** env;
Fl_Window* window;

Fl_Button *StartButton=(Fl_Button *)0;

Fl_Input *ServerInput=(Fl_Input *)0;

Fl_Input *AvatarName=(Fl_Input *)0;

Fl_Input *MapScale=(Fl_Input *)0;

Fl_Input *MapAspect=(Fl_Input *)0;

Fl_Input *BaseDir=(Fl_Input *)0;

Fl_Input *AppToStart=(Fl_Input *)0;

Fl_Round_Button *Radar=(Fl_Round_Button *)0;

Fl_Box *Label1=(Fl_Box *)0;

Fl_Round_Button *Client=(Fl_Round_Button *)0;

Fl_Round_Button *FirePower=(Fl_Round_Button *)0;

Fl_Round_Button *SelectPoints=(Fl_Round_Button *)0;

Fl_Round_Button *SnapTerrain=(Fl_Round_Button *)0;

Fl_Round_Button *SkyGroundPerformer=(Fl_Round_Button *)0;

Fl_Round_Button *Fog=(Fl_Round_Button *)0;

Fl_Round_Button *PointerIntersection=(Fl_Round_Button *)0;

Fl_Box *ServerInputLabel=(Fl_Box *)0;

Fl_Box *AvatarLabel=(Fl_Box *)0;

Fl_Box *MapScaleLabel=(Fl_Box *)0;

Fl_Box *MapAspectLabel=(Fl_Box *)0;

Fl_Box *CollabToolsLabel=(Fl_Box *)0;

Fl_Box *AppLabel=(Fl_Box *)0;

Fl_Box *Header=(Fl_Box *)0;

Fl_Round_Button *CollabConsole=(Fl_Round_Button *)0;

Fl_Input *Other2Load=(Fl_Input *)0;

Fl_Round_Button *Item_Button=(Fl_Round_Button *)0;

Fl_Button *Load_AvatarButton=(Fl_Button *)0;

bool Running;

static void loadbuttoncallback(Fl_Widget*, void*)
{
	printf("Load button pressed\n");
	char* Temp = new char[1024];
	Temp = fl_file_chooser("Pick a file to load", NULL, NULL);
	if (Temp == NULL)
		return;
	char* Dir = NULL;
	char* App = NULL;
	if (Temp[0] == '/')
	{
		int Location = 0;
		for (unsigned int i=0; i< strlen(Temp); i++)
		{
		if (Temp[i] == '/')
			Location = i;
		}
		App = new char[strlen(Temp) - Location +1];
		//Copy the app name
		for (unsigned int i=1; i< strlen(Temp) - Location+ 1; i++)
		{
			App[i-1] = Temp[Location+i];
		}
		//Get the path to the app
		Dir = new char[200];
		for (int i=0; i<Location; i++)
		{
			Dir[i] = Temp[i];
		}
		Dir[Location] = '\0';
	}
	else
	{
		App = strdup(Temp);
		Dir = new char[200];
		strcpy(Dir , getenv("PWD"));
	}
	char* Final = new char[400];
	strcpy(Final, App);
	AvatarName->value(Final);
}

static void startcallback(Fl_Widget*, void*)
{
	//Item and console stuff
	bool Item = false;
	bool Console = false;

	printf("Callback made\n");
	FILE* File;
	File = fopen("startfile", "w");
	fprintf(File, "#!/bin/bash\n");
	fprintf(File, "export DPF_CIRCLE_RADAR_FILE=circleRadar.rgb\n");
	fprintf(File, "export DPF_MAP_FILE=2Dmap.rgb\n");
	fprintf(File, "export DPF_MAP_SCALE=%s\n", MapScale->value());
	fprintf(File, "export DPF_MAP_ASPECT=%s\n", MapAspect->value());
	fprintf(File, "export DPF_SHARED_SERVER=%s\n", ServerInput->value());
	fprintf(File, "export DPF_AVATAR_NAME=%s\n", AvatarName->value());
	fprintf(File, "export DPF_BASEDIR=%s\n",BaseDir->value());
	fprintf(File, "export DPF_DSO_PATH=`pwd`:%s/ClientServer/Client/dsow:%s/ClientServer/Client/playbackReadWriteNavD:%s/ClientServer/Client\n", BaseDir->value(), BaseDir->value(), BaseDir->value());
	fprintf(File, "dtk-shutdownServer\n");
	fprintf(File, "dtk-server -d \n");
	fprintf(File, "export DPF_PLAYBACK_FILE=`pwd`/ClientServer/Client/playbackroute.txt\n");
	//fprintf(File, "cd ClientServer/Client\n");
	char* DSOLOAD = new char[500];
	strcpy(DSOLOAD, "export DPF_DSO_FILES=desktopGroup:caveSimInput");
	if (Client->value())
		strcat(DSOLOAD, ":dclient");
	if (FirePower->value())
		strcat(DSOLOAD, ":firepower");
	if (SelectPoints->value())
		strcat(DSOLOAD,  ":selectPoints");
	if (SnapTerrain->value())
		strcat(DSOLOAD, ":snapTerrain");
	if (SkyGroundPerformer->value())
		strcat(DSOLOAD, ":skyGroundPerformer");
	if (Fog->value())
		strcat(DSOLOAD, ":fogDSO");
	if (PointerIntersection->value())
		strcat(DSOLOAD, ":pointerIntersection");
	if (Radar->value())
		strcat(DSOLOAD, ":radar");
	if (CollabConsole->value())
	{
		Console = true;
		strcat(DSOLOAD, ":console");
	}
	if (Item_Button->value())
	{
		Item = true;
		strcat(DSOLOAD, ":item");
	}

	if (strlen(Other2Load->value()) > 0)
	{
		strcat(DSOLOAD,":");
		strcat(DSOLOAD,Other2Load->value());
	}
			
	fprintf(File, "%s\n", DSOLOAD);
	if (Item)
	{
		char* Data = new char[400];
		strcpy(Data,  "./Item_Gui&");
		fprintf(File, "%s\n", Data);
		delete [] Data;
	}
	if (Console)
	{
		char* Data = new char[400];
		strcpy(Data,  "./CollabConsole&");
		fprintf(File, "%s\n", Data);
		delete [] Data;
	}
	fprintf(File, "%s\n", AppToStart->value());
	fprintf(File, "xset r \n"); 
	int Pipe[2];
	pipe(Pipe);

	int pid = fork();
	if (pid == 0)
	{
		int ID=getpid();
		write(Pipe[1], &ID, sizeof(int));
		printf("Called chmod + x\n");
		char* Arg[4];
		Arg[0] = "chmod";
		Arg[1] = "+x";
		Arg[2] = "startfile";
		Arg[3] = NULL;
		execvp(Arg[0], Arg);
	}
	else
	{
		int ID = -1;
		read(Pipe[0], &ID, sizeof(int));
		wait(&ID);
	}


	delete [] DSOLOAD;
	fclose(File);
	pid = fork();
	if (pid == 0)
	{
		char* Arg2[2];
		Arg2[0] = "startfile";
		Arg2[1] = NULL;
		execve(Arg2[0], Arg2, env);
	}
	Running = false;
}



void make_window() {
  { Fl_Window* o = window = new Fl_Window(530, 410, "Collaborative Tools");
//	  o = window;
    StartButton = new Fl_Button(455, 365, 70, 40, "Start");
    ServerInput = new Fl_Input(165, 65, 315, 25);
    AvatarName = new Fl_Input(165, 95, 315, 25);
    MapScale = new Fl_Input(165, 125, 315, 25);
    MapAspect = new Fl_Input(165, 155, 315, 25);
    BaseDir = new Fl_Input(165, 185, 315, 25);
    AppToStart = new Fl_Input(165, 215, 315, 25);
    { Fl_Round_Button* o = Radar = new Fl_Round_Button(15, 290, 25, 25, "Radar");
      o->down_box(FL_ROUND_DOWN_BOX);
    }
    { Fl_Box* o = Label1 = new Fl_Box(5, 255, 510, 25, "DSO\'s To Load");
      o->labelsize(24);
    }
    { Fl_Round_Button* o = Client = new Fl_Round_Button(370, 315, 30, 25, "Client");
      o->down_box(FL_ROUND_DOWN_BOX);
    }
    { Fl_Round_Button* o = FirePower = new Fl_Round_Button(370, 290, 25, 25, "FirePower");
      o->down_box(FL_ROUND_DOWN_BOX);
    }
    { Fl_Round_Button* o = SelectPoints = new Fl_Round_Button(370, 340, 25, 25, "SelectPoints");
      o->down_box(FL_ROUND_DOWN_BOX);
    }
    { Fl_Round_Button* o = SnapTerrain = new Fl_Round_Button(15, 320, 25, 25, "SnapTerrain");
      o->down_box(FL_ROUND_DOWN_BOX);
    }
    { Fl_Round_Button* o = SkyGroundPerformer = new Fl_Round_Button(135, 320, 25, 25, "Sky Ground Performer");
      o->down_box(FL_ROUND_DOWN_BOX);
    }
    { Fl_Round_Button* o = Fog = new Fl_Round_Button(15, 350, 50, 25, "Fog");
      o->down_box(FL_ROUND_DOWN_BOX);
    }
    { Fl_Round_Button* o = PointerIntersection = new Fl_Round_Button(135, 350, 25, 25, "Pointer Intersection");
      o->down_box(FL_ROUND_DOWN_BOX);
    }
    ServerInputLabel = new Fl_Box(10, 65, 110, 25, "Server machine");
    AvatarLabel = new Fl_Box(10, 95, 95, 25, "Avatar model");
    MapScaleLabel = new Fl_Box(10, 125, 80, 25, "Map Scale");
    MapAspectLabel = new Fl_Box(5, 155, 135, 25, "Map Aspect Ratio");
    CollabToolsLabel = new Fl_Box(5, 185, 160, 25, "Collab Tools Directory");
    AppLabel = new Fl_Box(5, 215, 140, 25, "Application To Start");
    { Fl_Box* o = Header = new Fl_Box(5, 5, 525, 40, "Collaborative Tools Startup Screen");
      o->labelfont(1);
      o->labelsize(31);
    }
    { Fl_Round_Button* o = CollabConsole = new Fl_Round_Button(15, 375, 155, 25, "Collaborative Console");
      o->down_box(FL_ROUND_DOWN_BOX);
    }
    Other2Load = new Fl_Input(225, 375, 225, 25, "Other:");
    { Fl_Round_Button* o = Item_Button = new Fl_Round_Button(135, 290, 25, 25, "Item Manipulation");
      o->down_box(FL_ROUND_DOWN_BOX);
    }
    Load_AvatarButton = new Fl_Button(485, 95, 40, 25, "Load");
    o->end();
    o->resizable(o);
  }
  window->show();
  
}

int main(int argc, char** argv, char** environ)
{
	env = environ;
	make_window();
	StartButton->callback(startcallback, NULL);
	BaseDir->value(getenv("PWD"));
	MapAspect->value("0.8");
	MapScale->value("2000");
	Client->value(1);
	CollabConsole->value(1);
	Item_Button->value(1);
	Radar->value(1);

	Load_AvatarButton->callback(loadbuttoncallback, NULL);

	Running = true;
	while (Running)
	{
		if (!window->visible())
			return 0;
		Fl::wait(.000000000000005);
		usleep(100000);
	}
}
