// DSO for the Avatar's

#include<dpf.h>
#include<dtk/dtkDSO_loader.h>
#include<Performer/pr/pfTexture.h>

class avatar : public dtkAugment
{
  public:
    avatar(dpf* app);
    ~avatar(void);

    int postConfig(void);
    int preFrame(void);
    int postFrame(void);

  private:

    dpf* app;
    pfCoord coord;
    pfDCS* body;
    dtkSharedMem* shm;
};

avatar::avatar(dpf *app_in) : dtkAugment("avatar")
{
  setDescription("represents an entity in a virtual world");
  app = app_in;
  validate();
}

avatar::~avatar(void)
{
  delete body;
  delete shm;
}

int avatar::postConfig(void)
{
  cout<<"postConfig"<<endl;
  pfFilePath(".:./models:../models:"DPF_DATA_DIR);

  pfNode* model = pfdLoadFile("battledroid.pfb");
  app->display()->addGhostNode(model);
  body = new pfDCS();
  body->addChild(model);
  body->setRot(0,90,0);
  //try putting it here +1231.178 +1405.837 +875.1245 -071 +000 +000
  body->setTrans(1231.178,1405.837,975.1245);
  body->setScale(1);
  app->display()->world()->addChild(body);

  cout<<"end postConfig"<<endl;
  return DTK_CONTINUE;
  
}

int avatar::preFrame(void)
{
  coord.xyz.set(0,0,0);
  coord.hpr.set(0,0,0);
  app->display()->dpfToWorld(&coord);
/*
  body->setRot(coord.hpr[0],coord.hpr[1]+90,coord.hpr[2]+90);
  body->setTrans(coord.xyz[0],coord.xyz[1]+50,coord.xyz[2]);
*/
  body->setTrans(coord.xyz[0],coord.xyz[1]+50,coord.xyz[2]);
  body->setRot(coord.hpr[0],coord.hpr[1]+90,coord.hpr[2]+90);
  return DTK_CONTINUE;

}

int avatar::postFrame(void)
{
  return DTK_CONTINUE;
}

//////////////////////////////////////////////
//
//  Generic Stuff
//
//////////////////////////////////////////////

static dtkAugment *dtkDSO_loader(dtkManager *manager, void *p)
{
  dpf *app = static_cast<dpf *>(manager);
  return new avatar(app);
}

static int dtkDSO_unloader(dtkAugment *augment)
{
  delete augment;
  return DTKDSO_UNLOAD_CONTINUE;
}

