#ifndef CHATDSO_MENU_H
#define CHATDSO_MENU_H

#include <FL/Fl.h>
#include <FL/Fl_Menu_Button.H>
#include <FL/Fl_Menu_Item.H>

// curUserRightClick Callbacks
extern void addUserToNewGroup_callback(Fl_Widget*, void*);
extern void addUserToGroup_callback(Fl_Widget*, void*);

// curConvRightClick callbacks
extern void addConv_callback(Fl_Widget*, void*);
extern void removeAllConv_callback(Fl_Widget*, void*);
extern void removeSelectedConv_callback(Fl_Widget*, void*);

Fl_Menu_Item curUserRightClick[] = {
  {"Chat with",0,addConv_callback,0,FL_MENU_DIVIDER},
  {"Add selected to new group chat",0,addUserToNewGroup_callback},
  {"Add selected to selected group chat",FL_CTRL+'g',addUserToGroup_callback,0,FL_MENU_DIVIDER},
  {"Data"},
  {0},
};

Fl_Menu_Item curConvRightClick[] = {
  {"New Conversation",FL_CTRL+'n',addConv_callback,0,FL_MENU_DIVIDER},
  {"R&emove Selected Conversation", FL_CTRL+'e', removeSelectedConv_callback},
  {"Remove &All Conversations",FL_CTRL+'a', removeAllConv_callback, 0,FL_MENU_DIVIDER},
  {"Data"},
  {0}
};


#endif
