// generated by Fast Light User Interface Designer (fluid) version 1.0011
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "chatDso.h"
#include "chatDso-Menu.h"

#include <FL/Fl_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Browser.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Multi_Browser.H>
#include <FL/Fl_Scrollbar.H>
#include <FL/Fl_Tabs.H>
#include <FL/fl_ask.H>

Fl_Input *Send=(Fl_Input *)0;			    // widget where user types message
Fl_Tabs *curConvWin=(Fl_Tabs *)0;		    // the tabs of current open conversations
Fl_Browser *Conversation=(Fl_Browser *)0;	    // might not be needed
Fl_Multi_Browser *curUserList=(Fl_Multi_Browser*)0; // lists the current logged in computers
Fl_Multi_Browser *curConvList=(Fl_Multi_Browser*)0; // lists the current conversations and who
						    // is in which group
static Messenger* mess = NULL;
static MessageParser* par = NULL;
static char user[SIZE];
static void acceptInvite (groupData*);
static void declineInvite (groupData*);
static void changeWinColor(int,int);
static void deleteGroupMembers(int);
static void sendDropNotices(int);
static void removeSelectedMembers (int);
static bool addUserToGroup (char*, int);
static void changeUserColor(int, string);

/*********************************
 *	  Class Methods
 ********************************/

// CLEAN
chatDso::chatDso(dpf* app_in):
  dtkAugment("chatDso"){
  app = app_in;
  client = NULL;
  messenger = NULL;
  parser = NULL;
  guiWin = NULL;
  validate();
}

// CLEAN
chatDso::~chatDso() {
  if(guiWin) {
    delete guiWin;
    guiWin = NULL;
  }

  if(client) {
    delete client;
    client = NULL;
  }

  if(messenger) {
    delete messenger;
    messenger = NULL;
    mess = NULL;
  }

  if(parser) {
    delete parser;
    parser = NULL;
  }
}

// CLEAN
int chatDso::postConfig() {
  
  // connects to the server 
  if(!connectToClient()){
    printf("E:ERROR: Unable to connect to client\n");
    return DTK_CALLBACK_ERROR;
  }
 
  // creates object that sends messages to sharedMem segment
  // called genMessage
  messenger = new Messenger("genMessage");
  mess = messenger;
  if(!messenger) {
    printf("E:ERROR: Unable to create Messenger object.\n");
    return DTK_CALLBACK_ERROR;
  }
  
  // creates object that parses the messages from the sharedMem
  // segment called genMessage
  parser = new MessageParser("genMessage");
  par = parser;
  if(!parser) {
    printf("E:ERROR: Unable to create MessageParser object.\n");
    return DTK_CALLBACK_ERROR;
  }

  // creates the gui
  make_window();//this);
  if(!guiWin){
    printf("E:ERROR: Unable to create gui\n");
    return DTK_CALLBACK_ERROR;
  }

  // makes the list of Users
  makeList();
  
  // setting from who all the messages will be from, me
  messenger->setFrom(user);	

  // sets the data for group conversation 'everyone'
  groupData* newData = new groupData;
  if(newData){
    newData->groupName = "everyone";
    newData->creatorName = "everyone";
    newData->memberName = "everyone";
    curConvList->data(1,(void*)newData);
  }

  return DTK_REMOVE_CALLBACK; 
}

// CLEAN
// checks each frame for new information
int chatDso::postFrame() {
  static int i= 0;
  check();
  Fl::check();
  i++;
  return DTK_CONTINUE;
}

// CLEAN
// finds a conversation win associated with the string 'curConv'
int findConvWin(string curConv) {

  int i;
  for(i = 0; i < curConvWin->children(); i++){
    printf("E: checking '%s' against '%s'\n", curConv.c_str(),
		    ((Fl_Browser*)curConvWin->child(i))->label());
    if(curConv == ((Fl_Browser*)curConvWin->child(i))->label()){
      printf("E:Found '%s' at index %i\n", ((Fl_Browser*)curConvWin->child(i))->label(),i);
      return i;
    }
  }
  printf("E:returning %i\n", -1);
  return -1;
}

// given a name group conv, this functions searches through the 
// list of current conversations to find the specified one and 
// returns the index or -1 if not found
int findConv(string conv) {
	
//  printf("E:looking for '%s'\n", conv.c_str());
  int i;
  for(i = curConvList->size(); i > 0; i--){
    if(curConvList->text(i)[3] == '.' || 
       curConvList->text(i)[2] == '1') {
//      printf("E:checking %i, '%s'\n", i, ((groupData*)curConvList->data(i))->groupName.c_str());
      if(((groupData*)curConvList->data(i))->groupName == conv){
//	printf("E:Found conv at index %i\n", i);	      
        return i; 
      }
    }
  } 
  return -1;
}


int findUserInGroup(int groupIndex, string userName) {
//  printf("E:start findUserInGroup\n");
//  printf("E:size = %i, index = %i\n", curConvList->size(), groupIndex);
  int i;
  for(i = groupIndex+1;i<=curConvList->size();i++) {
  //  printf("\tE:%i %s\n", i, curConvList->text(i));
    if(curConvList->text(1)[4] != '.'){
    //  printf("E:found a user at index = %i... now testing userName = %s vs. data=\"%s\"\n",
//	      i,userName.c_str(), ((groupData*)curConvList->data(i))->memberName.c_str());
      if(((groupData*)curConvList->data(i))->memberName == userName){
//	printf("E:end findUserInGroup found user at index %i\n", i);
	return i;
      }
    }else if(curConvList->text(i)[3] == '.'){
  //    printf("E:else\n");
      break;
    }
  }
  i = -1; 
//  printf("E:end findUserInGroup: found nothing\n");
  return i;
}

// check to see of there is something to display
bool chatDso::check() {
	
  char buf[SIZE];
  char added[SIZE];

  // refresh the list of users
  makeList();
 
  // get messages from the server 
  string message;

  // unable to read message
  if(parser->NextMessage() < 0) return false;
  if(parser->getFrom() == user) return false;
 
  string forMe = parser->getTo();

  // checking through all groups to see if message is for me
  if((forMe == user) || findConv(forMe.c_str()) >= 0) {
    string tmp = parser->getMessage();	// gets the statement

    // switch statement to figure out what type of message it is    
    switch(tmp.at(0)) {
      
      // message "0toChat" for chatting
      case('0'):{
		sprintf(buf, "%s",parser->getLine().c_str());
		sprintf(added,"@C4@b@.%s", buf);

		// checking to see if message is a 1st time appearance from
		// a 1on1 chat, if so add new window and add to curConvList
		int convIndex = findConv(parser->getFrom());
		if((convIndex == -1)){
		  curUserList->value((usersIndex(parser->getFrom())+1));
		  addConv_callback(NULL,0);
		}
		
		// code to find the correct conversation to put message in
		int i = findConvWin(parser->getFrom());
		if(i>=0){
		  ((Fl_Browser*) curConvWin->child(i))->color(3);
		  ((Fl_Browser*) curConvWin->child(i))->add(added);
		  ((Fl_Browser*) curConvWin->child(i))->bottomline( ((Fl_Browser*) curConvWin->child(i))->size());
		  curConvWin->redraw();
		}
		
		break;
      }
      // message "1toJoinGroup" to invite you to join a group chat
      // **** works ****
      case('1'):{
		groupData *newGroup = new groupData;
		if(newGroup){
		  newGroup->groupName = parser->getLine('\t');
		  printf("E:newGroup->groupName = \"%s\"\n", newGroup->groupName.c_str());
		  newGroup->creatorName = parser->getFrom();
		  newGroup->memberName = newGroup->groupName;
	        
		  if(fl_ask("You are asked to join group \"%s\".\nDo you accept?",newGroup->groupName.c_str()))
		    acceptInvite(newGroup);
		  else declineInvite(newGroup);
		}
		
    		break;
      }
      
      // message "2toAcceptGroup" informing you that a user accepted your invite
      case('2'):{
		
		//code to change color of user on curConvList to show accepted
		int groupIndex = findConv(parser->getTo());
		if(groupIndex > 0) {
		  int userIndex = findUserInGroup(groupIndex, parser->getFrom());
		  
		  if(userIndex < 0)
		    addUserToGroup((char*)parser->getFrom().c_str(),groupIndex);
//		    curConvList->redraw();
//		  }

		  
		  changeUserColor(userIndex, parser->getFrom().c_str());// was groupIndex
	  
		}
		break;
      }
      
      // message "3toRejectGroup"informing you that a user declined your group invite
      case('3'):{
		char message[SIZE];
		sprintf(message,"@C1@i@.%s declined your invitation to join group %s\n",
				parser->getFrom().c_str(), parser->getTo().c_str());

		// post decline message to the conversation board that currently has focus
	        ((Fl_Browser*) curConvWin->value())->add(message);

		// add code to drop name from group
		//findAndDrop(groupName, memberName);
		//findAndDrop(parser->getTo(), parser->getFrom());
		break;
      }
      
      // message "4toDropUser" informing you that you have been dropped from group
      case('4'):{
		string dropWho = parser->getLine();
		int convIndex = findConv(parser->getTo());
		if(convIndex>0){
		  curConvList->value(convIndex);
		  if(dropWho == "all"){
		    fl_alert("This is a notice that the creator of group \"%s\" has closed the chat " \
			     "session to all members.", parser->getTo().c_str());
		    removeSelectedConv_callback(NULL,NULL);
		  }else if(dropWho == user) {
		    fl_alert("This is a notice that you are being dropped from group \"%s\".", 
				parser->getTo().c_str());
		    removeSelectedConv_callback(NULL,NULL);
		    
		  }else
		    fl_alert("This is a notice that \"%s\" has been dropped from group \"%s\".",
				  dropWho.c_str(), parser->getTo().c_str());
		}
		
		// add code that removes the group name from your lists
		// findAndDrop(groupName, memberName);
		break;
      }
 
      // message "5toDropSelf" informing you that member of one of your groups has dropped
      case('5'):{
		printf("E:User %s has dropped from group %s\n",
			parser->getFrom().c_str(), parser->getTo().c_str());
		// add code that removes that user from the groups
		// findAndDrop(groupName, memberName);
		break;
      }
		
      // message "disconnect" if someone disconnects		
      case('d'):{  
      	        string droppedUser = parser->getTo(); // was String();
	        sprintf(buf,"@C1@i%s has left the building.\n",droppedUser.c_str());
		Conversation->add(buf);
		
		// add code to go through curConvList and change color of droppedUser
		// to show that they are still apart of the group but inactive
	
		break;
      }

      // else message was unrecognizable	
      default:	return false; break;
    }

  } else return false;

  return true;
}

// searches through list of users 'allUsers' to find
// string name
int chatDso::usersIndex(string name) {
  unsigned int i;
  for (i = 0; i < allUsers.size(); i++){
    printf("E:usersIndex:checking %s against %s\n", name.c_str(),
		    allUsers[i].c_str());
    if(allUsers[i] == name){
      printf("E:usersIndex:found %s at index %i\n", allUsers[i].c_str(),i);
      return i;
    }
  }

  return -1;
}

// CLEAN
// connects to shared mem
bool chatDso::connectToClient() {
  
  gethostname(user, SIZE);
  myName = user;
  
  client = (dclient*) app->check("dclient");
  if(!client) {
    printf("E:Could not get client\n");
    return false;    
  }

  return true;    
}

// loads the list of logged in users into the gui
void chatDso::makeList() {

  client = (dclient*) app->check("dclient");
  if(!client){
    printf("E:end makeList client NULL\n");
    return;
  }
  
  vector<duser*> newUsers = client->getUsers();
  static unsigned int lastCount = 0;
  
  // if the newlist is different size then the old list, then true
  // to allow old list to updated
  if(newUsers.size() != lastCount) {
  
    // clear current list of logged in Users
    curUserList->clear();

    // removes old users
    if(lastCount > newUsers.size())
      removeOldUsers(newUsers);
  
    // look throught a refreshed list of users and check
    // to see who has been added or dropped
    unsigned int i;
    for (i = 0; i < newUsers.size(); i++) {
      
      int index = usersIndex(newUsers[i]->getName()); 
      if(index < 0) {
	string userName = newUsers[i]->getName();

	allUsers.push_back(userName);
	if(userName != user){
	  char buf[SIZE];
	  sprintf(buf,"@C1@i%s just joined our little party.\n", userName.c_str());
	  Conversation->add(buf);
	}
      }
    }

    // redraw curUserList with the updated list
    for (i=  0; i < allUsers.size(); i++){
      char buf[SIZE];
      sprintf(buf, "@C4@b@.%s", allUsers[i].c_str());
      curUserList->add(buf);
      curUserList->data(i+1, (void*)allUsers[i].c_str());
    }
  }
  
  lastCount = newUsers.size();
}

// checks the new list against the old list and 
// drops users who have disconnected
void chatDso::removeOldUsers(vector<duser*> newList) {
  allUsers.clear();
  for(unsigned int i = 0; i < newList.size(); i++)
    allUsers.push_back(newList[i]->getName());
  
  return;
}


/*********************************
 *	    Callbacks
 ********************************/

// sends the message out to the server to be sent to the appropriate group
static void sendMessage_callback(Fl_Widget*, Messenger* messenger) {
	
  if(Send->value() && strcmp(Send->value(),"") != 0) {
    
    char message[SIZE];
    sprintf(message,"%s: %s", user, Send->value());

    if(strlen(message) < SIZE){
      
      ((Fl_Browser*) curConvWin->value())->add(message);
      ((Fl_Browser*) curConvWin->value())->bottomline( ((Fl_Browser*) curConvWin->value())->size());
      
      messenger->setTo(curConvWin->value()->label());
      messenger->setMessage("0toChat");
      messenger->addString(message);
      messenger->SendMessage();

    } else 
	((Fl_Browser*) curConvWin->value())->add("@C1@b@iError: Message too big, try again.\n");

    Send->value("");
  }
}

// gets the current data from a location in the list
// for debugging purposes
static void rightClick_callback(Fl_Menu_Button* mb, void*) {
  int userIndex = curUserList->value();
  int convIndex = curConvList->value();

  printf("E:curUserList = %i, curConvList = %i\n", userIndex, convIndex);
  
  if(convIndex > 0){
    groupData *tmp = (groupData*) curConvList->data(convIndex);
    if(tmp)
      printf ("E:curConvIndex = %i, groupName = %s, creator = %s, memberName = %s\n", 
		      convIndex,tmp->groupName.c_str(),tmp->creatorName.c_str(),tmp->memberName.c_str());
    else printf("E:NULL\n");
  }

  if(userIndex > 0)  
    printf("E:curUserIndex = %i, data = %s\n", userIndex, (char*) curUserList->data(userIndex));
}

/***********************************
 *	    Menu Callbacks
 **********************************/
void addConv_callback(Fl_Widget*, int i);
int addConvWin(char*);
int addConv(groupData*);
void addUserToGroup_callback(Fl_Widget*, void*);

// add selected user to a new group chat
void addUserToNewGroup_callback(Fl_Widget*, void*) {
//  int userIndex = curUserList->value();
  int userIndex;
  int winIndex;
  char *convName = (char*) fl_input("Add selected names to group:\n", NULL);

  for (userIndex = 1; userIndex <= curUserList->size(); userIndex++){
//////
    if(curUserList->selected(userIndex)){//userIndex > 0) {
    //-----
//      char *convName = (char*) fl_input("Add selected names to group:\n", NULL);
      if(convName && strlen(convName) > 0) {
      
	// check to see if group is part of curConvList
	int convIndex = findConv(convName);
	printf("E:found index %i for %s\n", convIndex, convName);
	if(convIndex > 0){
	
	  // if group is already found, attempting to add member anyway
	  curConvList->value(convIndex);
	  addUserToGroup_callback(NULL,NULL);
	  return;
	}
      
	// if group is not found, add to list and add chat window with group name
	printf("E:group NOT found, adding \"%s\"\n", convName);
	curConvList->add(convName);
	groupData* newGroup = new groupData;
	if(newGroup){
	  newGroup->groupName = convName; 
	  newGroup->creatorName = user;
	  newGroup->memberName = newGroup->groupName;
	  curConvList->data(curConvList->size(),(void*) newGroup);
	  curConvList->value(curConvList->size());
	  winIndex = addConvWin(convName)-1;
	  // that works
	  ((Fl_Browser*)curConvWin->child(winIndex))->labelcolor(0);
	  addUserToGroup_callback(NULL, NULL);
	  curConvWin->redraw();
	}
      } else printf("E:Canceled\n");

      convName = NULL;      
    //-----
    }
//////
  }
}

static bool addUserToGroup(char* tmpName, int convIndex) {
    char name[SIZE];
      
    printf("E:addUserToGroup name = %s\n", tmpName);
    sprintf(name,"@b@i@.\t%s",tmpName);

    // check to see if user is already part of the group
    if(findUserInGroup(convIndex, tmpName) > 0){
      printf("E:already in list\n");
      return false;
    }
    
    // add user to list
    curConvList->insert(convIndex+1,name);
        
    groupData* newGroup = new groupData;
    if(newGroup){
      printf("E:inside addUserToGroup_callback, getFrom = %s\n", par->getFrom().c_str());
      newGroup->groupName = ((groupData*)curConvList->data(convIndex))->groupName;
      newGroup->creatorName = ((groupData*)curConvList->data(convIndex))->creatorName;// user;
      newGroup->memberName = tmpName;
      curConvList->data(convIndex+1, (void*)newGroup);
    
      // this works	
      // code to change color of conv window to show it is a group conv
      int groupIndex = findConvWin(newGroup->groupName.c_str());
      if(groupIndex > 0) {
	//((Fl_Browser*)curConvWin->child(groupIndex))->labelcolor(0);
	curConvWin->redraw();		  
      }
    }
    newGroup = NULL;
    return true;
}

// adds user to a group conversation
void addUserToGroup_callback(Fl_Widget*, void*) {

  int userIndex,// = curUserList->value(),
      convIndex = curConvList->value();
  char name[SIZE],
       message[SIZE],
       *tmp = NULL;
 
  //printf("E:convIndex = %i, userIndex = %i\n", convIndex, userIndex);
  for (userIndex = 1; userIndex <= curUserList->size(); userIndex++) {
////
    if(curUserList->selected(userIndex)){
    //-----
      if(convIndex == 0|| convIndex == 1){
	printf("E:%s is already in group 'everyone'\n",curUserList->text(userIndex));
	return;
      }

      // adds selected buddy to an already selected group
      if(userIndex > 0 && convIndex > 0) {
    
	if(curConvList->text(convIndex)[2] == '4' ||
	  curConvList->text(convIndex)[3] == 'i' ||
	  curConvList->text(convIndex)[2] == '1') {
	  printf("E:NO, you cannot add %s to %s.\n",
		      curUserList->text(userIndex), curConvList->text(convIndex));
	  return;
	}
   
	tmp = (char*) curUserList->data(userIndex);
	if(!addUserToGroup(tmp, convIndex)) return;
	printf("E:after addUserToGroup, in addUserToGroup_callback\n");
    
	// change the font of group to show that it is a group
	sprintf(name,"@b@.%s", ((groupData*) curConvList->data(convIndex))->groupName.c_str());
	curConvList->text(convIndex, name);
		
	sprintf(message,"%s\tmembers=%s,",
		    ((groupData*)curConvList->data(convIndex))->groupName.c_str(),user); 
	for (int i = convIndex+1; i <= curConvList->size(); i++) {
	  if(curConvList->text(i)[2] != '4' ||
	    curConvList->text(i)[3] != 'i') {
	    printf("E:%s\n", curConvList->text(i));
	    sprintf(message,"%s%s,",message, ((groupData*)curConvList->data(i))->memberName.c_str());
	  }
	}
    
	printf("E:join group message = \"%s\"\n", message);
	if(mess) {
	  mess->setTo((char*)curUserList->data(userIndex));
	  printf("E:setTo = \"%s\"\n", (char*)curUserList->data(userIndex));
	  mess->setMessage("1toJoinGroup");
	  mess->addString(message);
	  mess->SendMessage();
	}
      }else printf("E:Nope\n");
    }
  //----
  }
////
  tmp = NULL;
}

// adds a new conversation to the curConversation list
// different int i values are passed to specify what type of
// addition is made
// i == 0 
// i == 1
void addConv_callback(Fl_Widget*, int i) {
  
  char *tmp = NULL;
//  int userIndex = curUserList->value();
//  printf("E:index = %i\n",userIndex);
  int userIndex;
 
  for (userIndex = 1; userIndex <= curUserList->size(); userIndex++){
////
    if(curUserList->selected(userIndex) &&
      (strcmp((char*)curUserList->data(userIndex),user) != 0 )) {
    //-----
      if(i == 0 && userIndex > 0){
	// color text red italic
	tmp = (char*)curUserList->data(userIndex);
	printf("E:<<0>>addConv_cb from userList tmp = %s\n", tmp);
    
      } else if(i == 1){
	// color needs to be black
	tmp = (char*) fl_input("Enter the name of the new chat session:  ");
	printf("E:<<1>>addConv_cb from convList tmp = '%s'\n", tmp);
      }

      if(tmp && strlen(tmp)>0) {
    
	// search conversation name against the list, it returns > 0, it found
	// something and can exit, else did not find anything and continue to add
	if(findConv(tmp) >= 0) { 
	  printf("E:Already in list\n");
	  tmp = NULL; return;
	}
	  
	groupData *newConv = new groupData;
	if(i>1) newConv->creatorName = par->getFrom();
	else newConv->creatorName = user;
	newConv->groupName = tmp;
	newConv->memberName = tmp;
  
	// adds the new group to the curConvList
	printf("E:>>>>>>addConv\n");
	int convIndex = addConv(newConv);
    
	// adds the group conv screen to curConvWin
	printf("E:>>>>>>addConvWin\n");
	int winIndex = addConvWin(tmp)-1;

	//  changes the color of the conv in curConvWin 
	if(i>0)changeWinColor(winIndex,convIndex);

      } else printf("E:Cancled\n");
    //-----
    }
////
  }
}

// changes the color on a conv win to black to show that
// is it now a group chat and not a 1on1 conv
void changeWinColor(int winIndex, int convIndex){
  ((Fl_Browser*)curConvWin->child(winIndex))->labelcolor(0);
     
  if(convIndex>0){ 
    char buf[SIZE];
    groupData *tmp = (groupData*)curConvList->data(convIndex);
    if(tmp){
      sprintf(buf, "@b@.%s", ((groupData*)curConvList->data(convIndex))->groupName.c_str());
      curConvList->text(convIndex, buf);
    }

    tmp = NULL;
  }

  curConvWin->redraw();  
}

// does the actual addition of the group to the curConvList
// *** this works ***
int addConv(groupData* newGroup) {
  if(!newGroup) return -1;
  else {
    char convName[SIZE];
    if(convName) {
      sprintf(convName, "@C1@b@i@.%s", newGroup->groupName.c_str());
      curConvList->add(convName);
    }
    
    int index = curConvList->size();
    curConvList->data(index, (void*)newGroup);
  }

  return curConvList->size();
}

// remove all current conversations
// *** this works ***
void removeAllConv_callback(Fl_Widget*, void*) { 
	
  if(curConvList->children() > 1){
    int i;

    // loop through and select all groups to send drop messages to
    // their members
    printf("E:going to loop through list\n");
    for (i = 2; i < curConvList->size(); i++){
      printf("E:%i %s\n", i, curConvList->text(i));
      if(((groupData*)curConvList->data(i))->groupName ==
	 ((groupData*)curConvList->data(i))->memberName){
	curConvList->select(i);
	printf("E:selecting %i %s\n",i, curConvList->text(i));
	printf("------\n");
	sendDropNotices(i);
	printf("------\n");
      }	
    }
    printf("E:end going through loop\n");
   
    // clears everything from the curConvList 
    curConvList->clear();

    // loops through all curConvWin and deletes them as well
    for (i = curConvWin->children(); i > 0; i--){	    
      curConvWin->remove(curConvWin->child(i));
    }
    
    // adds back the group 'everyone' because everyone is
    // always allowed to talk to everyone else, users cannot
    // delete it nor remove members from it
    curConvList->add("@b@.everyone");
    groupData* newData = new groupData;
    if(newData){
      newData->groupName = "everyone";
      newData->creatorName = "everyone";
      newData->memberName = "everyone";
      curConvList->data(1,(void*)newData);
    }
    
    curConvWin->redraw();
  }
}

// removes selected members of group at the index int index;
static void removeSelectedMembers (int index){
  groupData* tmp = NULL;
  for (int i = index;i<=curConvList->size();i++) { 
    if(curConvList->selected(i)){
      printf("E:yes %i is within size and is selected\n",i);
      printf("E:%i %s\n", i, curConvList->text(i));
      tmp = (groupData*) curConvList->data(i);
      if(tmp->groupName == tmp->memberName){
	printf("E:appartently %s == %s\n", tmp->groupName.c_str(), tmp->memberName.c_str());
	break;
      } else { 
	printf("E:attempting to delete %s\n", tmp->memberName.c_str());
	curConvList->remove(i);
       	i--;
      } 
    }  
  }
  curConvList->redraw();
}

// removes a selected conversation from the Conv list along
// with the associated chat screen
// *** most likely works ***
void removeSelectedConv_callback(Fl_Widget*, void*) {
  
  if(curConvList->size() < 1) return;
 
  // loop through entire list looking for selected groups to be deleted 
  // outer loop
  for (int p = 2; p <= curConvList->size(); p++) {
    // check if selected
    if(curConvList->selected(p) == 1) {
      // check if child
      if(curConvList->text(p)[2] == '4'|| curConvList->text(p)[3] == 'i') {
	// loop backwards to top of group that the member selected
	// is associated with
	int i;

	for (i = p; curConvList->text(i)[2] == '1' || curConvList->text(i)[3] == '.' ; i--);
	p = i-1;
      }

      //send notices to all members of the selected groups 
      //that either...
      //1) the conversation is closed to them
      //2) or the conversation has be closed by the creator
      //3) or someone is dropping themselves from the group
      printf("E:message = %s\n", par->getMessage().c_str());
      if(par->getMessage()!= "4toDropUser"){
        printf("*****\n");
        sendDropNotices(p); 
        printf("*****\n");
      }

      // if there are group members associated with a selected group
      // loop through those and delete them as well
      deleteGroupMembers(p+1);
      
      // find an associated group chat screen from the curConvWin
      int index = findConvWin(((groupData*)curConvList->data(p))->groupName.c_str());

      // do the actual removing of the group name from the list
      curConvList->remove(p);
     
      // delete the group chat screen from the curConvWin
      if(index > 0) curConvWin->remove(curConvWin->child(index));
      p--;
    }
  }
  curConvWin->redraw();
}

// removes the members for a particular group
// int index should be the index of the first group member
static void deleteGroupMembers(int index) {
  if(index <= curConvList->size()){

    // if there are group members associated with a selected group
    // loop through those and delete them as well
    for (int memberIndex = index; curConvList->text(memberIndex)[2] == '4'||// was p+1
				curConvList->text(memberIndex)[3] == 'i'; memberIndex++) {
      curConvList->remove(memberIndex);
      memberIndex--;
      if(memberIndex >= curConvList->size()) break;
    }
  }
}

// not done
void dropUser_callback(Fl_Widget*, void*) {
  int index = curConvList->value();
  if(index>0) {
    if(((groupData*)curConvList->data(index))->creatorName != user){
	fl_alert("You are not the creator of this group, thus you do not"\
		 " have permission to delete it nor any of it's members.");
	return;
    }
    
    char buf[SIZE];
    sprintf(buf,"%s", (char*)curConvList->text(index));
    if(buf[2] == '4' || buf[3] == 'i'){
      if(fl_ask("Are you sure you want to drop them from group %s?\n",
		((groupData*)curConvList->data(index))->groupName.c_str())){
	
	printf("E:start sendDropNotices~~~~~\n");
	sendDropNotices(index);
	printf("E:end sendDropNotices~~~~~\n");

	printf("E:starting removeSelectedMembers\n");
	removeSelectedMembers(index);
	printf("E:end removeSelectedMembers\n");
      }
      
    }else if(fl_ask("Do you want to drop the whole group?"))
	removeSelectedConv_callback (NULL,NULL);
  }
}
// sends messages to all members of a group at int index notifying
// them that they have been dropped from that group
static void sendDropNotices(int index) {
  int i;
  bool isNotEqual = (((groupData*)curConvList->data(index))->creatorName != user);
  if(index < curConvList->size()) i = curConvList->size()+1;
  else i = curConvList->size();

  // check to see if what was selected is a group
  if(curConvList->text(index)[3] == '.') {
      
    printf("E:sending dropNotices to all members of group %s\n", curConvList->text(index));

    // checks to see if group selected was created by the user, if so, send
    // 4toDropUser message, if not send the 5toDropSelf message
    //if(((groupData*)curConvList->data(index))->creatorName != user) {
    if(isNotEqual){
      printf("E:notifying members of group %s that you are dropping yourself.\n",
	    curConvList->text(index));
      mess->setMessage("5toDropSelf");

    }else {
      mess->addString("all");
      mess->setMessage("4toDropUser");
    }

  // else what was selected was a group member and a notice will be
  // sent to them saying they are dropped
  }else{
    printf("E:dropping a member\n");
    //checking to see if you have the authority to drop the user
    //if(((groupData*)curConvList->data(index))->creatorName != user) {
    if(isNotEqual){
      printf("E: you do not have the authority to drop %s from this group\n",
	      curConvList->text(index));
      return;
    }else mess->setMessage("4toDropUser");
    
    printf("E:sending dropNotice to member %s\n",curConvList->text(index));
    mess->addString(((groupData*)curConvList->data(index))->memberName);
  }
  
  mess->setTo(((groupData*)curConvList->data(index))->groupName);
  mess->SendMessage();
}

// when selecting a conversations from list it brings up that
// main chat window to the foreground
static void selectCurConv_callback (Fl_Multi_Browser*, void *) {
  int index = curConvList->value();
  if(index > 0) {
    if(curConvList->text(index)[2] == '1') {
      printf("E:one on one\n");
    } else if(curConvList->text(index)[5] == '.' ||
	      curConvList->text(index)[8] == '.') {
      
      for(int i = index; i > 0; i--) {
        if(curConvList->text(i)[3] == '.'){
	  index = i;
	  break;
	}
      }
    }
    
//    printf("E:in selectCurConv\n");
    int convWinIndex = findConvWin(((groupData*)curConvList->data(index))->groupName);
    if(convWinIndex >= 0){
      curConvWin->value(curConvWin->child(convWinIndex));
    }
  }
}

// hides the window
static void hide_callback(Fl_Button *, Fl_Window* guiWin) { guiWin->iconize(); }

// creates the chat gui
void chatDso::make_window(){

  { Fl_Window* o = new Fl_Window(520, 355, myName.c_str());
    guiWin = o;
    { Fl_Tabs * o = curConvWin = new Fl_Tabs(10, 5, 350, 210);
      { Fl_Browser* o = Conversation = 
        new Fl_Browser(15, 30, 340, 180, "everyone");
        o->type(FL_MULTI_BROWSER);
        o->align(FL_ALIGN_TOP_LEFT);
        o->box(FL_DOWN_BOX);
        o->labeltype(FL_ENGRAVED_LABEL);
        o->color(44);
        o->hide();
      }
      o->end();
    }
    { Fl_Input* o = Send = new Fl_Input(10, 235, 350, 85, "Send Message:");
      o->type(4);
      o->labeltype(FL_ENGRAVED_LABEL);
      o->align(FL_ALIGN_TOP_LEFT);
      o->maximum_size(SIZE);
      o->callback((Fl_Callback*)sendMessage_callback,(void*)messenger);
      o->when(FL_WHEN_ENTER_KEY);
    }
    { Fl_Multi_Browser *o = curUserList = 
	    new Fl_Multi_Browser(365, 25, 145, 90,"Who is Logged In:");
      o->labeltype(FL_ENGRAVED_LABEL);
      o->align(FL_ALIGN_TOP_LEFT);
    } 
    { Fl_Multi_Browser *o = curConvList = 
	    new Fl_Multi_Browser(365, 135, 145, 185, "Talking To:");
      o->labeltype(FL_ENGRAVED_LABEL);
      o->align(FL_ALIGN_TOP_LEFT);
      o->add("@b@.everyone");
      o->callback((Fl_Callback*)selectCurConv_callback);
    }
    { Fl_Button* o = new Fl_Button(320, 325, 90, 25, "Send"); 
      o->labeltype(FL_ENGRAVED_LABEL);
      o->callback((Fl_Callback*)sendMessage_callback, (void*)messenger);
    }
    { Fl_Button* o = new Fl_Button(420, 325, 90, 25, "Hide");
      o->labeltype(FL_ENGRAVED_LABEL);
      o->callback((Fl_Callback *)hide_callback,(void*)guiWin);
    }
    
    /* right click menus */
    
    // for the users logged in
    { Fl_Menu_Button *o = new Fl_Menu_Button(365, 135, 145, 185);    // 365, 235, 145, 85
      o->type(Fl_Menu_Button::POPUP3);
      o->menu(curConvRightClick);
      o->callback((Fl_Callback*)rightClick_callback);
    }
    // for the current conversations
    { Fl_Menu_Button *o = new Fl_Menu_Button(365, 25, 145, 90);    // 365, 25, 145, 190
      o->type(Fl_Menu_Button::POPUP3);
      o->menu(curUserRightClick);
      o->callback((Fl_Callback*)rightClick_callback);
    }
    o->end();
  }
  guiWin->show();
}

/*******************************************
 *	      Helper Functions
 ******************************************/
static void changeUserColor(int index, string name){
  printf("E:Inside changeUserColor index %i\n", index);
  char tmp[SIZE];
  sprintf(tmp,"@C4@b@i@.\t%s", name.c_str());
  curConvList->text(index,tmp);
  curConvList->redraw();
  printf("E:end changeUserColor\n");
}

// accepting an invitation to join a group, adds the 
// chat screen to curConvWin, and adds the group to the curConvList
void acceptInvite (groupData* acceptedGroup){

  mess->setTo(acceptedGroup->groupName.c_str());
  mess->setMessage("2toAcceptGroup"); 
  mess->SendMessage();

  //add conv to curConvList and curConWin
  int index = findConv(acceptedGroup->groupName.c_str());
  if(index >= 0) return;
  
  int convIndex = addConv(acceptedGroup);
  int winIndex = addConvWin((char*)acceptedGroup->groupName.c_str())-1;

  curConvList->value(convIndex);
  par->getLine('=');
  string member = par->getLine(',');
  string lastMember;
  
  while(member != lastMember){

    addUserToGroup((char*)member.c_str(),convIndex);
    printf("changing color for member %s at index %i\n", 
	    member.c_str(), convIndex+1);
    changeUserColor(convIndex+1, member.c_str());
    
    lastMember = member;
    member = par->getLine(',');
    
  }

  printf("E:done adding members to group\n");
 // addUserToGroup(user,convIndex);
 // changeUserColor(convIndex+1, user);
  changeWinColor(winIndex,convIndex);
}

// sends a message that you decline a group chat invite
void declineInvite (groupData* declineGroup) {
  printf("E:decline\n");
  mess->setTo(declineGroup->creatorName.c_str());
  mess->setMessage("3toRejectGroup");
  mess->SendMessage();
}

// adds a new chat window to curWinList
int addConvWin(char* tmp) {

  static bool colorFlag = false;

  { Fl_Browser* o = new Fl_Browser(15, 30, 340, 180, strdup(tmp));
    o->type(FL_MULTI_BROWSER);
    o->align(FL_ALIGN_TOP_LEFT);
    o->box(FL_DOWN_BOX);
    o->labeltype(FL_ENGRAVED_LABEL);
    o->labelcolor(1);		  // blue font	4);
    o->labelfont(2);		  // italic font
    if(colorFlag) o->color(44);
    colorFlag = !colorFlag;
    o->hide();
    
    curConvWin->add(o);
  }
    
  curConvWin->redraw();
  
  return curConvWin->children();  
}

/*************** DTK C++ DSO loader/unloader functions ***********/
/*
 * All DTK DSO files are required to declare these two functions.
 * These function are called by the loading program to get your
 * C++ objects loaded.
 *
 *****************************************************************/

static dtkAugment *dtkDSO_loader(dtkManager *manager, void *p)
{
  dpf *app = static_cast<dpf *>(manager);
  return new chatDso(app);
}

static int dtkDSO_unloader(dtkAugment *augment)
{
  delete augment;
  return DTKDSO_UNLOAD_CONTINUE;
}

