// generated by Fast Light User Interface Designer (fluid) version 1.0011
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "chatDso.h"
#include "chatDso-Menu.h"

#include <FL/Fl_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Browser.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Multi_Browser.H>
#include <FL/Fl_Scrollbar.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Group.H>
#include <FL/fl_ask.H>

Fl_Input *Send=(Fl_Input *)0;			    // widget where user types message
Fl_Tabs *curConvWin=(Fl_Tabs *)0;		    // the tabs of current open conversations
Fl_Browser *Conversation=(Fl_Browser *)0;	    // might not be needed
Fl_Multi_Browser *curUserList=(Fl_Multi_Browser*)0; // lists the current logged in computers
Fl_Multi_Browser *curConvList=(Fl_Multi_Browser*)0; // lists the current conversations and who
						    // is in which group
static Messenger* mess = NULL;
static char user[SIZE];
static void acceptInvite (groupData);
static void declineInvite (groupData);

/*********************************
 *	  Class Methods
 ********************************/

// CLEAN
chatDso::chatDso(dpf* app_in):
  dtkAugment("chatDso"){
  app = app_in;
  client = NULL;
  messenger = NULL;
  parser = NULL;
  guiWin = NULL;
  validate();
}

// CLEAN
chatDso::~chatDso() {
  if(guiWin) {
    delete guiWin;
    guiWin = NULL;
  }

  if(client) {
    delete client;
    client = NULL;
  }

  if(messenger) {
    delete messenger;
    messenger = NULL;
    mess = NULL;
  }

  if(parser) {
    delete parser;
    parser = NULL;
  }
}

// CLEAN
int chatDso::postConfig() {
  
  // connects to the server 
  if(!connectToClient()){
    printf("E:ERROR: Unable to connect to client\n");
    return DTK_CALLBACK_ERROR;
  }
 
  // creates object that sends messages to sharedMem segment
  // called genMessage
  messenger = new Messenger("genMessage");
  mess = messenger;
  if(!messenger) {
    printf("E:ERROR: Unable to create Messenger object.\n");
    return DTK_CALLBACK_ERROR;
  }
  
  // creates object that parses the messages from the sharedMem
  // segment called genMessage
  parser = new MessageParser("genMessage");
  if(!parser) {
    printf("E:ERROR: Unable to create MessageParser object.\n");
    return DTK_CALLBACK_ERROR;
  }

  // creates the gui
  make_window();//this);
  if(!guiWin){
    printf("E:ERROR: Unable to create gui\n");
    return DTK_CALLBACK_ERROR;
  }

  // makes the list of Users
  makeList();
  
  // setting from who all the messages will be from, me
  messenger->setFrom(user);	

  // sets the data for group conversation 'everyone'
  groupData* newData = new groupData;
  if(newData){
    newData->groupName = "everyone";
    newData->creatorName = "everyone";
    curConvList->data(1,(void*)newData);
  }

  return DTK_REMOVE_CALLBACK; 
}

// CLEAN
// checks each frame for new information
int chatDso::postFrame() {
  static int i= 0;
  check();
  Fl::check();
  i++;
  return DTK_CONTINUE;
}

// CLEAN
// finds a conversation win associated with the string 'curConv'
int findConvWin(string curConv) {

  int i;
  Fl_Group* tmp = NULL;
  for(i = 0; i < curConvWin->children(); i++) {
    tmp = (Fl_Group*)curConvWin->child(i);
    if(tmp && curConv == ((Fl_Browser*)tmp)->label()){
      printf("E:found conv win: %s at index = %i\n", curConv.c_str(),i);
      return i;
    }
  }

  return i-1;
}

// given a name group conv, this functions searches through the 
// list of current conversations to find the specified one and 
// returns the index or -1 if not found
int findConv(string conv) {
	
  if(conv == user){
    printf("E:<<<its me>>>\n");
    return 0;
  }

  int i;
  for(i = curConvList->size(); i > 0; i--){
    if(curConvList->text(i)[3] == '.') {
      if(((groupData*)curConvList->data(i))->groupName == conv)
        return i; 
    }
  } 
  return -1;
}


int findUserInGroup(int groupIndex, string userName) {
  printf("E:start findUserInGroup\n");
  printf("E:size = %i, index = %i\n", curConvList->size(), groupIndex);
  int i;
  for(i = groupIndex+1;i<=curConvList->size();i++) {
    printf("\tE:%i %s\n", i, curConvList->text(i));
    if(curConvList->text(1)[4] != '.'){
      printf("E:found a user at index = %i... now testing userName = %s vs. data=\"%s\"\n",
	      i,userName.c_str(), ((groupData*)curConvList->data(i))->groupName.c_str());
      if(((groupData*)curConvList->data(i))->groupName == userName){
	printf("E:end findUserInGroup found user at index %i\n", i);
	return i;
      }
    }else if(curConvList->text(i)[3] == '.'){
      printf("E:else\n");
      break;
    }
  }
  i = -1; 
  printf("E:end findUserInGroup: found nothing\n");
  return i;
}

// check to see of there is something to display
bool chatDso::check() {
	
  char buf[SIZE];
  char added[SIZE];

  // refresh the list of users
  makeList();
 
  // get messages from the server 
  string message;

  // unable to read message
  if(parser->NextMessage() < 0){
//    printf("E:No New messages\n");
//    printf("E:Last Message = %s\n", parser->getMessage().c_str());    
    return false;
  }

  if(parser->getFrom() == user){
    printf("E:message from me ignoring\n");
    return false;
  }
 
  string forMe = parser->getTo();
  printf("E:forme = %s\n", forMe.c_str());

  // checking through all groups to see if message is for me
  if(findConv(forMe.c_str()) >= 0) {
    string tmp = parser->getMessage();	// gets the statement
    printf("E:checking what the message is %s\n", tmp.c_str());

    // switch statement to figure out what type of message it is    
    switch(tmp.at(0)) {
      
      // message "0toChat" for chatting
      case('0'):{
		sprintf(buf, "%s",parser->getLine().c_str());
		sprintf(added,"@C4@b@.-%s-\n", buf);
		
		// code to find the correct conversation to put message in
		int i = findConvWin(forMe);
		if (i >= 0){
		  
		  Fl_Group* tmp = (Fl_Group*) curConvWin->child(i);
		  if(tmp){
		    //tmp->color(3);
		    ((Fl_Browser*) tmp->child(0))->add(added);
		  }
		}
		break;
      }
      
      // message "1toJoinGroup" to invite you to join a group chat		
      case('1'):{
		groupData newGroup;
		newGroup.groupName = parser->getString();
		newGroup.creatorName = parser->getFrom();
	        
		if(fl_ask("You are asked to join group \"%s\".\nDo you accept?",
					newGroup.groupName.c_str()))
		  
		  acceptInvite(newGroup);
		  
		else declineInvite(newGroup);
    		break;
      }
      
      // message "2toAcceptGroup" informing you that a user accepted your group invite
      case('2'):{
	        printf("E:User %s has accepted invitation to join group %s\n", 
		      parser->getFrom().c_str(), parser->getTo().c_str());
	
		//code to change color of user on curConvList to show accepted
		int groupIndex = findConv(parser->getTo());
		if(groupIndex > 0) {
		  int userIndex = findUserInGroup(groupIndex, parser->getFrom());
		  if(userIndex > 0){
		    char tmp[SIZE];
		    sprintf(tmp,"@C4@b@i@.\t%s", parser->getFrom().c_str());
		    curConvList->text(userIndex, tmp);
		    curConvList->redraw();
		  }
		}
		break;
      }
      
      // message "3toRejectGroup"informing you that a user declined your group invite
      case('3'):{
		char message[SIZE];
		sprintf(message,"@C1@i@.%s declined your invitation to join group %s\n",
				parser->getFrom().c_str(), parser->getTo().c_str());

		// post decline message to the conversation board that currently has focus
		Fl_Group* tmp = (Fl_Group*) curConvWin->value();
	        if(tmp) ((Fl_Browser*) tmp->child(0))->add(message);

		// add code to drop name from group

		break;
      }
      
      // message "4toDropUser" informing you that you have been dropped from group
      case('4'):{  
	        fl_alert("This is a notice that you are being dropped from group \"%s\".", 
				parser->getTo().c_str());
		// add code that removes the group name from your lists
		break;
      }
 
      // message "5toDropSelf" informing you that member of one of your groups has dropped
      case('5'):{
		printf("E:User %s has dropped from group\n", parser->getFrom().c_str());
		// add code that removes that user from the groups
		break;
      }

      
      // message "disconnect" if someone disconnects		
      case('d'):{  
      	        string droppedUser = parser->getString();
		//printf("E:%s has left the building.\n", droppedUser.c_str());
	        sprintf(buf,"@C1@i%s has left the building.\n",droppedUser.c_str());
		Conversation->add(buf);
	
/*		usleep(3000);	
		printf("E:before makeList from 'd'\n");
		makeList();
		printf("E:after makeList from 'd'\n");
*/
		break;
      }

      // else message was unrecognizable	
      default:	printf("E:Unrecognized message = %s\n", message.c_str()); return false; break;
    }

  } else printf("E:Not for me: message = %s\n", message.c_str()); return false;

  return true;
}

// searches through list of users 'allUsers' to find
// string name
int chatDso::usersIndex(string name) {
  unsigned int i;
  for (i = 0; i < allUsers.size(); i++) {
    if(allUsers[i] == name){
      return i;
    }
  }

  return -1;
}

// CLEAN
// connects to shared mem
bool chatDso::connectToClient() {
  
  gethostname(user, SIZE);
  myName = user;
  
  client = (dclient*) app->check("dclient");
  if(!client) {
    printf("E:Could not get client\n");
    return false;    
  }

  return true;    
}

// loads the list of logged in users into the gui
void chatDso::makeList() {

  client = (dclient*) app->check("dclient");
  if(!client){
    printf("E:end makeList client NULL\n");
    return;
  }
  
  vector<duser*> newUsers = client->getUsers();
  static unsigned int lastCount = 0;
  
  printf("makeList check: lastCount = %i vs. newUsers.size() = %i\n", 
		    lastCount, newUsers.size());
  // if the newlist is different size then the old list, then true
  // to allow old list to updated
  if(newUsers.size() != lastCount) {
    printf("E:different size\n");
  
    // clear current list of logged in Users
    curUserList->clear();
    //curUserList->redraw();

    // removes old users
    printf("remove old users:lastCount = %i vs. newUsers.size() = %i\n", 
		    lastCount, newUsers.size());
    if(lastCount > newUsers.size()){	// was <
      printf("E:before removeOldUsers\n");
      removeOldUsers(newUsers);
      printf("E:after removeOldUsers\n");
    }
  
    // look throught a refreshed list of users and check
    // to see who has been added or dropped
    unsigned int i;
    for (i = 0; i < newUsers.size(); i++) {
      
      int index = usersIndex(newUsers[i]->getName()); 
      if(index < 0) {
	string userName = newUsers[i]->getName();

	allUsers.push_back(userName);
	char buf[SIZE];
	sprintf(buf,"@C1@i%s just joined our little party.\n", userName.c_str());
	Conversation->add(buf);
      }
    }

    // redraw curUserList with the updated list
    for (i=  0; i < allUsers.size(); i++){
      char buf[SIZE];
      sprintf(buf, "@C4@b@.%s", allUsers[i].c_str());
      curUserList->add(buf);
      curUserList->data(i+1, (void*)allUsers[i].c_str());
    }
  }
  
  lastCount = newUsers.size();
}

// checks the new list against the old list and 
// drops users who have disconnected
void chatDso::removeOldUsers(vector<duser*> newList) {
  allUsers.clear();
  printf("E:the new list is...\n");
  for(unsigned int i = 0; i < newList.size(); i++){
    allUsers.push_back(newList[i]->getName());
    printf("E:newList[%i] = %s allUsers[%i] = %s\n", i,newList[i]->getName().c_str(),
		   i, allUsers[i].c_str());
  }
  
  printf("E:end removingOldUsers\n");
  return;
}


/*********************************
 *	    Callbacks
 ********************************/

// sends the message out to the server to be sent to the appropriate group
static void sendMessage_callback(Fl_Widget*, Messenger* messenger) {
	
  if(Send->value() && strcmp(Send->value(),"") != 0) {
    
    char message[SIZE];
    sprintf(message,"%s: %s\n", user, Send->value());
    
    if(strlen(message) < SIZE){
      
      Fl_Group* tmp = (Fl_Group*) curConvWin->value();
      if(tmp){
	((Fl_Browser*) tmp->child(0))->add(message);
	((Fl_Browser*) tmp->child(0))->bottomline( ((Fl_Browser*) tmp->child(0))->size());
      }
      
      messenger->setTo(curConvWin->value()->label());
      messenger->setMessage("0toChat");
      messenger->addString(message);
      messenger->SendMessage();

    } else {
      Fl_Group* tmp = (Fl_Group*) curConvWin->value();
      if(tmp)
	((Fl_Browser*) tmp->child(0))->add("@C1@b@iError: Message too big, try again.\n");
    }

    Send->value("");
  }
}

static void rightClick_callback(Fl_Menu_Button* mb, void*) {
  int userIndex = curUserList->value();
  int convIndex = curConvList->value();

  printf("E:curUserList = %i, curConvList = %i\n", userIndex, convIndex);
  
  if(convIndex > 0){
    groupData *tmp = (groupData*) curConvList->data(convIndex);
    if(tmp)
      printf ("E:curConvIndex = %i, data = %s\n", convIndex,tmp->groupName.c_str());
    else printf("E:NULL\n");
  }

  if(userIndex > 0)  
    printf("E:curUserIndex = %i, data = %s\n", userIndex, (char*) curUserList->data(userIndex));
}

/***********************************
 *	    Menu Callbacks
 **********************************/
void addConv_callback(Fl_Widget*, int i);
int addConvWin(char*);
bool addConv(groupData*);
void addUserToGroup_callback(Fl_Widget*, void*);

// add selected user to a new group chat
void addUserToNewGroup_callback(Fl_Widget*, void*) {
  int userIndex = curUserList->value();
  int winIndex;

//  addUserToGroup_callback(NULL,NULL);

  if(userIndex > 0) {
    char * convName = (char*) fl_input("Add %s to group:\n",
		    NULL,(char*)curUserList->data(userIndex));
    if(convName) {
      curConvList->add(convName);
      groupData* newGroup = new groupData;
      if(newGroup){
	newGroup->groupName = convName; 
	newGroup->creatorName = user;
	curConvList->data(curConvList->size(),(void*) newGroup);
	curConvList->value(curConvList->size());
	winIndex = addConvWin(convName)-1;
	// that works
	((Fl_Group*)curConvWin->child(winIndex))->labelcolor(0);
	addUserToGroup_callback(NULL, NULL);
	curConvWin->redraw();
      }
    } else printf("E:Canceled\n");

    convName = NULL;      
  }
}

// adds user to a group conversation
void addUserToGroup_callback(Fl_Widget*, void*) {

  int userIndex = curUserList->value(),
      convIndex = curConvList->value();
  char name[SIZE],
       message[SIZE],
       *tmp = NULL;
 
  printf("E:convIndex = %i, userIndex = %i\n", convIndex, userIndex);
	       
  if(convIndex == 0) return;

  // adds selected buddy to an already selected group
  if(userIndex > 0 && convIndex > 0) {
    
    tmp = (char*) curUserList->data(userIndex);
    printf("E:addUserToGroup name = %s\n", tmp);
    sprintf(name,"@b@i@.\t%s",tmp);

    // add user to list
    curConvList->insert(convIndex+1,name);
///    
    groupData* newGroup = new groupData;
    if(newGroup){
      newGroup->groupName = tmp;
      newGroup->creatorName = user;
      curConvList->data(convIndex+1, (void*)newGroup);
    
      // this works	
      // code to change color of conv window to show it is a group conv
      printf("E:\t NOW for the group text\n");
      int groupIndex = findConvWin(newGroup->groupName.c_str());//parser->getTo());
      if(groupIndex > 0) {
	//((Fl_Group*)curConvWin->child(groupIndex))->labelcolor(0);
	printf("E:\tSuccess\n");
	curConvWin->redraw();		  
      }
    }
    newGroup = NULL;
////

    // change the font of group to show that it is a group
    sprintf(name,"@b@.%s", ((groupData*) curConvList->data(convIndex))->groupName.c_str());
    curConvList->text(convIndex, name);
		
    // print out who got added
    sprintf(message, "%s\n",((groupData*) curConvList->data(convIndex))->groupName.c_str());
    printf("E:join group message = %s\n", message);
    
    if(mess) {
      mess->setTo((char*)curUserList->data(userIndex));
      mess->setMessage("1toJoinGroup");
      mess->addString(message);
      mess->SendMessage();
    }
  }
  
  tmp = NULL;
}

// adds a new conversation to the curConversation list
void addConv_callback(Fl_Widget*, int i) {
  
  char *tmp = NULL;
  int userIndex = curUserList->value();
  printf("E:index = %i\n",userIndex);
  
  if(i == 0 && userIndex > 0){
    // color text red italic
    tmp = (char*)curUserList->data(userIndex);
    printf("E:<<0>>addConv_cb from userList tmp = %s\n", tmp);
    
  } else if(i == 1){
    // color needs to be black
    tmp = (char*) fl_input("Enter the name of the new chat session:  ");
    printf("E:<<1>>addConv_cb from convList tmp = %s\n", tmp);
    
  } else {
    printf("E:<<else>>addConv_cb from addUserToNewGroup\n"); 
    //tmp = (char*)curUserList->data(userIndex);
    //tmp = mess->getFrom().c_str();
  }

  if(tmp) {
	  
    groupData *newConv = new groupData;
    newConv->creatorName = user;
    newConv->groupName = tmp;
  
    // adds the new group to the curConvList
    printf("E:>>>>>>addConv\n");
    addConv(newConv);
    // adds the group conv screen to curConvWin
    printf("E:>>>>>>addConvWin\n");
    int winIndex = addConvWin(tmp)-1;
    if(i==1) ((Fl_Group*)curConvWin->child(winIndex))->labelcolor(0);
    curConvWin->redraw();  
  } else printf("E:Cancled\n");
  
  
}

bool addConv(groupData* newGroup) {
  if(!newGroup) return false;
  else {
    char *convName = new char[SIZE];
    if(convName) {
      sprintf(convName, "@C1@b@i@.%s", newGroup->groupName.c_str());
      curConvList->add(convName);
    }
    
    int index = curConvList->size();
    curConvList->data(index, (void*)newGroup);
//    addConvWin((char*)newGroup->groupName.c_str());
  }
  return true;
}

// remove all current conversations
void removeAllConv_callback(Fl_Widget*, void*) { 
	
  if(curConvList->children() > 1){ 
    curConvList->clear();
    for (int i = curConvWin->children(); i > 0; i--){	    
      curConvWin->remove(curConvWin->child(i));
    }
    
    curConvList->add("@b@.everyone");
    groupData* newData = new groupData;
    if(newData){
      newData->groupName = "everyone";
      newData->creatorName = "everyone";
      curConvList->data(1,(void*)newData);
    }
    
    curConvWin->redraw();
  }
}

// removes a selected conversation from the Conv list along
// with the associated chat screen
// **this works**
void removeSelectedConv_callback(Fl_Widget*, void*) {

  if(curConvList->size() < 1) return;
 
  // loop through entire list looking for selectd groups to be deleted 
  for (int p = 2; p <= curConvList->size(); p++) {
    if(curConvList->selected(p)== 1){
      if(p+1 <= curConvList->size()){
	// if there are group members associated with a selected group
	// loop through those and delete them as well
        for (int memberIndex = p+1; curConvList->text(memberIndex)[2] == '4'||
		       		    curConvList->text(memberIndex)[3] == 'i'; memberIndex++) {
	  curConvList->remove(memberIndex);
	  memberIndex--;
	  if(memberIndex >= curConvList->size()) break;
	}
      }
      
      // find and associated group chat screen from the Fl_Tabs
      int index = findConvWin(((groupData*)curConvList->data(p))->groupName.c_str());

      // do the actual removing of the group name from the list
      curConvList->remove(p);
     
      // delete the group chat screen from the Fl_Tabs 
      if(index > 0) curConvWin->remove(curConvWin->child(index));
      p--;
    }
  }
  curConvWin->redraw();
}

// not done
void dropUser_callback(Fl_Widget*, void*) {
  int index = curConvList->value();
  if(index>0) {
    char buf[SIZE];
    sprintf(buf,"%s", (char*)curConvList->text(index));
    if(buf[2] == '4' || buf[2] == '@') {
      printf("E:Do you want to drop %s\n", buf);
    } else
      printf("E:You can't drop the whole group\n");
  }
}


// when selecting a conversations from list it brings up that
// main chat window to the foreground
static void selectCurConv_callback (Fl_Multi_Browser*, void *) {
  int index = curConvList->value();
  if(index > 0) {
    if(curConvList->text(index)[2] == '1') {
      printf("E:one on one\n");
    } else if(curConvList->text(index)[5] == '.' ||
	      curConvList->text(index)[8] == '.') {
      
      for(int i = index; i > 0; i--) {
        if(curConvList->text(i)[3] == '.'){
	  index = i;
	  break;
	}
      }
    }
    
    printf("E:in selectCurConv\n");
    int convWinIndex = findConvWin(((groupData*)curConvList->data(index))->groupName);
    if(convWinIndex >= 0){
      curConvWin->value(curConvWin->child(convWinIndex));
    }
  }
}

// hides the window
static void hide_callback(Fl_Button *, Fl_Window* guiWin) { guiWin->iconize(); }

// creates the chat gui
void chatDso::make_window(){

  { Fl_Window* o = new Fl_Window(520, 355, myName.c_str());
    guiWin = o;
    { Fl_Tabs * o = curConvWin = new Fl_Tabs(10, 5, 350, 190);
      { Fl_Group *o = new Fl_Group(10, 25, 350, 190,"everyone");
	o->box(FL_FLAT_BOX);
	o->labeltype(FL_ENGRAVED_LABEL);
	o->color(44);
	o->hide();
	{ Fl_Browser* o = Conversation = 
    	    new Fl_Browser(15, 30, 340, 180);
	  o->type(FL_MULTI_BROWSER);
	  o->align(FL_ALIGN_TOP_LEFT);
	}
	o->end();
      }
      o->end();
    }
    { Fl_Input* o = Send = new Fl_Input(10, 235, 350, 85, "Send Message:");
      o->type(4);
      o->labeltype(FL_ENGRAVED_LABEL);
      o->align(FL_ALIGN_TOP_LEFT);
      o->maximum_size(SIZE);
      o->callback((Fl_Callback*)sendMessage_callback,(void*)messenger);
      o->when(FL_WHEN_ENTER_KEY);
    }
    { Fl_Multi_Browser *o = curUserList = 
	    new Fl_Multi_Browser(365, 25, 145, 90,"Who is Logged In:");
      o->labeltype(FL_ENGRAVED_LABEL);
      o->align(FL_ALIGN_TOP_LEFT);
    } 
    { Fl_Multi_Browser *o = curConvList = 
	    new Fl_Multi_Browser(365, 135, 145, 185, "Talking To:");
      o->labeltype(FL_ENGRAVED_LABEL);
      o->align(FL_ALIGN_TOP_LEFT);
      o->add("@b@.everyone");
      o->callback((Fl_Callback*)selectCurConv_callback);
    }
    { Fl_Button* o = new Fl_Button(320, 325, 90, 25, "Send"); 
      o->labeltype(FL_ENGRAVED_LABEL);
      o->callback((Fl_Callback*)sendMessage_callback, (void*)messenger);
    }
    { Fl_Button* o = new Fl_Button(420, 325, 90, 25, "Hide");
      o->labeltype(FL_ENGRAVED_LABEL);
      o->callback((Fl_Callback *)hide_callback,(void*)guiWin);
    }
    
    /* right click menus */
    
    // for the users logged in
    { Fl_Menu_Button *o = new Fl_Menu_Button(365, 135, 145, 185);    // 365, 235, 145, 85
      o->type(Fl_Menu_Button::POPUP3);
      o->menu(curConvRightClick);
      o->callback((Fl_Callback*)rightClick_callback);
    }
    // for the current conversations
    { Fl_Menu_Button *o = new Fl_Menu_Button(365, 25, 145, 90);    // 365, 25, 145, 190
      o->type(Fl_Menu_Button::POPUP3);
      o->menu(curUserRightClick);
      o->callback((Fl_Callback*)rightClick_callback);
    }
    o->end();
  }
  guiWin->show();
}

/*******************************************
 *	      Helper Functions
 ******************************************/

void acceptInvite (groupData acceptedGroup){
  printf("E:acceptInvite\n");
  mess->setTo(acceptedGroup.groupName.c_str());
  mess->setMessage("2toAcceptGroup"); 
  mess->SendMessage();

  //addConv to curConvList and curConWin
  addConv_callback(NULL,2);
  
}

void declineInvite (groupData declineGroup) {
  printf("E:decline\n");
  mess->setTo(declineGroup.creatorName.c_str());
  mess->setMessage("3toRejectGroup");
  mess->SendMessage();
}

int addConvWin(char* tmp) {

  static bool colorFlag = false;

  { Fl_Group *o = new Fl_Group(10, 25, 350, 190, strdup(tmp));
    o->box(FL_FLAT_BOX);
    o->labeltype(FL_ENGRAVED_LABEL);
    o->labelcolor(1);		  // blue font	4);
    o->labelfont(2);		  // italic font
    if(colorFlag) o->color(44);
    colorFlag = !colorFlag;
    o->hide();
    { Fl_Browser* o = new Fl_Browser(15, 30, 340, 180);
      o->type(FL_MULTI_BROWSER);
      o->align(FL_ALIGN_TOP_LEFT);
    }
    o->end();
    curConvWin->add(o);
    curConvWin->redraw();
  }

  return curConvWin->children();  
}

/*************** DTK C++ DSO loader/unloader functions ***********/
/*
 * All DTK DSO files are required to declare these two functions.
 * These function are called by the loading program to get your
 * C++ objects loaded.
 *
 *****************************************************************/

static dtkAugment *dtkDSO_loader(dtkManager *manager, void *p)
{
  dpf *app = static_cast<dpf *>(manager);
  return new chatDso(app);
}

static int dtkDSO_unloader(dtkAugment *augment)
{
  delete augment;
  return DTKDSO_UNLOAD_CONTINUE;
}

