// generated by Fast Light User Interface Designer (fluid) version 1.0011
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "chatDso.h"
#include "chatDso-Menu.h"

#include <FL/Fl_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Browser.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Multi_Browser.H>
#include <FL/Fl_Scrollbar.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Group.H>
#include <FL/fl_ask.H>

Fl_Input *Send=(Fl_Input *)0;			    // widget where user types message
Fl_Tabs *curConvWin=(Fl_Tabs *)0;		    // the tabs of current open conversations
Fl_Browser *Conversation=(Fl_Browser *)0;	    // might not be needed
Fl_Multi_Browser *curUserList=(Fl_Multi_Browser*)0; // lists the current logged in computers
Fl_Multi_Browser *curConvList=(Fl_Multi_Browser*)0; // lists the current conversations and who
						    // is in which group
static Messenger* mess = NULL;
static char user[SIZE];
static void acceptInvite (groupData);
static void declineInvite (groupData);

/*********************************
 *	  Class Methods
 ********************************/
chatDso::chatDso(dpf* app_in):
  dtkAugment("chatDso"){
  printf("E:Constructor\n");
  app = app_in;
  client = NULL;
  messenger = NULL;
  parser = NULL;
  guiWin = NULL;
  validate();
  printf("E:end constructor\n");
}

chatDso::~chatDso() {
	printf("E:~destructor\n");
  if(guiWin) {
	  printf("E:deleting guiWin\n");
    delete guiWin;
    guiWin = NULL;
  }

  if(client) {
	  printf("E:deleting client\n");
    delete client;
    client = NULL;
  }

  if(messenger) {
	  printf("E:deleting messenget\n");
    delete messenger;
    messenger = NULL;
    mess = NULL;
  }

  if(parser) {
	  printf("E:deleting parser\n");
    delete parser;
    parser = NULL;
  }
  printf("E:end ~destructor\n");
}

int chatDso::postConfig() {
  printf("E:postConfig\n");
  
  printf("E:trying to connect to server via client\n");  
  // connects to the server 
  if(!connectToClient()){
    printf("E:ERROR: Unable to connect to client\n");
    return DTK_CALLBACK_ERROR;
  }
 
  // creates object that sends messages to sharedMem segment
  // called genMessage
  printf("E:trying to get new messenger\n");
  messenger = new Messenger("genMessage");
  mess = messenger;
  if(!messenger) {
    printf("E:ERROR: Unable to create Messenger object.\n");
    return DTK_CALLBACK_ERROR;
  }
  
  // creates object that parses the messages from the sharedMem
  // segment called genMessage
  printf("tryin to get new parser\n");
  parser = new MessageParser("genMessage");
  if(!parser) {
    printf("E:ERROR: Unable to create MessageParser object.\n");
    return DTK_CALLBACK_ERROR;
  }

  // creates the gui
  printf("E:making window\n");
  make_window();//this);
  if(!guiWin){
    printf("E:ERROR: Unable to create gui\n");
    return DTK_CALLBACK_ERROR;
  }

  // makes the list of Users
  printf("E:making list from postConfig\n");
  makeList();
  printf("E:end making list from postConfig\n");
  
  // setting some misc. data
  messenger->setFrom(user);
  groupData* newData = new groupData;
  if(newData){
    newData->groupName = "everyone";
    newData->creatorName = "everyone";
    //printf("E: made it here\n");
    curConvList->data(1,(void*)newData);
    printf("E:set data for Everyone conversation\n");
  }
  printf("E:end postConfig\n");
  return DTK_REMOVE_CALLBACK; 
}

// checks each frame for new information
int chatDso::postFrame() {
  static int i= 0;
  printf("E:%i ***begin postFrame***\n", i);
  printf("E:before main check\n");
  check();
  printf("E:after main check\nE:before Fl::check()\n");
  Fl::check();
  printf("E:after Fl::check()\nE: %i\nE:endpostFrame\n",i);
  i++;
  return DTK_CONTINUE;
}

// check to see of there is something to display
bool chatDso::check() {
	
  char buf[SIZE];
  char added[SIZE];

  // refresh the list of users
  makeList();
 
  // get messages from the server 
  string message;
  printf("E:before checking\n");

  // unable to read message
  if(parser->NextMessage() < 0){
    printf("E:No New messages\n");
    printf("E:Last Message = %s\n", parser->getMessage().c_str());    
    return false;
  }

  printf("E:after checking\n");

  if(parser->getFrom() == user){
    printf("E:message from me ignoring\n");
    return false;
  }
 
  printf("E:getting who is the messag to\n"); 
  string forMe = parser->getTo();
  printf("E:forme = %s\n", forMe.c_str());

  printf("E:before looping through groups\n");
  // checking through all groups to see if message is for me
  int i;
  for(i = curConvList->size(); i > 1; i--) {
    printf("E:%s\n",curConvList->text(i));
    if(curConvList->text(i)[2] != '4' || 
       curConvList->text(i)[2] != '@') {
      printf("found user at index %i\n",i);
      break; 
    }
  }
  printf("after looping through groups\n");
 
  printf("before checking what type of message\n"); 
  // if message for me then check what type of message it was 
  if(i>0){
    string tmp = parser->getMessage();	// gets the statement 
    printf("E:tmp = %s\n", tmp.c_str());

    // switch statement to figure out what type of message it is    
    switch(tmp.at(0)) {
      
      // message "0toChat" for chatting
      case('0'):{
		//parser->getLine('\t');
		sprintf(buf, "%s",parser->getLine().c_str());
		printf("E:chat = %s\n", buf);

		sprintf(added,"@C4@b%s\n", buf);
	        Conversation->add(added);
		break;
      }
      
      // message "1toJoinGroup" to invite you to join a group chat		
      case('1'):{
		groupData newGroup;
		newGroup.groupName = parser->getString();
		newGroup.creatorName = parser->getFrom();
		
	        printf("E:asked to join group %s\n", newGroup.groupName.c_str());
	        
		if(fl_ask("You are asked to join group \"%s\".\nDo you accept?",
					newGroup.groupName.c_str())){
		  printf("E:\nYes\n");
		  
		  // code to add group to list
		  acceptInvite(newGroup);
		  
		} else { 
		  printf("E:\nNo\n");
		  declineInvite(newGroup);
		}
    		break;
      }
      
      // message "2toAcceptGroup" informing you that a user accepted your group invite
      case('2'):{
	        printf("E:User %s has accepted invitation to join group %s\n", 
		      parser->getFrom().c_str(), parser->getTo().c_str());
		break;
      }
      
      // message "3toRejectGroup"informing you that a user declined your group invite
      case('3'):{
		char message[SIZE];
		sprintf(message,"@C1@i@. %s has declined your invitation to join group %s\n",
				parser->getFrom().c_str(), parser->getTo().c_str());

		// post decline message to the conversation board that currently has focus
		Fl_Group* tmp = (Fl_Group*) curConvWin->value();
	        if(tmp) ((Fl_Browser*) tmp->child(0))->add(message);

		break;
      }
      
      // message "4toDropUser" informing you that you have been dropped from group
      case('4'):{  
	        fl_alert("This is a notice that you are being dropped from group \"%s\".", 
				parser->getTo().c_str());
		// add code that removes the group name from your lists
		break;
      }
 
      // message "5toDropSelf" informing you that member of one of your groups has dropped
      case('5'):{
		printf("E:User %s has dropped from group\n", parser->getFrom().c_str());
		// add code that removes that user from the groups
		break;
      }

      
      // message "disconnect" if someone disconnects		
      // message "6toLogOut" if someone disconnects
      case('d'):{  
		printf("E:disconnects\n");
  /*    	        string droppedUser = parser->getString();
		//int index = userIndex(droppedUser);
	        sprintf(buf,"@C1@i%s has left the building.\n",droppedUser.c_str());
		Conversation->add(buf);
  */
		break;
      }

      // else message was unrecognizable	
      default:	printf("E:Unrecognized message = %s\n", message.c_str()); return false; break;
    }

  } else printf("E:Not for me: message = %s\n", message.c_str()); return false;

  printf("E:after checking what type the message is\n");
    
  return true;
}

int chatDso::usersIndex(string name) {
  unsigned int i;
  for (i = 0; i < allUsers.size(); i++) {
    if(allUsers[i] == name){
      return i;
    }
  }

  return -1;
}

// connects to shared mem
bool chatDso::connectToClient() {
  
  char buf[SIZE];
  gethostname(buf, SIZE);
  myName = buf;
  sprintf(user,"%s",buf);
  printf("E:user = %s\n", user);
  
  client = (dclient*) app->check("dclient");
  if(!client) {
    printf("E:Could not get client\n");
    return false;    
  }

  printf("E:apparently connected\n");

  return true;    
}

// loads the list of logged in users into the gui
void chatDso::makeList() {
  printf("E:start makeList\n");

  if(!(dclient*) app->check("dclient")){
    printf("E:end makeList dclient check\n");
    return;
  }
  
  vector<duser*> newUsers;
  
  static unsigned int lastCount = 0;
  client = (dclient*) app->check("dclient");
  
  newUsers = client->getUsers();

/////
  if(newUsers.size() != lastCount) {
  //  remove(newUsers);
    printf("E:different size\n");
  
    // checks to see if there are new users to add to the list
    unsigned int i;
    int index;
  
    // clear current list
    curUserList->clear();
  
    // look throught a refreshed list of users and check
    // to see who has been added or dropped
    for (i = 0; i < newUsers.size(); i++) {
      
      index = usersIndex(newUsers[i]->getName()); 
      if(index < 0) {
	string userName = newUsers[i]->getName();

	allUsers.push_back(userName);
	char buf[SIZE];
	sprintf(buf,"@C1@i%s just joined our little party.\n", userName.c_str());
	Conversation->add(buf);
      }
    }

    printf("E:done with adding new people\n");

    removeOldUsers(newUsers);
//--------- not in this code --------------
/*
    // change to text to show who is connected or not 
    printf("E:redrawing list with user names\n");
    for (i = 0; i < allUsers.size(); i++) {
      char buf[SIZE];      
      sprintf(buf,"@C4@b@.%s\n", allUsers[i].c_str());
      //sprintf(buf,"@C2@b%s\n", allUsers[i].userName.c_str());
      curUserList->add(buf);
      curUserList->data(i+1,(void*)allUsers[i].c_str());
    }
----------------------------------------*/
    printf("E:ending testing\n");
  }
  
  lastCount = newUsers.size();
  printf("E:end makeList\n");
}

// checks the new list against the old list and 
// drops users who have disconnected
void chatDso::removeOldUsers(vector<duser*> newList) {
  for(unsigned int i = 0;i < allUsers.size();i++){
    printf("E:%s\n",newList[i]->getName().c_str());
    if(allUsers[i] != newList[i]->getName()){
      allUsers.erase(allUsers.begin() + i);
      i--;
    }
  }
  return;
}


/*********************************
 *	    Callbacks
 ********************************/

// sends the message out to the server to be sent to the appropriate group
static void sendMessage_callback(Fl_Widget*, Messenger* messenger) {
	
  if(Send->value() && strcmp(Send->value(),"") != 0) {
    
    char message[SIZE];
    sprintf(message,"%s: %s\n", user, Send->value());
    printf("E:send message = %s\n", message);      
    
    if(strlen(message) < SIZE){
      
      Fl_Group* tmp = (Fl_Group*) curConvWin->value();
      if(tmp){
	((Fl_Browser*) tmp->child(0))->add(message);
	((Fl_Browser*) tmp->child(0))->bottomline( ((Fl_Browser*) tmp->child(0))->size());
      }
      
      messenger->setTo(curConvWin->value()->label());
      messenger->setMessage("0toChat");
      messenger->addString(message);
      printf("E:send total message = %s\n", message);      
      messenger->SendMessage();

    } else {
      Fl_Group* tmp = (Fl_Group*) curConvWin->value();
      if(tmp)
	((Fl_Browser*) tmp->child(0))->add("@C1@b@iError: Message too big, try again.\n");
    }

    Send->value("");
  }
}

static void rightClick_callback(Fl_Menu_Button* mb, void*) {
  int userIndex = curUserList->value();
  int convIndex = curConvList->value();

  printf("E:curUserList = %i, curConvList = %i\n", userIndex, convIndex);
  
  if(convIndex > 0){
    groupData *tmp = (groupData*) curConvList->data(convIndex);
    if(tmp)
      printf ("E:curConvIndex = %i, data = %s\n", convIndex,tmp->groupName.c_str());
    else printf("E:NULL\n");
  }

  if(userIndex > 0)  
    printf("E:curUserIndex = %i, data = %s\n", userIndex, (char*) curUserList->data(userIndex));

//  curConvList->deselect();
//  curUserList->deselect();
}

/***********************************
 *	    Menu Callbacks
 **********************************/
void addConv_callback(Fl_Widget*, int i);
void addTocurConvWin(char*);

// add selected user to a new group chat
void addUserToNewGroup_callback(Fl_Widget*, void*) {
  int userIndex = curUserList->value();

  if(userIndex > 0) {
    char * convName = (char*) fl_input("Add %s to group:\n",
		    NULL,(char*)curUserList->data(userIndex));
    if(convName) {
      curConvList->add(convName);
      groupData* newGroup = new groupData;
      if(newGroup){
	newGroup->groupName = convName; 
	newGroup->creatorName = user;
	curConvList->data(curConvList->size(),(void*) newGroup);
	curConvList->value(curConvList->size());
//	addConv_callback(NULL,2);
	addTocurConvWin(convName);
	addUserToGroup_callback(NULL, NULL);
      }
      //curConvList->data(curConvList->size(),(void*)strdup(convName));
      
    } else printf("E:Canceled\n");

    convName = NULL;      
  } 
}

// adds user to a group conversation
void addUserToGroup_callback(Fl_Widget*, void*) {

  int userIndex = curUserList->value(),
      convIndex = curConvList->value();
  char name[SIZE],
       message[SIZE],
       *tmp = NULL;
 
  printf("E:convIndex = %i, userIndex = %i\n", convIndex, userIndex);
	       
  if(convIndex == 0) return;

  // adds selected buddy to an already selected group
  if(userIndex > 0 && convIndex > 0) {
    
    tmp = (char*) curUserList->data(userIndex);
    printf("E:addUserToGroup name = %s\n", tmp);
    sprintf(name,"@b@i@.\t%s",tmp);

    // add user to list
    curConvList->insert(convIndex+1,name);
    curConvList->data(convIndex+1, curUserList->data(userIndex));

    // change the font of group to show that it is a group
    sprintf(name,"@b@.%s", ((groupData*) curConvList->data(convIndex))->groupName.c_str());
    curConvList->text(convIndex, name);

    string newUser = tmp;
    curConvList->data(convIndex+1, (void*)&newUser);
    
    // print out who got added
    sprintf(message, "%s\n",((groupData*) curConvList->data(convIndex))->groupName.c_str());
    printf("E:join group message = %s\n", message);
    
    if(mess) {
      mess->setTo((char*)curUserList->data(userIndex));
      mess->setMessage("1toJoinGroup");
      mess->addString(message);
      mess->SendMessage();
    }

  // else ask for name of group to assign selected buddy to
  } else if(userIndex > 0){
    tmp = (char*) fl_input("Add %s to group:\n",NULL,curUserList->text(userIndex));
    if(tmp) {
      printf("tmp = %s\n", tmp);
      /*for (i = curConvList->children(); i > 0; i--) {
	if(strcmp(tmp, curConvList->text(i)) == 0){
	  sprintf(name,"@b@i.\t%s",tmp);
	  break;
	}
      }*/
    }
  }
  
  tmp = NULL;
}

// adds a new conversation to the curConversation list
void addConv_callback(Fl_Widget*, int i) {
  char *convName = new char[SIZE];
  
  char *tmp = NULL;
  int userIndex = curUserList->value();
  printf("E:index = %i\n",userIndex);
  
  if(i == 0 && userIndex > 0){
    tmp = (char*)curUserList->data(userIndex);
    printf("E:addConv_cb from userList tmp = %s\n", tmp);
    curUserList->select(0);
    curUserList->deselect();
    curUserList->value(0);
    
  } else if(i == 1){
    tmp = (char*) fl_input("Enter the name of the new chat session:  ");
    printf("E:addConv_cb from convList tmp = %s\n", tmp);
    
  } else {
    printf("E:addConv_cb from addUserToNewGroup\n"); 
    tmp = (char*)curUserList->data(userIndex);
  }
  
  if(tmp) {

    sprintf(convName, "@C4@b@i@.%s", tmp);
    curConvList->add(convName);
    int index = curConvList->size();
    
    groupData *newConv = new groupData;
    string me;
    me = newConv->creatorName = user;
    newConv->groupName = tmp;
//    newConv->members.push_back(me);
    
    curConvList->data(index, (void*)newConv);

    addTocurConvWin(tmp);
/*
    { Fl_Group *o = new Fl_Group(10, 25, 350, 190, strdup(tmp));
      o->box(FL_FLAT_BOX);
      o->labeltype(FL_ENGRAVED_LABEL);
      o->labelcolor(4);		  // blue font
      o->labelfont(2);		  // italic font
      if(colorFlag) o->color(44);
      colorFlag = !colorFlag;
      o->hide();
      { Fl_Browser* o = new Fl_Browser(15, 30, 340, 180);
        o->type(FL_MULTI_BROWSER);
        o->align(FL_ALIGN_TOP_LEFT);
      }
      o->end();
      curConvWin->add(o);
      curConvWin->redraw();
    }
*/    
  } else printf("E:Cancled\n");

  convName = NULL;
}

// remove all current conversations
void removeAllConv_callback(Fl_Widget*, void*) { 
	
  if(curConvList->children() > 1){ 
    curConvList->clear();
    for (int i = curConvWin->children(); i > 0; i--){	    
      curConvWin->remove(curConvWin->child(i));
    }
  
    curConvList->add("@bEveryone");
    curConvList->data(1,(void*)"everyone");
    curConvWin->redraw();
  }
}

// removes a selected conversation
void removeSelectedConv_callback(Fl_Widget*, void*) {
	
  for (int i = curConvList->size(); i > 1; i--)
    if(i > 0 && !curConvList->select(i)) {
      curConvList->remove(i);
      curConvWin->remove(curConvWin->child(i-1));
      curConvList->deselect();
    }

  curConvWin->redraw();
}


void dropUser_callback(Fl_Widget*, void*) {
  int index = curConvList->value();
  if(index>0){
    char buf[SIZE];
    sprintf(buf,"%s", (char*)curConvList->text(index));
    if(buf[2] == '4' || buf[2] == '@'){
      printf("E:Do you want to drop %s\n", buf);
/*    string *newData = (string*) curConvList->data(index+1);
      if(!newData) printf("E:NULL\n");
        for(int i = index; i >= 1; i++){
	sprintf(buf, "%s", (char*)curConvList->text(i));
	if(buf[2] != '4' && buf[2] != '@'){
	  mess->setTo(((groupData*)curConvList->data(index))->groupName);
	  mess->setMessage("4toDropUser");
	  mess->SendMessage();
	  i = -1;
	}
      }
*/
    }else
      printf("E:You can't drop the whole group\n");
  }
}


// when selecting a conversations from list it brings up that
// main chat window to the foreground
static void selectCurConv_callback (Fl_Multi_Browser* multiBrowser, void *) {
  int index = multiBrowser->value();
  if(index > 0)
    curConvWin->value(curConvWin->child(index-1));
}

// hides the window
static void hide_callback(Fl_Button *, Fl_Window* guiWin) { guiWin->iconize(); }

// creates the chat gui
void chatDso::make_window(){//chatDso* data) {

  { Fl_Window* o = new Fl_Window(520, 355, myName.c_str());
    guiWin = o;
    { Fl_Tabs * o = curConvWin = new Fl_Tabs(10, 5, 350, 190);
      { Fl_Group *o = new Fl_Group(10, 25, 350, 190,"everyone");
	o->box(FL_FLAT_BOX);
	o->labeltype(FL_ENGRAVED_LABEL);
	o->color(44);
	o->hide();
	{ Fl_Browser* o = Conversation = 
    	    new Fl_Browser(15, 30, 340, 180);
	  o->type(FL_MULTI_BROWSER);
	  o->align(FL_ALIGN_TOP_LEFT);
	}
	o->end();
      }
      o->end();
    }
    { Fl_Input* o = Send = new Fl_Input(10, 235, 350, 85, "Send Message:");
      o->type(4);
      o->labeltype(FL_ENGRAVED_LABEL);
      o->align(FL_ALIGN_TOP_LEFT);
      o->maximum_size(SIZE);
      o->callback((Fl_Callback*)sendMessage_callback,(void*)messenger);
      o->when(FL_WHEN_ENTER_KEY);
    }
    { Fl_Multi_Browser *o = curUserList = 
	    new Fl_Multi_Browser(365, 25, 145, 90,"Who is Logged In:");	// 365, 25, 145, 190
      o->labeltype(FL_ENGRAVED_LABEL);
      o->align(FL_ALIGN_TOP_LEFT);
    } 
    { Fl_Multi_Browser *o = curConvList = 
	    new Fl_Multi_Browser(365, 135, 145, 185, "Talking To:"); // 365,235, 145, 85
      o->labeltype(FL_ENGRAVED_LABEL);
      o->align(FL_ALIGN_TOP_LEFT);
      o->add("@beveryone");
      //o->data(1,(void*)"everyone");
      o->callback((Fl_Callback*)selectCurConv_callback);
    }
    { Fl_Button* o = new Fl_Button(320, 325, 90, 25, "Send"); 
      o->labeltype(FL_ENGRAVED_LABEL);
      o->callback((Fl_Callback*)sendMessage_callback, (void*)messenger);
    }
    { Fl_Button* o = new Fl_Button(420, 325, 90, 25, "Hide");
      o->labeltype(FL_ENGRAVED_LABEL);
      o->callback((Fl_Callback *)hide_callback,(void*)guiWin);
    }
    
    /* right click menus */
    
    // for the users logged in
    { Fl_Menu_Button *o = new Fl_Menu_Button(365, 135, 145, 185);    // 365, 235, 145, 85
      o->type(Fl_Menu_Button::POPUP3);
      o->menu(curConvRightClick);
      o->callback((Fl_Callback*)rightClick_callback);
    }
    // for the current conversations
    { Fl_Menu_Button *o = new Fl_Menu_Button(365, 25, 145, 90);    // 365, 25, 145, 190
      o->type(Fl_Menu_Button::POPUP3);
      o->menu(curUserRightClick);
      o->callback((Fl_Callback*)rightClick_callback);
    }
    o->end();
  }
  guiWin->show();
}

/*******************************************
 *	      Helper Functions
 ******************************************/

void acceptInvite (groupData acceptedGroup){
  printf("E:acceptInvite\n");
  mess->setTo(acceptedGroup.groupName.c_str());
  mess->setMessage("2toAcceptGroup"); 
  mess->SendMessage();  
}

void declineInvite (groupData declineGroup) {
  printf("E:decline\n");
  mess->setTo(declineGroup.creatorName.c_str());
  mess->setMessage("3toRejectGroup");
  mess->SendMessage();
}

void addTocurConvWin(char* tmp) {

  static bool colorFlag = false;

  { Fl_Group *o = new Fl_Group(10, 25, 350, 190, strdup(tmp));
    o->box(FL_FLAT_BOX);
    o->labeltype(FL_ENGRAVED_LABEL);
    o->labelcolor(4);		  // blue font
    o->labelfont(2);		  // italic font
    if(colorFlag) o->color(44);
    colorFlag = !colorFlag;
    o->hide();
    { Fl_Browser* o = new Fl_Browser(15, 30, 340, 180);
      o->type(FL_MULTI_BROWSER);
      o->align(FL_ALIGN_TOP_LEFT);
    }
    o->end();
    curConvWin->add(o);
    curConvWin->redraw();
  }
}

/*************** DTK C++ DSO loader/unloader functions ***********/
/*
 * All DTK DSO files are required to declare these two functions.
 * These function are called by the loading program to get your
 * C++ objects loaded.
 *
 *****************************************************************/

static dtkAugment *dtkDSO_loader(dtkManager *manager, void *p)
{
  dpf *app = static_cast<dpf *>(manager);
  return new chatDso(app);
}

static int dtkDSO_unloader(dtkAugment *augment)
{
  delete augment;
  return DTKDSO_UNLOAD_CONTINUE;
}

