// This is the client to connect to the dedicated server

#ifndef DCLIENT_H
#define DCLIENT_H

#include <dpf.h>
#include <string>
#include <vector>
#include "duser.h"

const int SHM_SIZE = 1024*sizeof(char);

using namespace std;

class dclient : public dtkAugment
{
  public:
    dclient(dpf *app);
    ~dclient(void);

    int postConfig(void);
    int postFrame(void);

    vector<duser*> getUsers();

  private:

    dpf* app;
    dtkSharedMem* genMessage;
    dtkSharedMem* positionShm;
    dtkClient* ClientManager;
    char* host;
    dtkTime Timer;
    long double lastTime;

    vector<duser*> users;
    string compName;

    int CheckMessages();
    int SearchUsers(string user);
    int writeMessage(string Message);
    string getTime();
    int addNewUser(string newguy,string avatar);
    int disconnect(string user);
    
    pfCoord coord;

};

#endif
