//Chat display HUD


#define angle(X)    ((((int)X+180)%360)-180)

#define ROWS (1)
#define COLS (1)
//#define START (ROWS-26)

#include <dpf.h>
#include <time.h>
#include <dtk/dtkDSO_loader.h>
#include <string>

using namespace std;

class display:public dpfHeadsUpText
{
public:
  display (dpf * app);
  ~display (void);
  int preConfig (void);
  int postConfig (void);
  int postFrame (void);

private:
  dpf* app;
  int row;
  dtkTime t;
};

display::display (dpf * app_in):dpfHeadsUpText (app_in, "display")
{
  app = app_in;
  setDescription ("laser counter HUD");
  row = 4;
  validate();
}

display::~display (void)
{

}

int display::preConfig (void)
{
  dpfDisplay *d = app->display();
  if(d == NULL){
    cout<<" d == NULL"<<endl;
    return DTK_CALLBACK_ERROR ;
  }
  cout<<"1"<<endl;
  dpfPipe *p ;
  dpfPwin *w ;
  dpfScreen *s ;
  for (p=d->first(); p; p=p->next()) {
    for (w=p->first(); w; w=w->next()) {
      for (s=w->first(); s; s=s->next()) {
      	s->addHeadsUp(this) ;
      }
    }
  }
  
  if (init(50, 50)) {
     dtkMsg.add(DTKMSG_ERROR,
	       "dynamicHeadsUpText::preConfig(): unable to init text\n") ;
    return DTK_CALLBACK_ERROR ;
  }
  // put stuff here that doesn't change

  visible(1) ;
  screenVis(0) ;

  return DTK_REMOVE_CALLBACK ;
}

int display::postConfig (void)
{
  return DTK_CONTINUE;
}

int display::postFrame (void)
{
  int trow = row+20;

  time_t tic ;
  time(&tic) ;

  sprintf(text(trow,1),"Now:         %s", ctime(&tic)) ; trow-- ;
  sprintf(text(trow,1),"Running:     %-5.0f", (float) t.get()) ; trow-- ;
  sprintf(text(trow,1),"Frame rate:  %-2.0f", pfGetFrameRate()) ; trow-- ;
  sprintf(text(trow,1),"Frame count: %d", pfGetFrameCount()) ; trow-- ;

  flush() ;

  return DTK_CONTINUE;
}

/*************** DTK C++ DSO loader/unloader functions ***********/
/*
 * All DTK DSO files are required to declare these two functions.
 * These function are called by the loading program to get your
 * C++ objects loaded.
 *
 *****************************************************************/

static dtkAugment *
dtkDSO_loader (dtkManager * manager, void *p)
{
  dpf *app = static_cast < dpf * >(manager);
  return new display (app);
}

static int
dtkDSO_unloader (dtkAugment * augment)
{
  delete augment;
  return DTKDSO_UNLOAD_CONTINUE;
}
